/* Solver.c generated by valac 0.54.6, the Vala compiler
 * generated from Solver.vala, do not modify */

/* Solver class for gnonograms
 * Finds solution for a set of clues.
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */
/** PRIVATE **/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>

#define GNONOGRAMS_SOLVER_MODERATE_CPP ((gdouble) 5.0f)
#define GNONOGRAMS_SOLVER_HARD_CPP ((gdouble) 3.0f)
#define GNONOGRAMS_SOLVER_CHALLENGING_CPP ((gdouble) 1.5f)
#define GNONOGRAMS_ABSTRACT_SOLVER_MAX_PASSES ((guint) 200)
#define GNONOGRAMS_SOLVER_GUESSER_MAX_GUESSES ((guint) 9999)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GNONOGRAMS_TYPE_ABSTRACT_SOLVER (gnonograms_abstract_solver_get_type ())
#define GNONOGRAMS_ABSTRACT_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolver))
#define GNONOGRAMS_ABSTRACT_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolverClass))
#define GNONOGRAMS_IS_ABSTRACT_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_ABSTRACT_SOLVER))
#define GNONOGRAMS_IS_ABSTRACT_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_ABSTRACT_SOLVER))
#define GNONOGRAMS_ABSTRACT_SOLVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_ABSTRACT_SOLVER, GnonogramsAbstractSolverClass))

typedef struct _GnonogramsAbstractSolver GnonogramsAbstractSolver;
typedef struct _GnonogramsAbstractSolverClass GnonogramsAbstractSolverClass;
typedef struct _GnonogramsAbstractSolverPrivate GnonogramsAbstractSolverPrivate;

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;

#define GNONOGRAMS_TYPE_REGION (gnonograms_region_get_type ())
#define GNONOGRAMS_REGION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_REGION, GnonogramsRegion))
#define GNONOGRAMS_REGION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_REGION, GnonogramsRegionClass))
#define GNONOGRAMS_IS_REGION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_REGION))
#define GNONOGRAMS_IS_REGION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_REGION))
#define GNONOGRAMS_REGION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_REGION, GnonogramsRegionClass))

typedef struct _GnonogramsRegion GnonogramsRegion;
typedef struct _GnonogramsRegionClass GnonogramsRegionClass;

#define GNONOGRAMS_TYPE_MOVE (gnonograms_move_get_type ())
#define GNONOGRAMS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMove))
#define GNONOGRAMS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))
#define GNONOGRAMS_IS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_IS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))

typedef struct _GnonogramsMove GnonogramsMove;
typedef struct _GnonogramsMoveClass GnonogramsMoveClass;
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;

#define GNONOGRAMS_TYPE_SOLVER (gnonograms_solver_get_type ())
#define GNONOGRAMS_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolver))
#define GNONOGRAMS_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolverClass))
#define GNONOGRAMS_IS_SOLVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_SOLVER))
#define GNONOGRAMS_IS_SOLVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_SOLVER))
#define GNONOGRAMS_SOLVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_SOLVER, GnonogramsSolverClass))

typedef struct _GnonogramsSolver GnonogramsSolver;
typedef struct _GnonogramsSolverClass GnonogramsSolverClass;
typedef struct _GnonogramsSolverPrivate GnonogramsSolverPrivate;
enum  {
	GNONOGRAMS_SOLVER_0_PROPERTY,
	GNONOGRAMS_SOLVER_NUM_PROPERTIES
};
static GParamSpec* gnonograms_solver_properties[GNONOGRAMS_SOLVER_NUM_PROPERTIES];
typedef enum  {
	GNONOGRAMS_SOLVER_STATE_ERROR = 0,
	GNONOGRAMS_SOLVER_STATE_CANCELLED = 1,
	GNONOGRAMS_SOLVER_STATE_NO_SOLUTION = 1 << 1,
	GNONOGRAMS_SOLVER_STATE_SIMPLE = 1 << 2,
	GNONOGRAMS_SOLVER_STATE_ADVANCED = 1 << 3,
	GNONOGRAMS_SOLVER_STATE_AMBIGUOUS = 1 << 4,
	GNONOGRAMS_SOLVER_STATE_UNDEFINED = 1 << 5
} GnonogramsSolverState;

#define GNONOGRAMS_TYPE_SOLVER_STATE (gnonograms_solver_state_get_type ())
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
#define _gnonograms_move_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_move_unref (var), NULL)))
#define _gnonograms_region_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_region_unref (var), NULL)))

#define GNONOGRAMS_SOLVER_TYPE_GUESSER (gnonograms_solver_guesser_get_type ())
#define GNONOGRAMS_SOLVER_GUESSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_SOLVER_TYPE_GUESSER, GnonogramsSolverGuesser))
#define GNONOGRAMS_SOLVER_GUESSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_SOLVER_TYPE_GUESSER, GnonogramsSolverGuesserClass))
#define GNONOGRAMS_SOLVER_IS_GUESSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_SOLVER_TYPE_GUESSER))
#define GNONOGRAMS_SOLVER_IS_GUESSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_SOLVER_TYPE_GUESSER))
#define GNONOGRAMS_SOLVER_GUESSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_SOLVER_TYPE_GUESSER, GnonogramsSolverGuesserClass))

typedef struct _GnonogramsSolverGuesser GnonogramsSolverGuesser;
typedef struct _GnonogramsSolverGuesserClass GnonogramsSolverGuesserClass;
#define _gnonograms_solver_guesser_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_solver_guesser_unref (var), NULL)))
typedef struct _GnonogramsSolverGuesserPrivate GnonogramsSolverGuesserPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GnonogramsSolverParamSpecGuesser GnonogramsSolverParamSpecGuesser;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsAbstractSolver {
	GObject parent_instance;
	GnonogramsAbstractSolverPrivate * priv;
	GnonogramsRegion** regions;
	gint regions_length1;
	gboolean should_check_solution;
	GnonogramsDimensions _dimensions;
};

struct _GnonogramsAbstractSolverClass {
	GObjectClass parent_class;
	gboolean (*initialize) (GnonogramsAbstractSolver* self, gchar** row_clues, gint row_clues_length1, gchar** col_clues, gint col_clues_length1, GnonogramsMy2DCellArray* start_grid, GnonogramsMy2DCellArray* solution_grid);
	void (*reinitialize_regions) (GnonogramsAbstractSolver* self);
	gboolean (*valid) (GnonogramsAbstractSolver* self);
	gboolean (*solved) (GnonogramsAbstractSolver* self);
	gboolean (*differs_from_solution) (GnonogramsAbstractSolver* self, GnonogramsRegion* r);
	GeeArrayQueue* (*hint) (GnonogramsAbstractSolver* self, gchar** row_clues, gint row_clues_length1, gchar** col_clues, gint col_clues_length1, GnonogramsMy2DCellArray* working);
	GeeArrayQueue* (*debug) (GnonogramsAbstractSolver* self, guint idx, gboolean is_column, gchar** row_clues, gint row_clues_length1, gchar** col_clues, gint col_clues_length1, GnonogramsMy2DCellArray* working);
	GnonogramsDifficulty (*solve_it) (GnonogramsAbstractSolver* self);
	void (*configure_from_grade) (GnonogramsAbstractSolver* self, GnonogramsDifficulty grade);
};

struct _GnonogramsSolver {
	GnonogramsAbstractSolver parent_instance;
	GnonogramsSolverPrivate * priv;
};

struct _GnonogramsSolverClass {
	GnonogramsAbstractSolverClass parent_class;
};

struct _GnonogramsSolverPrivate {
	guint moderate_threshold;
	guint hard_threshold;
	guint challenging_threshold;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _GnonogramsSolverGuesser {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsSolverGuesserPrivate * priv;
};

struct _GnonogramsSolverGuesserClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsSolverGuesser *self);
};

struct _GnonogramsSolverGuesserPrivate {
	GnonogramsCell trial_cell;
	gint rdir;
	gint cdir;
	gint rlim;
	gint clim;
	gint turn;
	guint max_turns;
	guint initial_max_turns;
	GnonogramsCellState initial_cell_state;
	gboolean human_only;
	GnonogramsCellState* gs;
	gint gs_length1;
	gint _gs_size_;
	GnonogramsMy2DCellArray* _grid;
};

struct _GnonogramsSolverParamSpecGuesser {
	GParamSpec parent_instance;
};

static gint GnonogramsSolver_private_offset;
static gpointer gnonograms_solver_parent_class = NULL;
static gint GnonogramsSolverGuesser_private_offset;
static gpointer gnonograms_solver_guesser_parent_class = NULL;

VALA_EXTERN GType gnonograms_abstract_solver_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsAbstractSolver, g_object_unref)
VALA_EXTERN GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
VALA_EXTERN gpointer gnonograms_region_ref (gpointer instance);
VALA_EXTERN void gnonograms_region_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_region (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_region (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void gnonograms_value_take_region (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_region (const GValue* value);
VALA_EXTERN GType gnonograms_region_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsRegion, gnonograms_region_unref)
VALA_EXTERN gpointer gnonograms_move_ref (gpointer instance);
VALA_EXTERN void gnonograms_move_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_move (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_move (GValue* value,
                                gpointer v_object);
VALA_EXTERN void gnonograms_value_take_move (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_move (const GValue* value);
VALA_EXTERN GType gnonograms_move_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMove, gnonograms_move_unref)
VALA_EXTERN GType gnonograms_difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_dimensions_free (GnonogramsDimensions* self);
VALA_EXTERN GType gnonograms_solver_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsSolver, g_object_unref)
VALA_EXTERN void gnonograms_abstract_solver_configure_from_grade (GnonogramsAbstractSolver* self,
                                                      GnonogramsDifficulty grade);
VALA_EXTERN GnonogramsDifficulty gnonograms_abstract_solver_solve_it (GnonogramsAbstractSolver* self);
VALA_EXTERN GeeArrayQueue* gnonograms_abstract_solver_debug (GnonogramsAbstractSolver* self,
                                                 guint idx,
                                                 gboolean is_column,
                                                 gchar** row_clues,
                                                 gint row_clues_length1,
                                                 gchar** col_clues,
                                                 gint col_clues_length1,
                                                 GnonogramsMy2DCellArray* working);
VALA_EXTERN GeeArrayQueue* gnonograms_abstract_solver_hint (GnonogramsAbstractSolver* self,
                                                gchar** row_clues,
                                                gint row_clues_length1,
                                                gchar** col_clues,
                                                gint col_clues_length1,
                                                GnonogramsMy2DCellArray* working);
VALA_EXTERN GnonogramsSolver* gnonograms_solver_new (GnonogramsDimensions* _dimensions);
VALA_EXTERN GnonogramsSolver* gnonograms_solver_construct (GType object_type,
                                               GnonogramsDimensions* _dimensions);
VALA_EXTERN void gnonograms_abstract_solver_get_dimensions (GnonogramsAbstractSolver* self,
                                                GnonogramsDimensions * result);
VALA_EXTERN guint gnonograms_dimensions_length (GnonogramsDimensions *self);
static void gnonograms_solver_real_configure_from_grade (GnonogramsAbstractSolver* base,
                                                  GnonogramsDifficulty grade);
VALA_EXTERN void gnonograms_abstract_solver_set_use_advanced (GnonogramsAbstractSolver* self,
                                                  gboolean value);
VALA_EXTERN void gnonograms_abstract_solver_set_unique_only (GnonogramsAbstractSolver* self,
                                                 gboolean value);
VALA_EXTERN void gnonograms_abstract_solver_set_advanced_only (GnonogramsAbstractSolver* self,
                                                   gboolean value);
VALA_EXTERN void gnonograms_abstract_solver_set_human_only (GnonogramsAbstractSolver* self,
                                                gboolean value);
static GnonogramsDifficulty gnonograms_solver_real_solve_it (GnonogramsAbstractSolver* base);
VALA_EXTERN guint gnonograms_abstract_solver_get_n_regions (GnonogramsAbstractSolver* self);
VALA_EXTERN void gnonograms_region_set_to_initial_state (GnonogramsRegion* self);
static gint gnonograms_solver_simple_solver (GnonogramsSolver* self);
VALA_EXTERN GType gnonograms_solver_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsSolverState gnonograms_abstract_solver_get_state (GnonogramsAbstractSolver* self);
VALA_EXTERN gboolean gnonograms_abstract_solver_get_advanced_only (GnonogramsAbstractSolver* self);
VALA_EXTERN gboolean gnonograms_abstract_solver_get_use_advanced (GnonogramsAbstractSolver* self);
static gint gnonograms_solver_advanced_solver (GnonogramsSolver* self);
static GnonogramsDifficulty gnonograms_solver_passes_to_grade (GnonogramsSolver* self,
                                                        guint passes);
static GeeArrayQueue* gnonograms_solver_real_debug (GnonogramsAbstractSolver* base,
                                             guint idx,
                                             gboolean is_column,
                                             gchar** row_clues,
                                             gint row_clues_length1,
                                             gchar** col_clues,
                                             gint col_clues_length1,
                                             GnonogramsMy2DCellArray* working);
VALA_EXTERN gboolean gnonograms_abstract_solver_initialize (GnonogramsAbstractSolver* self,
                                                gchar** row_clues,
                                                gint row_clues_length1,
                                                gchar** col_clues,
                                                gint col_clues_length1,
                                                GnonogramsMy2DCellArray* start_grid,
                                                GnonogramsMy2DCellArray* solution_grid);
VALA_EXTERN guint gnonograms_abstract_solver_get_rows (GnonogramsAbstractSolver* self);
VALA_EXTERN gboolean gnonograms_region_debug (GnonogramsRegion* self);
VALA_EXTERN gboolean gnonograms_region_get_in_error (GnonogramsRegion* self);
VALA_EXTERN void gnonograms_abstract_solver_set_state (GnonogramsAbstractSolver* self,
                                           GnonogramsSolverState value);
VALA_EXTERN gboolean gnonograms_region_get_is_column (GnonogramsRegion* self);
VALA_EXTERN guint gnonograms_abstract_solver_get_cols (GnonogramsAbstractSolver* self);
VALA_EXTERN GType gnonograms_cell_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gnonograms_my2_dcell_array_get_array (GnonogramsMy2DCellArray* self,
                                           guint idx,
                                           gboolean iscolumn,
                                           GnonogramsCellState** sa,
                                           gint* sa_length1,
                                           guint start);
VALA_EXTERN guint gnonograms_region_get_index (GnonogramsRegion* self);
VALA_EXTERN GnonogramsCellState gnonograms_region_get_cell_state (GnonogramsRegion* self,
                                                      guint index);
VALA_EXTERN GType gnonograms_cell_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
VALA_EXTERN void gnonograms_cell_free (GnonogramsCell* self);
VALA_EXTERN GnonogramsMove* gnonograms_move_new (GnonogramsCell* cell,
                                     GnonogramsCellState previous_state);
VALA_EXTERN GnonogramsMove* gnonograms_move_construct (GType object_type,
                                           GnonogramsCell* cell,
                                           GnonogramsCellState previous_state);
static GeeArrayQueue* gnonograms_solver_real_hint (GnonogramsAbstractSolver* base,
                                            gchar** row_clues,
                                            gint row_clues_length1,
                                            gchar** col_clues,
                                            gint col_clues_length1,
                                            GnonogramsMy2DCellArray* working);
VALA_EXTERN void gnonograms_my2_dcell_array_get_dimensions (GnonogramsMy2DCellArray* self,
                                                GnonogramsDimensions * result);
VALA_EXTERN gboolean gnonograms_dimensions_equal (GnonogramsDimensions *self,
                                      GnonogramsDimensions* other);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_abstract_solver_get_grid (GnonogramsAbstractSolver* self);
VALA_EXTERN guint gnonograms_dimensions_rows (GnonogramsDimensions *self);
VALA_EXTERN guint gnonograms_dimensions_cols (GnonogramsDimensions *self);
VALA_EXTERN gboolean gnonograms_region_get_is_completed (GnonogramsRegion* self);
VALA_EXTERN gboolean gnonograms_region_solve (GnonogramsRegion* self);
VALA_EXTERN void gnonograms_abstract_solver_reinitialize_regions (GnonogramsAbstractSolver* self);
VALA_EXTERN GCancellable* gnonograms_abstract_solver_get_cancellable (GnonogramsAbstractSolver* self);
VALA_EXTERN GnonogramsMy2DCellArray* gnonograms_abstract_solver_get_solution (GnonogramsAbstractSolver* self);
VALA_EXTERN void gnonograms_my2_dcell_array_copy (GnonogramsMy2DCellArray* self,
                                      GnonogramsMy2DCellArray* ca);
VALA_EXTERN gboolean gnonograms_abstract_solver_solved (GnonogramsAbstractSolver* self);
VALA_EXTERN gboolean gnonograms_abstract_solver_get_human_only (GnonogramsAbstractSolver* self);
static gpointer gnonograms_solver_guesser_ref (gpointer instance);
static void gnonograms_solver_guesser_unref (gpointer instance);
static GParamSpec* gnonograms_solver_param_spec_guesser (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags) G_GNUC_UNUSED ;
static void gnonograms_solver_value_set_guesser (GValue* value,
                                          gpointer v_object) G_GNUC_UNUSED ;
static void gnonograms_solver_value_take_guesser (GValue* value,
                                           gpointer v_object) G_GNUC_UNUSED ;
static gpointer gnonograms_solver_value_get_guesser (const GValue* value) G_GNUC_UNUSED ;
static GType gnonograms_solver_guesser_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsSolverGuesser, gnonograms_solver_guesser_unref)
static GnonogramsSolverGuesser* gnonograms_solver_guesser_new (GnonogramsMy2DCellArray* _grid,
                                                        gboolean _human_only);
static GnonogramsSolverGuesser* gnonograms_solver_guesser_construct (GType object_type,
                                                              GnonogramsMy2DCellArray* _grid,
                                                              gboolean _human_only);
static gboolean gnonograms_solver_guesser_next_guess (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_cancel_previous_guess (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_invert_previous_guess (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_initialize (GnonogramsSolverGuesser* self);
VALA_EXTERN gboolean gnonograms_abstract_solver_get_unique_only (GnonogramsAbstractSolver* self);
static void gnonograms_solver_guesser_set_grid (GnonogramsSolverGuesser* self,
                                         GnonogramsMy2DCellArray* value);
static guint gnonograms_solver_guesser_get_rows (GnonogramsSolverGuesser* self);
static guint gnonograms_solver_guesser_get_cols (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_save_position (GnonogramsSolverGuesser* self);
static gboolean gnonograms_solver_guesser_make_guess (GnonogramsSolverGuesser* self);
static void gnonograms_solver_guesser_load_position (GnonogramsSolverGuesser* self);
VALA_EXTERN void gnonograms_cell_inverse (GnonogramsCell *self,
                              GnonogramsCell* result);
static GnonogramsMy2DCellArray* gnonograms_solver_guesser_get_grid (GnonogramsSolverGuesser* self);
VALA_EXTERN void gnonograms_my2_dcell_array_set_data_from_cell (GnonogramsMy2DCellArray* self,
                                                    GnonogramsCell* c);
VALA_EXTERN void gnonograms_my2_dcell_array_set_data_from_rc (GnonogramsMy2DCellArray* self,
                                                  guint r,
                                                  guint c,
                                                  GnonogramsCellState s);
VALA_EXTERN GnonogramsCellState gnonograms_my2_dcell_array_get_data_from_rc (GnonogramsMy2DCellArray* self,
                                                                 guint r,
                                                                 guint c);
VALA_EXTERN guint gnonograms_my2_dcell_array_get_area (GnonogramsMy2DCellArray* self);
VALA_EXTERN guint gnonograms_my2_dcell_array_get_rows (GnonogramsMy2DCellArray* self);
VALA_EXTERN guint gnonograms_my2_dcell_array_get_cols (GnonogramsMy2DCellArray* self);
static void gnonograms_solver_guesser_finalize (GnonogramsSolverGuesser * obj);
static GType gnonograms_solver_guesser_get_type_once (void);
static void gnonograms_solver_finalize (GObject * obj);
static GType gnonograms_solver_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
gnonograms_solver_get_instance_private (GnonogramsSolver* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsSolver_private_offset);
}

GnonogramsSolver*
gnonograms_solver_construct (GType object_type,
                             GnonogramsDimensions* _dimensions)
{
	GnonogramsSolver * self = NULL;
	GnonogramsDimensions _tmp0_;
	gdouble length = 0.0;
	GnonogramsDimensions _tmp1_ = {0};
	GnonogramsDimensions _tmp2_;
	g_return_val_if_fail (_dimensions != NULL, NULL);
	_tmp0_ = *_dimensions;
	self = (GnonogramsSolver*) g_object_new (object_type, "dimensions", &_tmp0_, NULL);
	gnonograms_abstract_solver_get_dimensions ((GnonogramsAbstractSolver*) self, &_tmp1_);
	_tmp2_ = _tmp1_;
	length = (gdouble) gnonograms_dimensions_length (&_tmp2_);
	self->priv->moderate_threshold = (guint) ((length / GNONOGRAMS_SOLVER_MODERATE_CPP) + 0.5);
	self->priv->hard_threshold = (guint) ((length / GNONOGRAMS_SOLVER_HARD_CPP) + 0.5);
	self->priv->challenging_threshold = (guint) ((length / GNONOGRAMS_SOLVER_CHALLENGING_CPP) - 0.5);
	return self;
}

GnonogramsSolver*
gnonograms_solver_new (GnonogramsDimensions* _dimensions)
{
	return gnonograms_solver_construct (GNONOGRAMS_TYPE_SOLVER, _dimensions);
}

static void
gnonograms_solver_real_configure_from_grade (GnonogramsAbstractSolver* base,
                                             GnonogramsDifficulty grade)
{
	GnonogramsSolver * self;
	self = (GnonogramsSolver*) base;
	gnonograms_abstract_solver_set_use_advanced ((GnonogramsAbstractSolver*) self, FALSE);
	gnonograms_abstract_solver_set_unique_only ((GnonogramsAbstractSolver*) self, TRUE);
	gnonograms_abstract_solver_set_advanced_only ((GnonogramsAbstractSolver*) self, FALSE);
	gnonograms_abstract_solver_set_human_only ((GnonogramsAbstractSolver*) self, TRUE);
	switch (grade) {
		case GNONOGRAMS_DIFFICULTY_EASY:
		case GNONOGRAMS_DIFFICULTY_MODERATE:
		case GNONOGRAMS_DIFFICULTY_HARD:
		case GNONOGRAMS_DIFFICULTY_CHALLENGING:
		{
			break;
		}
		case GNONOGRAMS_DIFFICULTY_ADVANCED:
		{
			gnonograms_abstract_solver_set_use_advanced ((GnonogramsAbstractSolver*) self, TRUE);
			gnonograms_abstract_solver_set_advanced_only ((GnonogramsAbstractSolver*) self, TRUE);
			break;
		}
		case GNONOGRAMS_DIFFICULTY_MAXIMUM:
		{
			gnonograms_abstract_solver_set_use_advanced ((GnonogramsAbstractSolver*) self, TRUE);
			gnonograms_abstract_solver_set_unique_only ((GnonogramsAbstractSolver*) self, FALSE);
			gnonograms_abstract_solver_set_advanced_only ((GnonogramsAbstractSolver*) self, TRUE);
			break;
		}
		case GNONOGRAMS_DIFFICULTY_COMPUTER:
		{
			gnonograms_abstract_solver_set_use_advanced ((GnonogramsAbstractSolver*) self, TRUE);
			gnonograms_abstract_solver_set_unique_only ((GnonogramsAbstractSolver*) self, FALSE);
			gnonograms_abstract_solver_set_advanced_only ((GnonogramsAbstractSolver*) self, FALSE);
			gnonograms_abstract_solver_set_human_only ((GnonogramsAbstractSolver*) self, FALSE);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GnonogramsDifficulty
gnonograms_solver_real_solve_it (GnonogramsAbstractSolver* base)
{
	GnonogramsSolver * self;
	gint _result_ = 0;
	gboolean _tmp6_ = FALSE;
	GnonogramsSolverState _tmp7_;
	GnonogramsSolverState _tmp8_;
	GnonogramsDifficulty result = 0;
	self = (GnonogramsSolver*) base;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				GnonogramsRegion** _tmp4_;
				gint _tmp4__length1;
				GnonogramsRegion* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_abstract_solver_get_n_regions ((GnonogramsAbstractSolver*) self);
				_tmp3_ = _tmp2_;
				if (!(((guint) i) < _tmp3_)) {
					break;
				}
				_tmp4_ = ((GnonogramsAbstractSolver*) self)->regions;
				_tmp4__length1 = ((GnonogramsAbstractSolver*) self)->regions_length1;
				_tmp5_ = _tmp4_[i];
				gnonograms_region_set_to_initial_state (_tmp5_);
			}
		}
	}
	_result_ = gnonograms_solver_simple_solver (self);
	_tmp7_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
	_tmp8_ = _tmp7_;
	if (_tmp8_ == GNONOGRAMS_SOLVER_STATE_SIMPLE) {
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp9_ = gnonograms_abstract_solver_get_advanced_only ((GnonogramsAbstractSolver*) self);
		_tmp10_ = _tmp9_;
		_tmp6_ = _tmp10_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		_result_ = 0;
	} else {
		gboolean _tmp11_ = FALSE;
		GnonogramsSolverState _tmp12_;
		GnonogramsSolverState _tmp13_;
		_tmp12_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
		_tmp13_ = _tmp12_;
		if (_tmp13_ != GNONOGRAMS_SOLVER_STATE_SIMPLE) {
			gboolean _tmp14_;
			gboolean _tmp15_;
			_tmp14_ = gnonograms_abstract_solver_get_use_advanced ((GnonogramsAbstractSolver*) self);
			_tmp15_ = _tmp14_;
			_tmp11_ = _tmp15_;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			_result_ = gnonograms_solver_advanced_solver (self);
		}
	}
	result = gnonograms_solver_passes_to_grade (self, (guint) _result_);
	return result;
}

static gpointer
_gnonograms_region_ref0 (gpointer self)
{
	return self ? gnonograms_region_ref (self) : NULL;
}

static GeeArrayQueue*
gnonograms_solver_real_debug (GnonogramsAbstractSolver* base,
                              guint idx,
                              gboolean is_column,
                              gchar** row_clues,
                              gint row_clues_length1,
                              gchar** col_clues,
                              gint col_clues_length1,
                              GnonogramsMy2DCellArray* working)
{
	GnonogramsSolver * self;
	GeeArrayQueue* moves = NULL;
	GeeArrayQueue* _tmp0_;
	guint _tmp1_ = 0U;
	GnonogramsRegion* r = NULL;
	GnonogramsRegion** _tmp4_;
	gint _tmp4__length1;
	GnonogramsRegion* _tmp5_;
	GnonogramsRegion* _tmp6_;
	gboolean changed = FALSE;
	GnonogramsRegion* _tmp7_;
	GnonogramsRegion* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GeeArrayQueue* result = NULL;
	self = (GnonogramsSolver*) base;
	g_return_val_if_fail (working != NULL, NULL);
	_tmp0_ = gee_array_queue_new (GNONOGRAMS_TYPE_MOVE, (GBoxedCopyFunc) gnonograms_move_ref, (GDestroyNotify) gnonograms_move_unref, NULL, NULL, NULL);
	moves = _tmp0_;
	gnonograms_abstract_solver_initialize ((GnonogramsAbstractSolver*) self, row_clues, (gint) row_clues_length1, col_clues, (gint) col_clues_length1, working, NULL);
	if (is_column) {
		guint _tmp2_;
		guint _tmp3_;
		_tmp2_ = gnonograms_abstract_solver_get_rows ((GnonogramsAbstractSolver*) self);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = (guint) 0;
	}
	_tmp4_ = ((GnonogramsAbstractSolver*) self)->regions;
	_tmp4__length1 = ((GnonogramsAbstractSolver*) self)->regions_length1;
	_tmp5_ = _tmp4_[idx + _tmp1_];
	_tmp6_ = _gnonograms_region_ref0 (_tmp5_);
	r = _tmp6_;
	_tmp7_ = r;
	changed = gnonograms_region_debug (_tmp7_);
	_tmp8_ = r;
	_tmp9_ = gnonograms_region_get_in_error (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_ERROR);
		g_critical ("Solver.vala:118: Debugged Region in error");
	}
	if (changed) {
		guint _tmp11_ = 0U;
		GnonogramsRegion* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		guint size = 0U;
		GnonogramsCellState* csa = NULL;
		GnonogramsCellState* _tmp19_;
		gint csa_length1;
		gint _csa_size_;
		GnonogramsRegion* _tmp20_;
		guint _tmp21_;
		guint _tmp22_;
		GnonogramsRegion* _tmp23_;
		gboolean _tmp24_;
		gboolean _tmp25_;
		_tmp12_ = r;
		_tmp13_ = gnonograms_region_get_is_column (_tmp12_);
		_tmp14_ = _tmp13_;
		if (_tmp14_) {
			guint _tmp15_;
			guint _tmp16_;
			_tmp15_ = gnonograms_abstract_solver_get_rows ((GnonogramsAbstractSolver*) self);
			_tmp16_ = _tmp15_;
			_tmp11_ = _tmp16_;
		} else {
			guint _tmp17_;
			guint _tmp18_;
			_tmp17_ = gnonograms_abstract_solver_get_cols ((GnonogramsAbstractSolver*) self);
			_tmp18_ = _tmp17_;
			_tmp11_ = _tmp18_;
		}
		size = _tmp11_;
		_tmp19_ = g_new0 (GnonogramsCellState, size);
		csa = _tmp19_;
		csa_length1 = size;
		_csa_size_ = csa_length1;
		_tmp20_ = r;
		_tmp21_ = gnonograms_region_get_index (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = r;
		_tmp24_ = gnonograms_region_get_is_column (_tmp23_);
		_tmp25_ = _tmp24_;
		gnonograms_my2_dcell_array_get_array (working, _tmp22_, _tmp25_, &csa, (gint*) (&csa_length1), (guint) 0);
		_csa_size_ = csa_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp26_ = FALSE;
				_tmp26_ = TRUE;
				while (TRUE) {
					GnonogramsCellState r_state = 0;
					GnonogramsRegion* _tmp28_;
					gboolean _tmp29_ = FALSE;
					if (!_tmp26_) {
						gint _tmp27_;
						_tmp27_ = i;
						i = _tmp27_ + 1;
					}
					_tmp26_ = FALSE;
					if (!(((guint) i) < size)) {
						break;
					}
					_tmp28_ = r;
					r_state = gnonograms_region_get_cell_state (_tmp28_, (guint) i);
					if (r_state != GNONOGRAMS_CELL_STATE_UNKNOWN) {
						GnonogramsCellState* _tmp30_;
						gint _tmp30__length1;
						GnonogramsCellState _tmp31_;
						_tmp30_ = csa;
						_tmp30__length1 = csa_length1;
						_tmp31_ = _tmp30_[i];
						_tmp29_ = _tmp31_ != r_state;
					} else {
						_tmp29_ = FALSE;
					}
					if (_tmp29_) {
						guint _tmp32_ = 0U;
						GnonogramsRegion* _tmp33_;
						gboolean _tmp34_;
						gboolean _tmp35_;
						guint row = 0U;
						guint _tmp39_ = 0U;
						GnonogramsRegion* _tmp40_;
						gboolean _tmp41_;
						gboolean _tmp42_;
						guint col = 0U;
						GnonogramsCell c = {0};
						GnonogramsCell _tmp46_ = {0};
						GeeArrayQueue* _tmp47_;
						GnonogramsCell _tmp48_;
						GnonogramsCellState* _tmp49_;
						gint _tmp49__length1;
						GnonogramsCellState _tmp50_;
						GnonogramsMove* _tmp51_;
						GnonogramsMove* _tmp52_;
						_tmp33_ = r;
						_tmp34_ = gnonograms_region_get_is_column (_tmp33_);
						_tmp35_ = _tmp34_;
						if (_tmp35_) {
							_tmp32_ = (guint) i;
						} else {
							GnonogramsRegion* _tmp36_;
							guint _tmp37_;
							guint _tmp38_;
							_tmp36_ = r;
							_tmp37_ = gnonograms_region_get_index (_tmp36_);
							_tmp38_ = _tmp37_;
							_tmp32_ = _tmp38_;
						}
						row = _tmp32_;
						_tmp40_ = r;
						_tmp41_ = gnonograms_region_get_is_column (_tmp40_);
						_tmp42_ = _tmp41_;
						if (_tmp42_) {
							GnonogramsRegion* _tmp43_;
							guint _tmp44_;
							guint _tmp45_;
							_tmp43_ = r;
							_tmp44_ = gnonograms_region_get_index (_tmp43_);
							_tmp45_ = _tmp44_;
							_tmp39_ = _tmp45_;
						} else {
							_tmp39_ = (guint) i;
						}
						col = _tmp39_;
						_tmp46_.row = row;
						_tmp46_.col = col;
						_tmp46_.state = r_state;
						c = _tmp46_;
						_tmp47_ = moves;
						_tmp48_ = c;
						_tmp49_ = csa;
						_tmp49__length1 = csa_length1;
						_tmp50_ = _tmp49_[i];
						_tmp51_ = gnonograms_move_new (&_tmp48_, _tmp50_);
						_tmp52_ = _tmp51_;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp47_, _tmp52_);
						_gnonograms_move_unref0 (_tmp52_);
						break;
					}
				}
			}
		}
		csa = (g_free (csa), NULL);
	}
	result = moves;
	_gnonograms_region_unref0 (r);
	return result;
}

static GeeArrayQueue*
gnonograms_solver_real_hint (GnonogramsAbstractSolver* base,
                             gchar** row_clues,
                             gint row_clues_length1,
                             gchar** col_clues,
                             gint col_clues_length1,
                             GnonogramsMy2DCellArray* working)
{
	GnonogramsSolver * self;
	GnonogramsDimensions _tmp0_ = {0};
	GnonogramsDimensions _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsMy2DCellArray* _tmp3_;
	GnonogramsDimensions _tmp4_ = {0};
	GnonogramsDimensions _tmp5_;
	GnonogramsDimensions _tmp6_ = {0};
	GnonogramsDimensions _tmp7_;
	GnonogramsDimensions _tmp8_ = {0};
	GnonogramsDimensions _tmp9_;
	gboolean changed = FALSE;
	guint count = 0U;
	GeeArrayQueue* moves = NULL;
	GeeArrayQueue* _tmp10_;
	GnonogramsRegion** _tmp11_;
	gint _tmp11__length1;
	GeeArrayQueue* result = NULL;
	self = (GnonogramsSolver*) base;
	g_return_val_if_fail (working != NULL, NULL);
	gnonograms_my2_dcell_array_get_dimensions (working, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = gnonograms_abstract_solver_get_grid ((GnonogramsAbstractSolver*) self);
	_tmp3_ = _tmp2_;
	gnonograms_my2_dcell_array_get_dimensions (_tmp3_, &_tmp4_);
	_tmp5_ = _tmp4_;
	_vala_assert (gnonograms_dimensions_equal (&_tmp1_, &_tmp5_), "working.dimensions.equal (grid.dimensions)");
	gnonograms_my2_dcell_array_get_dimensions (working, &_tmp6_);
	_tmp7_ = _tmp6_;
	_vala_assert (gnonograms_dimensions_rows (&_tmp7_) == ((guint) row_clues_length1), "working.dimensions.rows () == row_clues.length");
	gnonograms_my2_dcell_array_get_dimensions (working, &_tmp8_);
	_tmp9_ = _tmp8_;
	_vala_assert (gnonograms_dimensions_cols (&_tmp9_) == ((guint) col_clues_length1), "working.dimensions.cols () == col_clues.length");
	gnonograms_abstract_solver_initialize ((GnonogramsAbstractSolver*) self, row_clues, (gint) row_clues_length1, col_clues, (gint) col_clues_length1, working, NULL);
	changed = FALSE;
	count = (guint) 0;
	_tmp10_ = gee_array_queue_new (GNONOGRAMS_TYPE_MOVE, (GBoxedCopyFunc) gnonograms_move_ref, (GDestroyNotify) gnonograms_move_unref, NULL, NULL, NULL);
	moves = _tmp10_;
	_tmp11_ = ((GnonogramsAbstractSolver*) self)->regions;
	_tmp11__length1 = ((GnonogramsAbstractSolver*) self)->regions_length1;
	{
		GnonogramsRegion** r_collection = NULL;
		gint r_collection_length1 = 0;
		gint _r_collection_size_ = 0;
		gint r_it = 0;
		r_collection = _tmp11_;
		r_collection_length1 = _tmp11__length1;
		for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
			GnonogramsRegion* _tmp12_;
			GnonogramsRegion* r = NULL;
			_tmp12_ = _gnonograms_region_ref0 (r_collection[r_it]);
			r = _tmp12_;
			{
				guint _tmp13_ = 0U;
				GnonogramsRegion* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
				guint size = 0U;
				GnonogramsCellState* csa = NULL;
				GnonogramsCellState* _tmp21_;
				gint csa_length1;
				gint _csa_size_;
				GnonogramsRegion* _tmp22_;
				guint _tmp23_;
				guint _tmp24_;
				GnonogramsRegion* _tmp25_;
				gboolean _tmp26_;
				gboolean _tmp27_;
				_tmp14_ = r;
				_tmp15_ = gnonograms_region_get_is_column (_tmp14_);
				_tmp16_ = _tmp15_;
				if (_tmp16_) {
					guint _tmp17_;
					guint _tmp18_;
					_tmp17_ = gnonograms_abstract_solver_get_rows ((GnonogramsAbstractSolver*) self);
					_tmp18_ = _tmp17_;
					_tmp13_ = _tmp18_;
				} else {
					guint _tmp19_;
					guint _tmp20_;
					_tmp19_ = gnonograms_abstract_solver_get_cols ((GnonogramsAbstractSolver*) self);
					_tmp20_ = _tmp19_;
					_tmp13_ = _tmp20_;
				}
				size = _tmp13_;
				_tmp21_ = g_new0 (GnonogramsCellState, size);
				csa = _tmp21_;
				csa_length1 = size;
				_csa_size_ = csa_length1;
				_tmp22_ = r;
				_tmp23_ = gnonograms_region_get_index (_tmp22_);
				_tmp24_ = _tmp23_;
				_tmp25_ = r;
				_tmp26_ = gnonograms_region_get_is_column (_tmp25_);
				_tmp27_ = _tmp26_;
				gnonograms_my2_dcell_array_get_array (working, _tmp24_, _tmp27_, &csa, (gint*) (&csa_length1), (guint) 0);
				_csa_size_ = csa_length1;
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp28_ = FALSE;
						_tmp28_ = TRUE;
						while (TRUE) {
							GnonogramsCellState r_state = 0;
							GnonogramsRegion* _tmp30_;
							gboolean _tmp31_ = FALSE;
							if (!_tmp28_) {
								gint _tmp29_;
								_tmp29_ = i;
								i = _tmp29_ + 1;
							}
							_tmp28_ = FALSE;
							if (!(((guint) i) < size)) {
								break;
							}
							_tmp30_ = r;
							r_state = gnonograms_region_get_cell_state (_tmp30_, (guint) i);
							if (r_state != GNONOGRAMS_CELL_STATE_UNKNOWN) {
								GnonogramsCellState* _tmp32_;
								gint _tmp32__length1;
								GnonogramsCellState _tmp33_;
								_tmp32_ = csa;
								_tmp32__length1 = csa_length1;
								_tmp33_ = _tmp32_[i];
								_tmp31_ = _tmp33_ != r_state;
							} else {
								_tmp31_ = FALSE;
							}
							if (_tmp31_) {
								guint _tmp34_ = 0U;
								GnonogramsRegion* _tmp35_;
								gboolean _tmp36_;
								gboolean _tmp37_;
								guint row = 0U;
								guint _tmp41_ = 0U;
								GnonogramsRegion* _tmp42_;
								gboolean _tmp43_;
								gboolean _tmp44_;
								guint col = 0U;
								GnonogramsCell c = {0};
								GnonogramsCell _tmp48_ = {0};
								GeeArrayQueue* _tmp49_;
								GnonogramsCell _tmp50_;
								GnonogramsCellState* _tmp51_;
								gint _tmp51__length1;
								GnonogramsCellState _tmp52_;
								GnonogramsMove* _tmp53_;
								GnonogramsMove* _tmp54_;
								_tmp35_ = r;
								_tmp36_ = gnonograms_region_get_is_column (_tmp35_);
								_tmp37_ = _tmp36_;
								if (_tmp37_) {
									_tmp34_ = (guint) i;
								} else {
									GnonogramsRegion* _tmp38_;
									guint _tmp39_;
									guint _tmp40_;
									_tmp38_ = r;
									_tmp39_ = gnonograms_region_get_index (_tmp38_);
									_tmp40_ = _tmp39_;
									_tmp34_ = _tmp40_;
								}
								row = _tmp34_;
								_tmp42_ = r;
								_tmp43_ = gnonograms_region_get_is_column (_tmp42_);
								_tmp44_ = _tmp43_;
								if (_tmp44_) {
									GnonogramsRegion* _tmp45_;
									guint _tmp46_;
									guint _tmp47_;
									_tmp45_ = r;
									_tmp46_ = gnonograms_region_get_index (_tmp45_);
									_tmp47_ = _tmp46_;
									_tmp41_ = _tmp47_;
								} else {
									_tmp41_ = (guint) i;
								}
								col = _tmp41_;
								_tmp48_.row = row;
								_tmp48_.col = col;
								_tmp48_.state = r_state;
								c = _tmp48_;
								_tmp49_ = moves;
								_tmp50_ = c;
								_tmp51_ = csa;
								_tmp51__length1 = csa_length1;
								_tmp52_ = _tmp51_[i];
								_tmp53_ = gnonograms_move_new (&_tmp50_, _tmp52_);
								_tmp54_ = _tmp53_;
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp54_);
								_gnonograms_move_unref0 (_tmp54_);
								changed = TRUE;
							}
						}
					}
				}
				csa = (g_free (csa), NULL);
				_gnonograms_region_unref0 (r);
			}
		}
	}
	while (TRUE) {
		gboolean _tmp55_ = FALSE;
		gboolean _tmp56_ = FALSE;
		guint _tmp59_;
		GnonogramsRegion** _tmp60_;
		gint _tmp60__length1;
		if (!changed) {
			_tmp56_ = count < ((guint) 2);
		} else {
			_tmp56_ = FALSE;
		}
		if (_tmp56_) {
			GnonogramsSolverState _tmp57_;
			GnonogramsSolverState _tmp58_;
			_tmp57_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
			_tmp58_ = _tmp57_;
			_tmp55_ = _tmp58_ != GNONOGRAMS_SOLVER_STATE_ERROR;
		} else {
			_tmp55_ = FALSE;
		}
		if (!_tmp55_) {
			break;
		}
		changed = FALSE;
		_tmp59_ = count;
		count = _tmp59_ + 1;
		_tmp60_ = ((GnonogramsAbstractSolver*) self)->regions;
		_tmp60__length1 = ((GnonogramsAbstractSolver*) self)->regions_length1;
		{
			GnonogramsRegion** r_collection = NULL;
			gint r_collection_length1 = 0;
			gint _r_collection_size_ = 0;
			gint r_it = 0;
			r_collection = _tmp60_;
			r_collection_length1 = _tmp60__length1;
			for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
				GnonogramsRegion* _tmp61_;
				GnonogramsRegion* r = NULL;
				_tmp61_ = _gnonograms_region_ref0 (r_collection[r_it]);
				r = _tmp61_;
				{
					GnonogramsRegion* _tmp62_;
					gboolean _tmp63_;
					gboolean _tmp64_;
					GnonogramsRegion* _tmp65_;
					GnonogramsRegion* _tmp66_;
					gboolean _tmp67_;
					gboolean _tmp68_;
					_tmp62_ = r;
					_tmp63_ = gnonograms_region_get_is_completed (_tmp62_);
					_tmp64_ = _tmp63_;
					if (_tmp64_) {
						_gnonograms_region_unref0 (r);
						continue;
					}
					_tmp65_ = r;
					changed = gnonograms_region_solve (_tmp65_);
					_tmp66_ = r;
					_tmp67_ = gnonograms_region_get_in_error (_tmp66_);
					_tmp68_ = _tmp67_;
					if (_tmp68_) {
						gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_ERROR);
						_gnonograms_region_unref0 (r);
						break;
					}
					if (changed) {
						guint _tmp69_ = 0U;
						GnonogramsRegion* _tmp70_;
						gboolean _tmp71_;
						gboolean _tmp72_;
						guint size = 0U;
						GnonogramsCellState* csa = NULL;
						GnonogramsCellState* _tmp77_;
						gint csa_length1;
						gint _csa_size_;
						GnonogramsRegion* _tmp78_;
						guint _tmp79_;
						guint _tmp80_;
						GnonogramsRegion* _tmp81_;
						gboolean _tmp82_;
						gboolean _tmp83_;
						_tmp70_ = r;
						_tmp71_ = gnonograms_region_get_is_column (_tmp70_);
						_tmp72_ = _tmp71_;
						if (_tmp72_) {
							guint _tmp73_;
							guint _tmp74_;
							_tmp73_ = gnonograms_abstract_solver_get_rows ((GnonogramsAbstractSolver*) self);
							_tmp74_ = _tmp73_;
							_tmp69_ = _tmp74_;
						} else {
							guint _tmp75_;
							guint _tmp76_;
							_tmp75_ = gnonograms_abstract_solver_get_cols ((GnonogramsAbstractSolver*) self);
							_tmp76_ = _tmp75_;
							_tmp69_ = _tmp76_;
						}
						size = _tmp69_;
						_tmp77_ = g_new0 (GnonogramsCellState, size);
						csa = _tmp77_;
						csa_length1 = size;
						_csa_size_ = csa_length1;
						_tmp78_ = r;
						_tmp79_ = gnonograms_region_get_index (_tmp78_);
						_tmp80_ = _tmp79_;
						_tmp81_ = r;
						_tmp82_ = gnonograms_region_get_is_column (_tmp81_);
						_tmp83_ = _tmp82_;
						gnonograms_my2_dcell_array_get_array (working, _tmp80_, _tmp83_, &csa, (gint*) (&csa_length1), (guint) 0);
						_csa_size_ = csa_length1;
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp84_ = FALSE;
								_tmp84_ = TRUE;
								while (TRUE) {
									GnonogramsCellState r_state = 0;
									GnonogramsRegion* _tmp86_;
									gboolean _tmp87_ = FALSE;
									if (!_tmp84_) {
										gint _tmp85_;
										_tmp85_ = i;
										i = _tmp85_ + 1;
									}
									_tmp84_ = FALSE;
									if (!(((guint) i) < size)) {
										break;
									}
									_tmp86_ = r;
									r_state = gnonograms_region_get_cell_state (_tmp86_, (guint) i);
									if (r_state != GNONOGRAMS_CELL_STATE_UNKNOWN) {
										GnonogramsCellState* _tmp88_;
										gint _tmp88__length1;
										GnonogramsCellState _tmp89_;
										_tmp88_ = csa;
										_tmp88__length1 = csa_length1;
										_tmp89_ = _tmp88_[i];
										_tmp87_ = _tmp89_ != r_state;
									} else {
										_tmp87_ = FALSE;
									}
									if (_tmp87_) {
										guint _tmp90_ = 0U;
										GnonogramsRegion* _tmp91_;
										gboolean _tmp92_;
										gboolean _tmp93_;
										guint row = 0U;
										guint _tmp97_ = 0U;
										GnonogramsRegion* _tmp98_;
										gboolean _tmp99_;
										gboolean _tmp100_;
										guint col = 0U;
										GnonogramsCell c = {0};
										GnonogramsCell _tmp104_ = {0};
										GeeArrayQueue* _tmp105_;
										GnonogramsCell _tmp106_;
										GnonogramsCellState* _tmp107_;
										gint _tmp107__length1;
										GnonogramsCellState _tmp108_;
										GnonogramsMove* _tmp109_;
										GnonogramsMove* _tmp110_;
										_tmp91_ = r;
										_tmp92_ = gnonograms_region_get_is_column (_tmp91_);
										_tmp93_ = _tmp92_;
										if (_tmp93_) {
											_tmp90_ = (guint) i;
										} else {
											GnonogramsRegion* _tmp94_;
											guint _tmp95_;
											guint _tmp96_;
											_tmp94_ = r;
											_tmp95_ = gnonograms_region_get_index (_tmp94_);
											_tmp96_ = _tmp95_;
											_tmp90_ = _tmp96_;
										}
										row = _tmp90_;
										_tmp98_ = r;
										_tmp99_ = gnonograms_region_get_is_column (_tmp98_);
										_tmp100_ = _tmp99_;
										if (_tmp100_) {
											GnonogramsRegion* _tmp101_;
											guint _tmp102_;
											guint _tmp103_;
											_tmp101_ = r;
											_tmp102_ = gnonograms_region_get_index (_tmp101_);
											_tmp103_ = _tmp102_;
											_tmp97_ = _tmp103_;
										} else {
											_tmp97_ = (guint) i;
										}
										col = _tmp97_;
										_tmp104_.row = row;
										_tmp104_.col = col;
										_tmp104_.state = r_state;
										c = _tmp104_;
										_tmp105_ = moves;
										_tmp106_ = c;
										_tmp107_ = csa;
										_tmp107__length1 = csa_length1;
										_tmp108_ = _tmp107_[i];
										_tmp109_ = gnonograms_move_new (&_tmp106_, _tmp108_);
										_tmp110_ = _tmp109_;
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp105_, _tmp110_);
										_gnonograms_move_unref0 (_tmp110_);
										break;
									}
								}
							}
						}
						csa = (g_free (csa), NULL);
						_gnonograms_region_unref0 (r);
						break;
					}
					_gnonograms_region_unref0 (r);
				}
			}
		}
	}
	result = moves;
	return result;
}

/** Returns -1 to indicate an error **/
static gint
gnonograms_solver_simple_solver (GnonogramsSolver* self)
{
	gboolean changed = FALSE;
	gint pass = 0;
	GnonogramsMy2DCellArray* _tmp14_;
	GnonogramsMy2DCellArray* _tmp15_;
	GnonogramsMy2DCellArray* _tmp16_;
	GnonogramsMy2DCellArray* _tmp17_;
	GnonogramsSolverState _tmp18_;
	GnonogramsSolverState _tmp19_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	changed = TRUE;
	pass = 1;
	gnonograms_abstract_solver_reinitialize_regions ((GnonogramsAbstractSolver*) self);
	gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		GnonogramsRegion** _tmp2_;
		gint _tmp2__length1;
		gint _tmp11_;
		GCancellable* _tmp12_;
		GCancellable* _tmp13_;
		if (changed) {
			_tmp1_ = pass >= 0;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			_tmp0_ = ((guint) pass) < GNONOGRAMS_ABSTRACT_SOLVER_MAX_PASSES;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		changed = FALSE;
		_tmp2_ = ((GnonogramsAbstractSolver*) self)->regions;
		_tmp2__length1 = ((GnonogramsAbstractSolver*) self)->regions_length1;
		{
			GnonogramsRegion** r_collection = NULL;
			gint r_collection_length1 = 0;
			gint _r_collection_size_ = 0;
			gint r_it = 0;
			r_collection = _tmp2_;
			r_collection_length1 = _tmp2__length1;
			for (r_it = 0; r_it < r_collection_length1; r_it = r_it + 1) {
				GnonogramsRegion* _tmp3_;
				GnonogramsRegion* r = NULL;
				_tmp3_ = _gnonograms_region_ref0 (r_collection[r_it]);
				r = _tmp3_;
				{
					GnonogramsRegion* _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
					GnonogramsRegion* _tmp7_;
					GnonogramsRegion* _tmp8_;
					gboolean _tmp9_;
					gboolean _tmp10_;
					_tmp4_ = r;
					_tmp5_ = gnonograms_region_get_is_completed (_tmp4_);
					_tmp6_ = _tmp5_;
					if (_tmp6_) {
						_gnonograms_region_unref0 (r);
						continue;
					}
					_tmp7_ = r;
					changed |= gnonograms_region_solve (_tmp7_);
					_tmp8_ = r;
					_tmp9_ = gnonograms_region_get_in_error (_tmp8_);
					_tmp10_ = _tmp9_;
					if (_tmp10_) {
						gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_ERROR);
						_gnonograms_region_unref0 (r);
						break;
					}
					_gnonograms_region_unref0 (r);
				}
			}
		}
		_tmp11_ = pass;
		pass = _tmp11_ + 1;
		_tmp12_ = gnonograms_abstract_solver_get_cancellable ((GnonogramsAbstractSolver*) self);
		_tmp13_ = _tmp12_;
		if (g_cancellable_is_cancelled (_tmp13_)) {
			gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_CANCELLED);
			break;
		}
	}
	_tmp14_ = gnonograms_abstract_solver_get_solution ((GnonogramsAbstractSolver*) self);
	_tmp15_ = _tmp14_;
	_tmp16_ = gnonograms_abstract_solver_get_grid ((GnonogramsAbstractSolver*) self);
	_tmp17_ = _tmp16_;
	gnonograms_my2_dcell_array_copy (_tmp15_, _tmp17_);
	_tmp18_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
	_tmp19_ = _tmp18_;
	if (!(((GNONOGRAMS_SOLVER_STATE_ERROR | GNONOGRAMS_SOLVER_STATE_CANCELLED) & _tmp19_) == _tmp19_)) {
		if (gnonograms_abstract_solver_solved ((GnonogramsAbstractSolver*) self)) {
			gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_SIMPLE);
		} else {
			gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
			pass = 0;
		}
	}
	result = pass;
	return result;
}

/** Make single cell guesses, depth 1 (no recursion)
        Make a guess in each unknown cell in turn
        If it leads to contradiction mark opposite to guess,
        continue simple solve and if still no solution, continue with another guess.
        If first guess does not lead to solution leave unknown and choose another cell
    **/
static gint
gnonograms_solver_advanced_solver (GnonogramsSolver* self)
{
	gint _result_ = 0;
	gint changed_count = 0;
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint min_to_contradiction = 0;
	GnonogramsSolverGuesser* guesser = NULL;
	GnonogramsMy2DCellArray* _tmp3_;
	GnonogramsMy2DCellArray* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GnonogramsSolverGuesser* _tmp7_;
	GnonogramsSolverState initial_state = 0;
	GnonogramsSolverState inverse_state = 0;
	gint contra = 0;
	GnonogramsSolverState _tmp38_;
	GnonogramsSolverState _tmp39_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_result_ = 0;
	changed_count = 0;
	_tmp1_ = gnonograms_abstract_solver_get_human_only ((GnonogramsAbstractSolver*) self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = 5;
	} else {
		_tmp0_ = (gint) GNONOGRAMS_ABSTRACT_SOLVER_MAX_PASSES;
	}
	min_to_contradiction = _tmp0_;
	_tmp3_ = gnonograms_abstract_solver_get_grid ((GnonogramsAbstractSolver*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = gnonograms_abstract_solver_get_human_only ((GnonogramsAbstractSolver*) self);
	_tmp6_ = _tmp5_;
	_tmp7_ = gnonograms_solver_guesser_new (_tmp4_, _tmp6_);
	guesser = _tmp7_;
	initial_state = GNONOGRAMS_SOLVER_STATE_UNDEFINED;
	inverse_state = GNONOGRAMS_SOLVER_STATE_UNDEFINED;
	contra = 0;
	gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
	while (TRUE) {
		GnonogramsSolverState _tmp8_;
		GnonogramsSolverState _tmp9_;
		gint _tmp10_;
		GnonogramsSolverGuesser* _tmp11_;
		GnonogramsSolverState _tmp12_;
		GnonogramsSolverState _tmp13_;
		gboolean _tmp14_ = FALSE;
		GnonogramsSolverState _tmp15_;
		GnonogramsSolverState _tmp16_;
		GnonogramsSolverGuesser* _tmp18_;
		GnonogramsSolverState _tmp19_;
		GnonogramsSolverState _tmp20_;
		gboolean _tmp21_ = FALSE;
		GCancellable* _tmp36_;
		GCancellable* _tmp37_;
		_tmp8_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
		_tmp9_ = _tmp8_;
		if (!(_tmp9_ == GNONOGRAMS_SOLVER_STATE_UNDEFINED)) {
			break;
		}
		_tmp10_ = changed_count;
		changed_count = _tmp10_ + 1;
		_tmp11_ = guesser;
		if (!gnonograms_solver_guesser_next_guess (_tmp11_)) {
			gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
			break;
		}
		_result_ = gnonograms_solver_simple_solver (self);
		_tmp12_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
		_tmp13_ = _tmp12_;
		initial_state = _tmp13_;
		_tmp15_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
		_tmp16_ = _tmp15_;
		if (_tmp16_ == GNONOGRAMS_SOLVER_STATE_ERROR) {
			_tmp14_ = _result_ > min_to_contradiction;
		} else {
			_tmp14_ = FALSE;
		}
		if (_tmp14_) {
			GnonogramsSolverGuesser* _tmp17_;
			gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
			_tmp17_ = guesser;
			gnonograms_solver_guesser_cancel_previous_guess (_tmp17_);
			continue;
		}
		contra = _result_;
		_tmp18_ = guesser;
		gnonograms_solver_guesser_invert_previous_guess (_tmp18_);
		_result_ = gnonograms_solver_simple_solver (self);
		_tmp19_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
		_tmp20_ = _tmp19_;
		inverse_state = _tmp20_;
		if (initial_state == GNONOGRAMS_SOLVER_STATE_ERROR) {
			_tmp21_ = inverse_state == GNONOGRAMS_SOLVER_STATE_ERROR;
		} else {
			_tmp21_ = FALSE;
		}
		if (_tmp21_) {
			gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
			break;
		}
		switch (inverse_state) {
			case GNONOGRAMS_SOLVER_STATE_ERROR:
			{
				gboolean _tmp22_ = FALSE;
				GnonogramsSolverGuesser* _tmp24_;
				if (initial_state == GNONOGRAMS_SOLVER_STATE_ERROR) {
					_tmp22_ = TRUE;
				} else {
					_tmp22_ = _result_ > min_to_contradiction;
				}
				if (_tmp22_) {
					GnonogramsSolverGuesser* _tmp23_;
					_tmp23_ = guesser;
					gnonograms_solver_guesser_cancel_previous_guess (_tmp23_);
					gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
					break;
				}
				contra = _result_;
				_tmp24_ = guesser;
				gnonograms_solver_guesser_invert_previous_guess (_tmp24_);
				_result_ = gnonograms_solver_simple_solver (self);
				if (initial_state == GNONOGRAMS_SOLVER_STATE_SIMPLE) {
					gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_ADVANCED);
				} else {
					if (initial_state == GNONOGRAMS_SOLVER_STATE_NO_SOLUTION) {
						GnonogramsSolverGuesser* _tmp25_;
						_tmp25_ = guesser;
						gnonograms_solver_guesser_initialize (_tmp25_);
						gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
					} else {
						GEnumValue* _tmp26_;
						_tmp26_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_SOLVER_STATE), initial_state);
						g_critical ("Solver.vala:327: unexpected sinitial tate %s", (_tmp26_ != NULL) ? _tmp26_->value_name : NULL);
						g_assert_not_reached ();
					}
				}
				break;
			}
			case GNONOGRAMS_SOLVER_STATE_NO_SOLUTION:
			{
				if (initial_state == GNONOGRAMS_SOLVER_STATE_SIMPLE) {
					gboolean _tmp27_;
					gboolean _tmp28_;
					_tmp27_ = gnonograms_abstract_solver_get_unique_only ((GnonogramsAbstractSolver*) self);
					_tmp28_ = _tmp27_;
					if (_tmp28_) {
						gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
					} else {
						GnonogramsSolverGuesser* _tmp29_;
						_tmp29_ = guesser;
						gnonograms_solver_guesser_invert_previous_guess (_tmp29_);
						_result_ = gnonograms_solver_simple_solver (self);
						gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_AMBIGUOUS);
					}
				} else {
					if (initial_state == GNONOGRAMS_SOLVER_STATE_ERROR) {
						GnonogramsSolverGuesser* _tmp30_;
						_tmp30_ = guesser;
						gnonograms_solver_guesser_initialize (_tmp30_);
						gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
					} else {
						if (initial_state == GNONOGRAMS_SOLVER_STATE_NO_SOLUTION) {
							GnonogramsSolverGuesser* _tmp31_;
							_tmp31_ = guesser;
							gnonograms_solver_guesser_cancel_previous_guess (_tmp31_);
							gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_UNDEFINED);
						} else {
							GEnumValue* _tmp32_;
							_tmp32_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_SOLVER_STATE), initial_state);
							g_critical ("Solver.vala:352: unexpected initial state %s", (_tmp32_ != NULL) ? _tmp32_->value_name : NULL);
							g_assert_not_reached ();
						}
					}
				}
				break;
			}
			case GNONOGRAMS_SOLVER_STATE_SIMPLE:
			{
				if (initial_state == GNONOGRAMS_SOLVER_STATE_ERROR) {
					gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_ADVANCED);
				} else {
					gboolean _tmp33_;
					gboolean _tmp34_;
					_tmp33_ = gnonograms_abstract_solver_get_unique_only ((GnonogramsAbstractSolver*) self);
					_tmp34_ = _tmp33_;
					if (_tmp34_) {
						gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_NO_SOLUTION);
					} else {
						gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_AMBIGUOUS);
					}
				}
				break;
			}
			case GNONOGRAMS_SOLVER_STATE_CANCELLED:
			{
				break;
			}
			default:
			{
				GEnumValue* _tmp35_;
				_tmp35_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_SOLVER_STATE), inverse_state);
				g_critical ("Solver.vala:376: unexpected state %s", (_tmp35_ != NULL) ? _tmp35_->value_name : NULL);
				g_assert_not_reached ();
			}
		}
		_tmp36_ = gnonograms_abstract_solver_get_cancellable ((GnonogramsAbstractSolver*) self);
		_tmp37_ = _tmp36_;
		if (g_cancellable_is_cancelled (_tmp37_)) {
			gnonograms_abstract_solver_set_state ((GnonogramsAbstractSolver*) self, GNONOGRAMS_SOLVER_STATE_CANCELLED);
			break;
		}
	}
	_tmp38_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
	_tmp39_ = _tmp38_;
	switch (_tmp39_) {
		case GNONOGRAMS_SOLVER_STATE_CANCELLED:
		case GNONOGRAMS_SOLVER_STATE_NO_SOLUTION:
		{
			result = 0;
			_gnonograms_solver_guesser_unref0 (guesser);
			return result;
		}
		case GNONOGRAMS_SOLVER_STATE_ADVANCED:
		case GNONOGRAMS_SOLVER_STATE_AMBIGUOUS:
		{
			result = _result_;
			_gnonograms_solver_guesser_unref0 (guesser);
			return result;
		}
		default:
		{
			GnonogramsSolverState _tmp40_;
			GnonogramsSolverState _tmp41_;
			GEnumValue* _tmp42_;
			_tmp40_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_enum_get_value (g_type_class_ref (GNONOGRAMS_TYPE_SOLVER_STATE), _tmp41_);
			g_critical ("Solver.vala:398: unexpected state %s", (_tmp42_ != NULL) ? _tmp42_->value_name : NULL);
			g_assert_not_reached ();
		}
	}
}

/** Only call if simple solver used **/
static GnonogramsDifficulty
gnonograms_solver_passes_to_grade (GnonogramsSolver* self,
                                   guint passes)
{
	GnonogramsDifficulty _result_ = 0;
	GnonogramsDifficulty result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (passes == ((guint) 0)) {
		_result_ = GNONOGRAMS_DIFFICULTY_UNDEFINED;
	} else {
		GnonogramsSolverState _tmp0_;
		GnonogramsSolverState _tmp1_;
		_tmp0_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
		_tmp1_ = _tmp0_;
		if (_tmp1_ == GNONOGRAMS_SOLVER_STATE_ADVANCED) {
			_result_ = GNONOGRAMS_DIFFICULTY_ADVANCED;
		} else {
			GnonogramsSolverState _tmp2_;
			GnonogramsSolverState _tmp3_;
			_tmp2_ = gnonograms_abstract_solver_get_state ((GnonogramsAbstractSolver*) self);
			_tmp3_ = _tmp2_;
			if (_tmp3_ == GNONOGRAMS_SOLVER_STATE_AMBIGUOUS) {
				_result_ = GNONOGRAMS_DIFFICULTY_MAXIMUM;
			} else {
				if (passes >= self->priv->challenging_threshold) {
					_result_ = GNONOGRAMS_DIFFICULTY_CHALLENGING;
				} else {
					if (passes >= self->priv->hard_threshold) {
						_result_ = GNONOGRAMS_DIFFICULTY_HARD;
					} else {
						if (passes >= self->priv->moderate_threshold) {
							_result_ = GNONOGRAMS_DIFFICULTY_MODERATE;
						} else {
							_result_ = GNONOGRAMS_DIFFICULTY_EASY;
						}
					}
				}
			}
		}
	}
	result = _result_;
	return result;
}

static inline gpointer
gnonograms_solver_guesser_get_instance_private (GnonogramsSolverGuesser* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsSolverGuesser_private_offset);
}

static GnonogramsSolverGuesser*
gnonograms_solver_guesser_construct (GType object_type,
                                     GnonogramsMy2DCellArray* _grid,
                                     gboolean _human_only)
{
	GnonogramsSolverGuesser* self = NULL;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	g_return_val_if_fail (_grid != NULL, NULL);
	self = (GnonogramsSolverGuesser*) g_type_create_instance (object_type);
	gnonograms_solver_guesser_set_grid (self, _grid);
	_tmp0_ = gnonograms_solver_guesser_get_rows (self);
	_tmp1_ = _tmp0_;
	self->priv->rlim = (gint) _tmp1_;
	_tmp2_ = gnonograms_solver_guesser_get_cols (self);
	_tmp3_ = _tmp2_;
	self->priv->clim = (gint) _tmp3_;
	self->priv->human_only = _human_only;
	gnonograms_solver_guesser_initialize (self);
	return self;
}

static GnonogramsSolverGuesser*
gnonograms_solver_guesser_new (GnonogramsMy2DCellArray* _grid,
                               gboolean _human_only)
{
	return gnonograms_solver_guesser_construct (GNONOGRAMS_SOLVER_TYPE_GUESSER, _grid, _human_only);
}

static void
gnonograms_solver_guesser_initialize (GnonogramsSolverGuesser* self)
{
	GnonogramsCell _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	self->priv->rdir = 0;
	self->priv->cdir = 1;
	self->priv->turn = 0;
	if (self->priv->human_only) {
		self->priv->max_turns = self->priv->initial_max_turns;
	} else {
		guint _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
		_tmp0_ = gnonograms_solver_guesser_get_rows (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gnonograms_solver_guesser_get_cols (self);
		_tmp3_ = _tmp2_;
		self->priv->max_turns = MIN (_tmp1_, _tmp3_) / 2;
	}
	_tmp4_.row = (guint) 0;
	_tmp4_.col = G_MAXUINT;
	_tmp4_.state = self->priv->initial_cell_state;
	self->priv->trial_cell = _tmp4_;
}

static gboolean
gnonograms_solver_guesser_next_guess (GnonogramsSolverGuesser* self)
{
	gboolean guessed = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	gnonograms_solver_guesser_save_position (self);
	guessed = gnonograms_solver_guesser_make_guess (self);
	result = guessed;
	return result;
}

static void
gnonograms_solver_guesser_invert_previous_guess (GnonogramsSolverGuesser* self)
{
	GnonogramsCell _tmp0_ = {0};
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsCell _tmp3_;
	g_return_if_fail (self != NULL);
	gnonograms_solver_guesser_load_position (self);
	gnonograms_cell_inverse (&self->priv->trial_cell, &_tmp0_);
	self->priv->trial_cell = _tmp0_;
	_tmp1_ = gnonograms_solver_guesser_get_grid (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->trial_cell;
	gnonograms_my2_dcell_array_set_data_from_cell (_tmp2_, &_tmp3_);
}

static void
gnonograms_solver_guesser_cancel_previous_guess (GnonogramsSolverGuesser* self)
{
	GnonogramsCell _tmp0_ = {0};
	GnonogramsMy2DCellArray* _tmp1_;
	GnonogramsMy2DCellArray* _tmp2_;
	GnonogramsCell _tmp3_;
	GnonogramsCell _tmp4_;
	g_return_if_fail (self != NULL);
	gnonograms_solver_guesser_load_position (self);
	gnonograms_cell_inverse (&self->priv->trial_cell, &_tmp0_);
	self->priv->trial_cell = _tmp0_;
	_tmp1_ = gnonograms_solver_guesser_get_grid (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->trial_cell;
	_tmp4_ = self->priv->trial_cell;
	gnonograms_my2_dcell_array_set_data_from_rc (_tmp2_, _tmp3_.row, _tmp4_.col, GNONOGRAMS_CELL_STATE_UNKNOWN);
}

static void
gnonograms_solver_guesser_save_position (GnonogramsSolverGuesser* self)
{
	gint index = 0;
	g_return_if_fail (self != NULL);
	index = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_solver_guesser_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				{
					gint c = 0;
					c = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint _tmp6_;
							guint _tmp7_;
							GnonogramsCellState* _tmp8_;
							gint _tmp8__length1;
							gint _tmp9_;
							GnonogramsMy2DCellArray* _tmp10_;
							GnonogramsMy2DCellArray* _tmp11_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = c;
								c = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = gnonograms_solver_guesser_get_cols (self);
							_tmp7_ = _tmp6_;
							if (!(((guint) c) < _tmp7_)) {
								break;
							}
							_tmp8_ = self->priv->gs;
							_tmp8__length1 = self->priv->gs_length1;
							_tmp9_ = index;
							index = _tmp9_ + 1;
							_tmp10_ = gnonograms_solver_guesser_get_grid (self);
							_tmp11_ = _tmp10_;
							_tmp8_[_tmp9_] = gnonograms_my2_dcell_array_get_data_from_rc (_tmp11_, (guint) r, (guint) c);
						}
					}
				}
			}
		}
	}
}

static void
gnonograms_solver_guesser_load_position (GnonogramsSolverGuesser* self)
{
	gint index = 0;
	g_return_if_fail (self != NULL);
	index = 0;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_solver_guesser_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				{
					gint c = 0;
					c = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint _tmp6_;
							guint _tmp7_;
							GnonogramsMy2DCellArray* _tmp8_;
							GnonogramsMy2DCellArray* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							GnonogramsCellState* _tmp12_;
							gint _tmp12__length1;
							gint _tmp13_;
							GnonogramsCellState _tmp14_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = c;
								c = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = gnonograms_solver_guesser_get_cols (self);
							_tmp7_ = _tmp6_;
							if (!(((guint) c) < _tmp7_)) {
								break;
							}
							_tmp8_ = gnonograms_solver_guesser_get_grid (self);
							_tmp9_ = _tmp8_;
							_tmp10_ = r;
							_tmp11_ = c;
							_tmp12_ = self->priv->gs;
							_tmp12__length1 = self->priv->gs_length1;
							_tmp13_ = index;
							index = _tmp13_ + 1;
							_tmp14_ = _tmp12_[_tmp13_];
							gnonograms_my2_dcell_array_set_data_from_rc (_tmp9_, (guint) _tmp10_, (guint) _tmp11_, _tmp14_);
						}
					}
				}
			}
		}
	}
}

/** Used by advanced solver. Scans in a spiral pattern from edges
          * as critical cells most likely in this region.
        **/
static gboolean
gnonograms_solver_guesser_make_guess (GnonogramsSolverGuesser* self)
{
	gint r = 0;
	GnonogramsCell _tmp0_;
	gint c = 0;
	GnonogramsCell _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->trial_cell;
	r = (gint) _tmp0_.row;
	_tmp1_ = self->priv->trial_cell;
	c = (gint) _tmp1_.col;
	while (TRUE) {
		gboolean _tmp2_ = FALSE;
		GnonogramsMy2DCellArray* _tmp16_;
		GnonogramsMy2DCellArray* _tmp17_;
		r += self->priv->rdir;
		c += self->priv->cdir;
		if (self->priv->cdir == 1) {
			_tmp2_ = c >= self->priv->clim;
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			gint _tmp3_;
			gint _tmp4_;
			_tmp3_ = c;
			c = _tmp3_ - 1;
			self->priv->cdir = 0;
			self->priv->rdir = 1;
			_tmp4_ = r;
			r = _tmp4_ + 1;
		} else {
			gboolean _tmp5_ = FALSE;
			if (self->priv->rdir == 1) {
				_tmp5_ = r >= self->priv->rlim;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				gint _tmp6_;
				gint _tmp7_;
				_tmp6_ = r;
				r = _tmp6_ - 1;
				self->priv->rdir = 0;
				self->priv->cdir = -1;
				_tmp7_ = c;
				c = _tmp7_ - 1;
			} else {
				gboolean _tmp8_ = FALSE;
				if (self->priv->cdir == -1) {
					_tmp8_ = c < self->priv->turn;
				} else {
					_tmp8_ = FALSE;
				}
				if (_tmp8_) {
					gint _tmp9_;
					gint _tmp10_;
					_tmp9_ = c;
					c = _tmp9_ + 1;
					self->priv->cdir = 0;
					self->priv->rdir = -1;
					_tmp10_ = r;
					r = _tmp10_ - 1;
				} else {
					gboolean _tmp11_ = FALSE;
					if (self->priv->rdir == -1) {
						_tmp11_ = r <= self->priv->turn;
					} else {
						_tmp11_ = FALSE;
					}
					if (_tmp11_) {
						gint _tmp12_;
						gint _tmp13_;
						gint _tmp14_;
						gint _tmp15_;
						_tmp12_ = r;
						r = _tmp12_ + 1;
						_tmp13_ = self->priv->turn;
						self->priv->turn = _tmp13_ + 1;
						_tmp14_ = self->priv->rlim;
						self->priv->rlim = _tmp14_ - 1;
						_tmp15_ = self->priv->clim;
						self->priv->clim = _tmp15_ - 1;
						self->priv->rdir = 0;
						self->priv->cdir = 1;
					}
				}
			}
		}
		if (((guint) self->priv->turn) > self->priv->max_turns) {
			self->priv->trial_cell.row = (guint) 0;
			self->priv->trial_cell.col = G_MAXUINT;
			result = FALSE;
			return result;
		}
		_tmp16_ = gnonograms_solver_guesser_get_grid (self);
		_tmp17_ = _tmp16_;
		if (gnonograms_my2_dcell_array_get_data_from_rc (_tmp17_, (guint) r, (guint) c) == GNONOGRAMS_CELL_STATE_UNKNOWN) {
			GnonogramsMy2DCellArray* _tmp18_;
			GnonogramsMy2DCellArray* _tmp19_;
			GnonogramsCell _tmp20_;
			self->priv->trial_cell.row = (guint) r;
			self->priv->trial_cell.col = (guint) c;
			_tmp18_ = gnonograms_solver_guesser_get_grid (self);
			_tmp19_ = _tmp18_;
			_tmp20_ = self->priv->trial_cell;
			gnonograms_my2_dcell_array_set_data_from_cell (_tmp19_, &_tmp20_);
			break;
		}
	}
	result = TRUE;
	return result;
}

static GnonogramsMy2DCellArray*
gnonograms_solver_guesser_get_grid (GnonogramsSolverGuesser* self)
{
	GnonogramsMy2DCellArray* result;
	GnonogramsMy2DCellArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_grid;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gnonograms_solver_guesser_set_grid (GnonogramsSolverGuesser* self,
                                    GnonogramsMy2DCellArray* value)
{
	GnonogramsMy2DCellArray* _tmp0_;
	GnonogramsMy2DCellArray* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	GnonogramsCellState* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_grid);
	self->priv->_grid = _tmp0_;
	_tmp1_ = self->priv->_grid;
	_tmp2_ = gnonograms_my2_dcell_array_get_area (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_new0 (GnonogramsCellState, _tmp3_);
	self->priv->gs = (g_free (self->priv->gs), NULL);
	self->priv->gs = _tmp4_;
	self->priv->gs_length1 = _tmp3_;
	self->priv->_gs_size_ = self->priv->gs_length1;
}

static guint
gnonograms_solver_guesser_get_rows (GnonogramsSolverGuesser* self)
{
	guint result;
	GnonogramsMy2DCellArray* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = gnonograms_my2_dcell_array_get_rows (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static guint
gnonograms_solver_guesser_get_cols (GnonogramsSolverGuesser* self)
{
	guint result;
	GnonogramsMy2DCellArray* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_grid;
	_tmp1_ = gnonograms_my2_dcell_array_get_cols (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static void
gnonograms_solver_value_guesser_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
gnonograms_solver_value_guesser_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		gnonograms_solver_guesser_unref (value->data[0].v_pointer);
	}
}

static void
gnonograms_solver_value_guesser_copy_value (const GValue* src_value,
                                            GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gnonograms_solver_guesser_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
gnonograms_solver_value_guesser_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
gnonograms_solver_value_guesser_collect_value (GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		GnonogramsSolverGuesser * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gnonograms_solver_guesser_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
gnonograms_solver_value_guesser_lcopy_value (const GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	GnonogramsSolverGuesser ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gnonograms_solver_guesser_ref (value->data[0].v_pointer);
	}
	return NULL;
}

static GParamSpec*
gnonograms_solver_param_spec_guesser (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags)
{
	GnonogramsSolverParamSpecGuesser* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GNONOGRAMS_SOLVER_TYPE_GUESSER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

static gpointer
gnonograms_solver_value_get_guesser (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_SOLVER_TYPE_GUESSER), NULL);
	return value->data[0].v_pointer;
}

static void
gnonograms_solver_value_set_guesser (GValue* value,
                                     gpointer v_object)
{
	GnonogramsSolverGuesser * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_SOLVER_TYPE_GUESSER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_SOLVER_TYPE_GUESSER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gnonograms_solver_guesser_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_solver_guesser_unref (old);
	}
}

static void
gnonograms_solver_value_take_guesser (GValue* value,
                                      gpointer v_object)
{
	GnonogramsSolverGuesser * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GNONOGRAMS_SOLVER_TYPE_GUESSER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GNONOGRAMS_SOLVER_TYPE_GUESSER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gnonograms_solver_guesser_unref (old);
	}
}

static void
gnonograms_solver_guesser_class_init (GnonogramsSolverGuesserClass * klass,
                                      gpointer klass_data)
{
	gnonograms_solver_guesser_parent_class = g_type_class_peek_parent (klass);
	((GnonogramsSolverGuesserClass *) klass)->finalize = gnonograms_solver_guesser_finalize;
	g_type_class_adjust_private_offset (klass, &GnonogramsSolverGuesser_private_offset);
}

static void
gnonograms_solver_guesser_instance_init (GnonogramsSolverGuesser * self,
                                         gpointer klass)
{
	self->priv = gnonograms_solver_guesser_get_instance_private (self);
	self->priv->initial_max_turns = (guint) 3;
	self->priv->initial_cell_state = GNONOGRAMS_CELL_STATE_EMPTY;
	self->ref_count = 1;
}

static void
gnonograms_solver_guesser_finalize (GnonogramsSolverGuesser * obj)
{
	GnonogramsSolverGuesser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_SOLVER_TYPE_GUESSER, GnonogramsSolverGuesser);
	g_signal_handlers_destroy (self);
	self->priv->gs = (g_free (self->priv->gs), NULL);
	_g_object_unref0 (self->priv->_grid);
}

static GType
gnonograms_solver_guesser_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gnonograms_solver_value_guesser_init, gnonograms_solver_value_guesser_free_value, gnonograms_solver_value_guesser_copy_value, gnonograms_solver_value_guesser_peek_pointer, "p", gnonograms_solver_value_guesser_collect_value, "p", gnonograms_solver_value_guesser_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsSolverGuesserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_solver_guesser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsSolverGuesser), 0, (GInstanceInitFunc) gnonograms_solver_guesser_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gnonograms_solver_guesser_type_id;
	gnonograms_solver_guesser_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GnonogramsSolverGuesser", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GnonogramsSolverGuesser_private_offset = g_type_add_instance_private (gnonograms_solver_guesser_type_id, sizeof (GnonogramsSolverGuesserPrivate));
	return gnonograms_solver_guesser_type_id;
}

static GType
gnonograms_solver_guesser_get_type (void)
{
	static volatile gsize gnonograms_solver_guesser_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_solver_guesser_type_id__volatile)) {
		GType gnonograms_solver_guesser_type_id;
		gnonograms_solver_guesser_type_id = gnonograms_solver_guesser_get_type_once ();
		g_once_init_leave (&gnonograms_solver_guesser_type_id__volatile, gnonograms_solver_guesser_type_id);
	}
	return gnonograms_solver_guesser_type_id__volatile;
}

static gpointer
gnonograms_solver_guesser_ref (gpointer instance)
{
	GnonogramsSolverGuesser * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

static void
gnonograms_solver_guesser_unref (gpointer instance)
{
	GnonogramsSolverGuesser * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GNONOGRAMS_SOLVER_GUESSER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
gnonograms_solver_class_init (GnonogramsSolverClass * klass,
                              gpointer klass_data)
{
	gnonograms_solver_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsSolver_private_offset);
	((GnonogramsAbstractSolverClass *) klass)->configure_from_grade = (void (*) (GnonogramsAbstractSolver*, GnonogramsDifficulty)) gnonograms_solver_real_configure_from_grade;
	((GnonogramsAbstractSolverClass *) klass)->solve_it = (GnonogramsDifficulty (*) (GnonogramsAbstractSolver*)) gnonograms_solver_real_solve_it;
	((GnonogramsAbstractSolverClass *) klass)->debug = (GeeArrayQueue* (*) (GnonogramsAbstractSolver*, guint, gboolean, gchar**, gint, gchar**, gint, GnonogramsMy2DCellArray*)) gnonograms_solver_real_debug;
	((GnonogramsAbstractSolverClass *) klass)->hint = (GeeArrayQueue* (*) (GnonogramsAbstractSolver*, gchar**, gint, gchar**, gint, GnonogramsMy2DCellArray*)) gnonograms_solver_real_hint;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_solver_finalize;
}

static void
gnonograms_solver_instance_init (GnonogramsSolver * self,
                                 gpointer klass)
{
	self->priv = gnonograms_solver_get_instance_private (self);
}

static void
gnonograms_solver_finalize (GObject * obj)
{
	GnonogramsSolver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_SOLVER, GnonogramsSolver);
	G_OBJECT_CLASS (gnonograms_solver_parent_class)->finalize (obj);
}

static GType
gnonograms_solver_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsSolverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_solver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsSolver), 0, (GInstanceInitFunc) gnonograms_solver_instance_init, NULL };
	GType gnonograms_solver_type_id;
	gnonograms_solver_type_id = g_type_register_static (GNONOGRAMS_TYPE_ABSTRACT_SOLVER, "GnonogramsSolver", &g_define_type_info, 0);
	GnonogramsSolver_private_offset = g_type_add_instance_private (gnonograms_solver_type_id, sizeof (GnonogramsSolverPrivate));
	return gnonograms_solver_type_id;
}

GType
gnonograms_solver_get_type (void)
{
	static volatile gsize gnonograms_solver_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_solver_type_id__volatile)) {
		GType gnonograms_solver_type_id;
		gnonograms_solver_type_id = gnonograms_solver_get_type_once ();
		g_once_init_leave (&gnonograms_solver_type_id__volatile, gnonograms_solver_type_id);
	}
	return gnonograms_solver_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

