/* utils.c generated by valac 0.54.6, the Vala compiler
 * generated from utils.vala, do not modify */

/* Utility functions for gnonograms
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

#define GNONOGRAMS_BLOCKSEPARATOR ", "
#define GNONOGRAMS_BLANKLABELTEXT N_ ("?")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

#define GNONOGRAMS_TYPE_BLOCK (gnonograms_block_get_type ())
#define GNONOGRAMS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock))
#define GNONOGRAMS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))
#define GNONOGRAMS_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))

typedef struct _GnonogramsBlock GnonogramsBlock;
typedef struct _GnonogramsBlockClass GnonogramsBlockClass;
#define _gnonograms_block_unref0(var) ((var == NULL) ? NULL : (var = (gnonograms_block_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())

#define GNONOGRAMS_TYPE_MY2_DCELL_ARRAY (gnonograms_my2_dcell_array_get_type ())
#define GNONOGRAMS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArray))
#define GNONOGRAMS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_IS_MY2_DCELL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY))
#define GNONOGRAMS_MY2_DCELL_ARRAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MY2_DCELL_ARRAY, GnonogramsMy2DCellArrayClass))

typedef struct _GnonogramsMy2DCellArray GnonogramsMy2DCellArray;
typedef struct _GnonogramsMy2DCellArrayClass GnonogramsMy2DCellArrayClass;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_NO_SOLUTION,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION,
	GNONOGRAMS_FILE_CHOOSER_ACTION_SELECT_FOLDER,
	GNONOGRAMS_FILE_CHOOSER_ACTION_UNDEFINED
} GnonogramsFileChooserAction;

#define GNONOGRAMS_TYPE_FILE_CHOOSER_ACTION (gnonograms_file_chooser_action_get_type ())

#define GNONOGRAMS_TYPE_FILTER_INFO (gnonograms_filter_info_get_type ())
typedef struct _GnonogramsFilterInfo GnonogramsFilterInfo;

struct _GnonogramsFilterInfo {
	gchar* name;
	gchar** patterns;
	gint patterns_length1;
};

VALA_EXTERN gchar** gnonograms_utils_remove_blank_lines (gchar** sa,
                                             gint sa_length1,
                                             gint* result_length1);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gint* gnonograms_utils_block_array_from_clue (const gchar* s,
                                              gint* result_length1);
VALA_EXTERN gpointer gnonograms_block_ref (gpointer instance);
VALA_EXTERN void gnonograms_block_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_block (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_block (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void gnonograms_value_take_block (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_block (const GValue* value);
VALA_EXTERN GType gnonograms_block_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsBlock, gnonograms_block_unref)
VALA_EXTERN GeeArrayList* gnonograms_utils_block_struct_array_from_clue (const gchar* s);
VALA_EXTERN GnonogramsBlock* gnonograms_block_new (gint len,
                                       gboolean complete,
                                       gboolean _error_);
VALA_EXTERN GnonogramsBlock* gnonograms_block_construct (GType object_type,
                                             gint len,
                                             gboolean complete,
                                             gboolean _error_);
VALA_EXTERN gint gnonograms_utils_blockextent_from_clue (const gchar* s);
VALA_EXTERN GType gnonograms_cell_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gint gnonograms_utils_freedom_from_array (GnonogramsCellState* arr,
                                          gint arr_length1);
VALA_EXTERN GType gnonograms_my2_dcell_array_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMy2DCellArray, g_object_unref)
VALA_EXTERN gchar** gnonograms_utils_row_clues_from_2D_array (GnonogramsMy2DCellArray* array,
                                                  gint* result_length1);
VALA_EXTERN guint gnonograms_my2_dcell_array_get_rows (GnonogramsMy2DCellArray* self);
VALA_EXTERN guint gnonograms_my2_dcell_array_get_cols (GnonogramsMy2DCellArray* self);
VALA_EXTERN gchar* gnonograms_my2_dcell_array_data2text (GnonogramsMy2DCellArray* self,
                                             guint idx,
                                             guint length,
                                             gboolean iscolumn);
VALA_EXTERN gchar** gnonograms_utils_col_clues_from_2D_array (GnonogramsMy2DCellArray* array,
                                                  gint* result_length1);
VALA_EXTERN GeeArrayList* gnonograms_utils_complete_block_array_from_cellstate_array (GnonogramsCellState* cellstates,
                                                                          gint cellstates_length1);
VALA_EXTERN GnonogramsBlock* gnonograms_block_new_null (void);
VALA_EXTERN GnonogramsBlock* gnonograms_block_construct_null (GType object_type);
VALA_EXTERN gchar* gnonograms_utils_block_string_from_cellstate_array (GnonogramsCellState* cellstates,
                                                           gint cellstates_length1);
VALA_EXTERN GnonogramsCellState* gnonograms_utils_cellstate_array_from_string (const gchar* s,
                                                                   gint* result_length1);
static void _vala_array_add2 (GnonogramsCellState* * array,
                       gint* length,
                       gint* size,
                       GnonogramsCellState value);
VALA_EXTERN gchar* gnonograms_utils_string_from_cellstate_array (GnonogramsCellState* cs,
                                                     gint cs_length1);
VALA_EXTERN gint gnonograms_utils_show_dlg (const gchar* primary_text,
                                GtkMessageType type,
                                const gchar* secondary_text,
                                GtkWindow* parent);
VALA_EXTERN void gnonograms_utils_show_error_dialog (const gchar* primary_text,
                                         const gchar* secondary_text,
                                         GtkWindow* parent);
VALA_EXTERN gboolean gnonograms_utils_show_confirm_dialog (const gchar* primary_text,
                                               const gchar* secondary_text,
                                               GtkWindow* parent);
VALA_EXTERN GType gnonograms_file_chooser_action_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_filter_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsFilterInfo* gnonograms_filter_info_dup (const GnonogramsFilterInfo* self);
VALA_EXTERN void gnonograms_filter_info_free (GnonogramsFilterInfo* self);
VALA_EXTERN void gnonograms_filter_info_copy (const GnonogramsFilterInfo* self,
                                  GnonogramsFilterInfo* dest);
VALA_EXTERN void gnonograms_filter_info_destroy (GnonogramsFilterInfo* self);
VALA_EXTERN gchar* gnonograms_utils_get_file_path (GtkWindow* parent,
                                       GnonogramsFileChooserAction action,
                                       const gchar* dialogname,
                                       GnonogramsFilterInfo* filters,
                                       gint filters_length1,
                                       const gchar* start_path,
                                       gboolean* save_solution);
VALA_EXTERN void gnonograms_utils_get_monitor_area (GdkScreen* screen,
                                        GdkWindow* window,
                                        GdkRectangle* result);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

gchar**
gnonograms_utils_remove_blank_lines (gchar** sa,
                                     gint sa_length1,
                                     gint* result_length1)
{
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** result = NULL;
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	_result_ = _tmp0_;
	_result__length1 = 0;
	__result__size_ = _result__length1;
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = sa;
		s_collection_length1 = sa_length1;
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
			gchar* _tmp1_;
			gchar* s = NULL;
			_tmp1_ = g_strdup (s_collection[s_it]);
			s = _tmp1_;
			{
				gchar* ss = NULL;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				const gchar* _tmp4_;
				_tmp2_ = s;
				_tmp3_ = string_strip (_tmp2_);
				ss = _tmp3_;
				_tmp4_ = ss;
				if (g_strcmp0 (_tmp4_, "") != 0) {
					const gchar* _tmp5_;
					gchar* _tmp6_;
					_tmp5_ = ss;
					_tmp6_ = g_strdup (_tmp5_);
					_vala_array_add1 (&_result_, &_result__length1, &__result__size_, _tmp6_);
				}
				_g_free0 (ss);
				_g_free0 (s);
			}
		}
	}
	_tmp7_ = _result_;
	_tmp7__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}

gint*
gnonograms_utils_block_array_from_clue (const gchar* s,
                                        gint* result_length1)
{
	gchar** blocks = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint blocks_length1;
	gint _blocks_size_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint* result = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit_set (s, ", ", 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp4_ = gnonograms_utils_remove_blank_lines (_tmp2_, (gint) _vala_array_length (_tmp0_), &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp3_;
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	blocks = _tmp5_;
	blocks_length1 = _tmp5__length1;
	_blocks_size_ = blocks_length1;
	_tmp6_ = blocks;
	_tmp6__length1 = blocks_length1;
	if (_tmp6__length1 == 0) {
		gint* _tmp7_;
		gint* _tmp8_;
		gint _tmp8__length1;
		_tmp7_ = g_new0 (gint, 1);
		_tmp7_[0] = 0;
		_tmp8_ = _tmp7_;
		_tmp8__length1 = 1;
		if (result_length1) {
			*result_length1 = _tmp8__length1;
		}
		result = _tmp8_;
		blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
		return result;
	} else {
		gint* block_array = NULL;
		gchar** _tmp9_;
		gint _tmp9__length1;
		gint* _tmp10_;
		gint block_array_length1;
		gint _block_array_size_;
		gint index = 0;
		gchar** _tmp11_;
		gint _tmp11__length1;
		gint* _tmp16_;
		gint _tmp16__length1;
		_tmp9_ = blocks;
		_tmp9__length1 = blocks_length1;
		_tmp10_ = g_new0 (gint, _tmp9__length1);
		block_array = _tmp10_;
		block_array_length1 = _tmp9__length1;
		_block_array_size_ = block_array_length1;
		index = 0;
		_tmp11_ = blocks;
		_tmp11__length1 = blocks_length1;
		{
			gchar** block_collection = NULL;
			gint block_collection_length1 = 0;
			gint _block_collection_size_ = 0;
			gint block_it = 0;
			block_collection = _tmp11_;
			block_collection_length1 = _tmp11__length1;
			for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
				gchar* _tmp12_;
				gchar* block = NULL;
				_tmp12_ = g_strdup (block_collection[block_it]);
				block = _tmp12_;
				{
					gint* _tmp13_;
					gint _tmp13__length1;
					gint _tmp14_;
					const gchar* _tmp15_;
					_tmp13_ = block_array;
					_tmp13__length1 = block_array_length1;
					_tmp14_ = index;
					index = _tmp14_ + 1;
					_tmp15_ = block;
					_tmp13_[_tmp14_] = atoi (_tmp15_);
					_g_free0 (block);
				}
			}
		}
		_tmp16_ = block_array;
		_tmp16__length1 = block_array_length1;
		if (result_length1) {
			*result_length1 = _tmp16__length1;
		}
		result = _tmp16_;
		blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
}

GeeArrayList*
gnonograms_utils_block_struct_array_from_clue (const gchar* s)
{
	gchar** blocks = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gint blocks_length1;
	gint _blocks_size_;
	GeeArrayList* block_array = NULL;
	GeeArrayList* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GeeArrayList* result = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit_set (s, ", ", 0);
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _vala_array_length (_tmp0_);
	_tmp4_ = gnonograms_utils_remove_blank_lines (_tmp2_, (gint) _vala_array_length (_tmp0_), &_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp3_;
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	blocks = _tmp5_;
	blocks_length1 = _tmp5__length1;
	_blocks_size_ = blocks_length1;
	_tmp6_ = gee_array_list_new (GNONOGRAMS_TYPE_BLOCK, (GBoxedCopyFunc) gnonograms_block_ref, (GDestroyNotify) gnonograms_block_unref, NULL, NULL, NULL);
	block_array = _tmp6_;
	_tmp7_ = blocks;
	_tmp7__length1 = blocks_length1;
	{
		gchar** block_collection = NULL;
		gint block_collection_length1 = 0;
		gint _block_collection_size_ = 0;
		gint block_it = 0;
		block_collection = _tmp7_;
		block_collection_length1 = _tmp7__length1;
		for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
			gchar* _tmp8_;
			gchar* block = NULL;
			_tmp8_ = g_strdup (block_collection[block_it]);
			block = _tmp8_;
			{
				GeeArrayList* _tmp9_;
				const gchar* _tmp10_;
				GnonogramsBlock* _tmp11_;
				GnonogramsBlock* _tmp12_;
				_tmp9_ = block_array;
				_tmp10_ = block;
				_tmp11_ = gnonograms_block_new (atoi (_tmp10_), FALSE, FALSE);
				_tmp12_ = _tmp11_;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp12_);
				_gnonograms_block_unref0 (_tmp12_);
				_g_free0 (block);
			}
		}
	}
	result = block_array;
	blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gint
gnonograms_utils_blockextent_from_clue (const gchar* s)
{
	gint* blocks = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint blocks_length1;
	gint _blocks_size_;
	gint extent = 0;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint result = 0;
	if (s == NULL) {
		result = 0;
		return result;
	}
	_tmp1_ = gnonograms_utils_block_array_from_clue (s, &_tmp0_);
	blocks = _tmp1_;
	blocks_length1 = _tmp0_;
	_blocks_size_ = blocks_length1;
	extent = 0;
	_tmp2_ = blocks;
	_tmp2__length1 = blocks_length1;
	{
		gint* block_collection = NULL;
		gint block_collection_length1 = 0;
		gint _block_collection_size_ = 0;
		gint block_it = 0;
		block_collection = _tmp2_;
		block_collection_length1 = _tmp2__length1;
		for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
			gint block = 0;
			block = block_collection[block_it];
			{
				extent += block + 1;
			}
		}
	}
	_tmp3_ = extent;
	extent = _tmp3_ - 1;
	result = extent;
	blocks = (g_free (blocks), NULL);
	return result;
}

gint
gnonograms_utils_freedom_from_array (GnonogramsCellState* arr,
                                     gint arr_length1)
{
	gint filled = 0;
	gint blocks = 0;
	gint length = 0;
	gint result = 0;
	filled = 0;
	blocks = 0;
	length = arr_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsCellState _tmp2_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < length)) {
					break;
				}
				_tmp2_ = arr[i];
				if (_tmp2_ == GNONOGRAMS_CELL_STATE_FILLED) {
					gint _tmp3_;
					gboolean _tmp4_ = FALSE;
					_tmp3_ = filled;
					filled = _tmp3_ + 1;
					if (i == 0) {
						_tmp4_ = TRUE;
					} else {
						GnonogramsCellState _tmp5_;
						_tmp5_ = arr[i - 1];
						_tmp4_ = _tmp5_ == GNONOGRAMS_CELL_STATE_EMPTY;
					}
					if (_tmp4_) {
						gint _tmp6_;
						_tmp6_ = blocks;
						blocks = _tmp6_ + 1;
					}
				}
			}
		}
	}
	result = (length - filled) - (blocks - 1);
	return result;
}

gchar**
gnonograms_utils_row_clues_from_2D_array (GnonogramsMy2DCellArray* array,
                                          gint* result_length1)
{
	guint rows = 0U;
	guint _tmp0_;
	guint _tmp1_;
	guint cols = 0U;
	guint _tmp2_;
	guint _tmp3_;
	gchar** clues = NULL;
	gchar** _tmp4_;
	gint clues_length1;
	gint _clues_size_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** result = NULL;
	g_return_val_if_fail (array != NULL, NULL);
	_tmp0_ = gnonograms_my2_dcell_array_get_rows (array);
	_tmp1_ = _tmp0_;
	rows = _tmp1_;
	_tmp2_ = gnonograms_my2_dcell_array_get_cols (array);
	_tmp3_ = _tmp2_;
	cols = _tmp3_;
	_tmp4_ = g_new0 (gchar*, rows + 1);
	clues = _tmp4_;
	clues_length1 = rows;
	_clues_size_ = clues_length1;
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gchar** _tmp7_;
				gint _tmp7__length1;
				gchar* _tmp8_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = r;
					r = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(((guint) r) < rows)) {
					break;
				}
				_tmp7_ = clues;
				_tmp7__length1 = clues_length1;
				_tmp8_ = gnonograms_my2_dcell_array_data2text (array, (guint) r, cols, FALSE);
				_g_free0 (_tmp7_[r]);
				_tmp7_[r] = _tmp8_;
			}
		}
	}
	_tmp9_ = clues;
	_tmp9__length1 = clues_length1;
	if (result_length1) {
		*result_length1 = _tmp9__length1;
	}
	result = _tmp9_;
	return result;
}

gchar**
gnonograms_utils_col_clues_from_2D_array (GnonogramsMy2DCellArray* array,
                                          gint* result_length1)
{
	guint rows = 0U;
	guint _tmp0_;
	guint _tmp1_;
	guint cols = 0U;
	guint _tmp2_;
	guint _tmp3_;
	gchar** clues = NULL;
	gchar** _tmp4_;
	gint clues_length1;
	gint _clues_size_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** result = NULL;
	g_return_val_if_fail (array != NULL, NULL);
	_tmp0_ = gnonograms_my2_dcell_array_get_rows (array);
	_tmp1_ = _tmp0_;
	rows = _tmp1_;
	_tmp2_ = gnonograms_my2_dcell_array_get_cols (array);
	_tmp3_ = _tmp2_;
	cols = _tmp3_;
	_tmp4_ = g_new0 (gchar*, cols + 1);
	clues = _tmp4_;
	clues_length1 = cols;
	_clues_size_ = clues_length1;
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gchar** _tmp7_;
				gint _tmp7__length1;
				gchar* _tmp8_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = c;
					c = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(((guint) c) < cols)) {
					break;
				}
				_tmp7_ = clues;
				_tmp7__length1 = clues_length1;
				_tmp8_ = gnonograms_my2_dcell_array_data2text (array, (guint) c, rows, TRUE);
				_g_free0 (_tmp7_[c]);
				_tmp7_[c] = _tmp8_;
			}
		}
	}
	_tmp9_ = clues;
	_tmp9__length1 = clues_length1;
	if (result_length1) {
		*result_length1 = _tmp9__length1;
	}
	result = _tmp9_;
	return result;
}

GeeArrayList*
gnonograms_utils_complete_block_array_from_cellstate_array (GnonogramsCellState* cellstates,
                                                            gint cellstates_length1)
{
	GeeArrayList* blocks = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	gboolean valid = FALSE;
	GnonogramsCellState previous_state = 0;
	GeeArrayList* result = NULL;
	_tmp0_ = gee_array_list_new (GNONOGRAMS_TYPE_BLOCK, (GBoxedCopyFunc) gnonograms_block_ref, (GDestroyNotify) gnonograms_block_unref, NULL, NULL, NULL);
	blocks = _tmp0_;
	count = 0;
	valid = TRUE;
	previous_state = GNONOGRAMS_CELL_STATE_UNKNOWN;
	{
		GnonogramsCellState* state_collection = NULL;
		gint state_collection_length1 = 0;
		gint _state_collection_size_ = 0;
		gint state_it = 0;
		state_collection = cellstates;
		state_collection_length1 = cellstates_length1;
		for (state_it = 0; state_it < state_collection_length1; state_it = state_it + 1) {
			GnonogramsCellState state = 0;
			state = state_collection[state_it];
			{
				switch (state) {
					case GNONOGRAMS_CELL_STATE_EMPTY:
					{
						if (count > 0) {
							GeeArrayList* _tmp1_;
							GnonogramsBlock* _tmp2_;
							GnonogramsBlock* _tmp3_;
							_tmp1_ = blocks;
							_tmp2_ = gnonograms_block_new (count, TRUE, FALSE);
							_tmp3_ = _tmp2_;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp3_);
							_gnonograms_block_unref0 (_tmp3_);
							count = 0;
						} else {
							valid = TRUE;
						}
						break;
					}
					case GNONOGRAMS_CELL_STATE_FILLED:
					{
						if (valid) {
							gint _tmp4_;
							_tmp4_ = count;
							count = _tmp4_ + 1;
						}
						break;
					}
					case GNONOGRAMS_CELL_STATE_UNKNOWN:
					{
						gboolean _tmp5_ = FALSE;
						if (valid) {
							_tmp5_ = TRUE;
						} else {
							_tmp5_ = previous_state != GNONOGRAMS_CELL_STATE_UNKNOWN;
						}
						if (_tmp5_) {
							GeeArrayList* _tmp6_;
							GnonogramsBlock* _tmp7_;
							GnonogramsBlock* _tmp8_;
							valid = FALSE;
							count = 0;
							_tmp6_ = blocks;
							_tmp7_ = gnonograms_block_new_null ();
							_tmp8_ = _tmp7_;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp8_);
							_gnonograms_block_unref0 (_tmp8_);
						}
						break;
					}
					default:
					{
						break;
					}
				}
				previous_state = state;
			}
		}
	}
	if (count > 0) {
		GeeArrayList* _tmp9_;
		GnonogramsBlock* _tmp10_;
		GnonogramsBlock* _tmp11_;
		_tmp9_ = blocks;
		_tmp10_ = gnonograms_block_new (count, TRUE, FALSE);
		_tmp11_ = _tmp10_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp11_);
		_gnonograms_block_unref0 (_tmp11_);
	}
	result = blocks;
	return result;
}

gchar*
gnonograms_utils_block_string_from_cellstate_array (GnonogramsCellState* cellstates,
                                                    gint cellstates_length1)
{
	GString* sb = NULL;
	GString* _tmp0_;
	gint count = 0;
	gint blocks = 0;
	gboolean counting = FALSE;
	GnonogramsCellState count_state = 0;
	GString* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* result = NULL;
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	count = 0;
	blocks = 0;
	counting = FALSE;
	count_state = GNONOGRAMS_CELL_STATE_UNDEFINED;
	{
		GnonogramsCellState* state_collection = NULL;
		gint state_collection_length1 = 0;
		gint _state_collection_size_ = 0;
		gint state_it = 0;
		state_collection = cellstates;
		state_collection_length1 = cellstates_length1;
		for (state_it = 0; state_it < state_collection_length1; state_it = state_it + 1) {
			GnonogramsCellState state = 0;
			state = state_collection[state_it];
			{
				switch (state) {
					case GNONOGRAMS_CELL_STATE_EMPTY:
					{
						if (count_state == GNONOGRAMS_CELL_STATE_FILLED) {
							GString* _tmp1_;
							gchar* _tmp2_;
							gchar* _tmp3_;
							gchar* _tmp4_;
							gchar* _tmp5_;
							gint _tmp6_;
							_tmp1_ = sb;
							_tmp2_ = g_strdup_printf ("%i", count);
							_tmp3_ = _tmp2_;
							_tmp4_ = g_strconcat (_tmp3_, GNONOGRAMS_BLOCKSEPARATOR, NULL);
							_tmp5_ = _tmp4_;
							g_string_append (_tmp1_, _tmp5_);
							_g_free0 (_tmp5_);
							_g_free0 (_tmp3_);
							_tmp6_ = blocks;
							blocks = _tmp6_ + 1;
						} else {
							if (count_state == GNONOGRAMS_CELL_STATE_UNKNOWN) {
								GString* _tmp7_;
								_tmp7_ = sb;
								g_string_append (_tmp7_, "?" GNONOGRAMS_BLOCKSEPARATOR);
							}
						}
						counting = FALSE;
						count_state = GNONOGRAMS_CELL_STATE_UNDEFINED;
						count = 0;
						break;
					}
					case GNONOGRAMS_CELL_STATE_FILLED:
					{
						gint _tmp9_;
						if (count_state == GNONOGRAMS_CELL_STATE_UNDEFINED) {
							count = 0;
							counting = TRUE;
						} else {
							if (count_state == GNONOGRAMS_CELL_STATE_UNKNOWN) {
								GString* _tmp8_;
								_tmp8_ = sb;
								g_string_append (_tmp8_, "?" GNONOGRAMS_BLOCKSEPARATOR);
								count = 0;
							}
						}
						count_state = GNONOGRAMS_CELL_STATE_FILLED;
						_tmp9_ = count;
						count = _tmp9_ + 1;
						break;
					}
					case GNONOGRAMS_CELL_STATE_UNKNOWN:
					{
						if (count_state == GNONOGRAMS_CELL_STATE_UNDEFINED) {
							counting = TRUE;
						} else {
							if (count_state == GNONOGRAMS_CELL_STATE_FILLED) {
								GString* _tmp10_;
								gchar* _tmp11_;
								gchar* _tmp12_;
								gchar* _tmp13_;
								gchar* _tmp14_;
								_tmp10_ = sb;
								_tmp11_ = g_strdup_printf ("%i", count);
								_tmp12_ = _tmp11_;
								_tmp13_ = g_strconcat (_tmp12_, GNONOGRAMS_BLOCKSEPARATOR, NULL);
								_tmp14_ = _tmp13_;
								g_string_append (_tmp10_, _tmp14_);
								_g_free0 (_tmp14_);
								_g_free0 (_tmp12_);
								count = 0;
							}
						}
						count_state = GNONOGRAMS_CELL_STATE_UNKNOWN;
						break;
					}
					default:
					{
						gchar* _tmp15_;
						_tmp15_ = g_strdup (_ (GNONOGRAMS_BLANKLABELTEXT));
						result = _tmp15_;
						_g_string_free0 (sb);
						return result;
					}
				}
			}
		}
	}
	if (count_state == GNONOGRAMS_CELL_STATE_FILLED) {
		GString* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gint _tmp21_;
		_tmp16_ = sb;
		_tmp17_ = g_strdup_printf ("%i", count);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strconcat (_tmp18_, GNONOGRAMS_BLOCKSEPARATOR, NULL);
		_tmp20_ = _tmp19_;
		g_string_append (_tmp16_, _tmp20_);
		_g_free0 (_tmp20_);
		_g_free0 (_tmp18_);
		_tmp21_ = blocks;
		blocks = _tmp21_ + 1;
	} else {
		if (count_state == GNONOGRAMS_CELL_STATE_UNKNOWN) {
			GString* _tmp22_;
			gint _tmp23_;
			_tmp22_ = sb;
			g_string_append (_tmp22_, "?" GNONOGRAMS_BLOCKSEPARATOR);
			_tmp23_ = blocks;
			blocks = _tmp23_ + 1;
		}
	}
	if (blocks == 0) {
		GString* _tmp24_;
		_tmp24_ = sb;
		g_string_append (_tmp24_, "0");
	} else {
		GString* _tmp25_;
		GString* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		_tmp25_ = sb;
		_tmp26_ = sb;
		_tmp27_ = strlen (GNONOGRAMS_BLOCKSEPARATOR);
		_tmp28_ = _tmp27_;
		g_string_truncate (_tmp25_, (gsize) (_tmp26_->len - _tmp28_));
	}
	_tmp29_ = sb;
	_tmp30_ = _tmp29_->str;
	_tmp31_ = g_strdup (_tmp30_);
	result = _tmp31_;
	_g_string_free0 (sb);
	return result;
}

static void
_vala_array_add2 (GnonogramsCellState* * array,
                  gint* length,
                  gint* size,
                  GnonogramsCellState value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GnonogramsCellState, *array, *size);
	}
	(*array)[(*length)++] = value;
}

GnonogramsCellState*
gnonograms_utils_cellstate_array_from_string (const gchar* s,
                                              gint* result_length1)
{
	GnonogramsCellState* cs = NULL;
	GnonogramsCellState* _tmp0_;
	gint cs_length1;
	gint _cs_size_;
	gchar** blocks = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gint blocks_length1;
	gint _blocks_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GnonogramsCellState* _tmp10_;
	gint _tmp10__length1;
	GnonogramsCellState* result = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	_tmp0_ = g_new0 (GnonogramsCellState, 0);
	cs = _tmp0_;
	cs_length1 = 0;
	_cs_size_ = cs_length1;
	_tmp2_ = _tmp1_ = g_strsplit_set (s, GNONOGRAMS_BLOCKSEPARATOR, 0);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _vala_array_length (_tmp1_);
	_tmp5_ = gnonograms_utils_remove_blank_lines (_tmp3_, (gint) _vala_array_length (_tmp1_), &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp4_;
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	blocks = _tmp6_;
	blocks_length1 = _tmp6__length1;
	_blocks_size_ = blocks_length1;
	_tmp7_ = blocks;
	_tmp7__length1 = blocks_length1;
	{
		gchar** block_collection = NULL;
		gint block_collection_length1 = 0;
		gint _block_collection_size_ = 0;
		gint block_it = 0;
		block_collection = _tmp7_;
		block_collection_length1 = _tmp7__length1;
		for (block_it = 0; block_it < block_collection_length1; block_it = block_it + 1) {
			gchar* _tmp8_;
			gchar* block = NULL;
			_tmp8_ = g_strdup (block_collection[block_it]);
			block = _tmp8_;
			{
				const gchar* _tmp9_;
				_tmp9_ = block;
				_vala_array_add2 (&cs, &cs_length1, &_cs_size_, (GnonogramsCellState) CLAMP (atoi (_tmp9_), 0, (gint) GNONOGRAMS_CELL_STATE_UNDEFINED));
				_g_free0 (block);
			}
		}
	}
	_tmp10_ = cs;
	_tmp10__length1 = cs_length1;
	if (result_length1) {
		*result_length1 = _tmp10__length1;
	}
	result = _tmp10_;
	blocks = (_vala_array_free (blocks, blocks_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gchar*
gnonograms_utils_string_from_cellstate_array (GnonogramsCellState* cs,
                                              gint cs_length1)
{
	GString* sb = NULL;
	GString* _tmp0_;
	GString* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result = NULL;
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	{
		GnonogramsCellState* state_collection = NULL;
		gint state_collection_length1 = 0;
		gint _state_collection_size_ = 0;
		gint state_it = 0;
		state_collection = cs;
		state_collection_length1 = cs_length1;
		for (state_it = 0; state_it < state_collection_length1; state_it = state_it + 1) {
			guint state = 0U;
			state = (guint) state_collection[state_it];
			{
				GString* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				GString* _tmp4_;
				_tmp1_ = sb;
				_tmp2_ = g_strdup_printf ("%u", state);
				_tmp3_ = _tmp2_;
				g_string_append (_tmp1_, _tmp3_);
				_g_free0 (_tmp3_);
				_tmp4_ = sb;
				g_string_append (_tmp4_, " ");
			}
		}
	}
	_tmp5_ = sb;
	_tmp6_ = _tmp5_->str;
	_tmp7_ = g_strdup (_tmp6_);
	result = _tmp7_;
	_g_string_free0 (sb);
	return result;
}

gint
gnonograms_utils_show_dlg (const gchar* primary_text,
                           GtkMessageType type,
                           const gchar* secondary_text,
                           GtkWindow* parent)
{
	gchar* icon_name = NULL;
	gchar* _tmp0_;
	GtkButtonsType buttons = 0;
	const gchar* _tmp5_ = NULL;
	GraniteMessageDialog* dialog = NULL;
	const gchar* _tmp6_;
	GraniteMessageDialog* _tmp7_;
	GraniteMessageDialog* _tmp8_;
	GraniteMessageDialog* _tmp12_;
	gint response = 0;
	GraniteMessageDialog* _tmp13_;
	GraniteMessageDialog* _tmp14_;
	gint result = 0;
	g_return_val_if_fail (primary_text != NULL, 0);
	_tmp0_ = g_strdup ("");
	icon_name = _tmp0_;
	buttons = GTK_BUTTONS_CLOSE;
	switch (type) {
		case GTK_MESSAGE_INFO:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("dialog-information");
			_g_free0 (icon_name);
			icon_name = _tmp1_;
			break;
		}
		case GTK_MESSAGE_WARNING:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("dialog-warning");
			_g_free0 (icon_name);
			icon_name = _tmp2_;
			break;
		}
		case GTK_MESSAGE_ERROR:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("dialog-error");
			_g_free0 (icon_name);
			icon_name = _tmp3_;
			break;
		}
		case GTK_MESSAGE_QUESTION:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("dialog-question");
			_g_free0 (icon_name);
			icon_name = _tmp4_;
			buttons = GTK_BUTTONS_NONE;
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	_tmp5_ = secondary_text;
	if (_tmp5_ == NULL) {
		_tmp5_ = "";
	}
	_tmp6_ = icon_name;
	_tmp7_ = granite_message_dialog_new_with_image_from_icon_name (primary_text, _tmp5_, _tmp6_, buttons);
	g_object_ref_sink (_tmp7_);
	dialog = _tmp7_;
	_tmp8_ = dialog;
	gtk_window_set_transient_for ((GtkWindow*) _tmp8_, parent);
	if (type == GTK_MESSAGE_QUESTION) {
		GraniteMessageDialog* _tmp9_;
		GraniteMessageDialog* _tmp10_;
		GraniteMessageDialog* _tmp11_;
		_tmp9_ = dialog;
		gtk_dialog_add_button ((GtkDialog*) _tmp9_, "YES", (gint) GTK_RESPONSE_YES);
		_tmp10_ = dialog;
		gtk_dialog_add_button ((GtkDialog*) _tmp10_, "NO", (gint) GTK_RESPONSE_NO);
		_tmp11_ = dialog;
		gtk_dialog_set_default_response ((GtkDialog*) _tmp11_, (gint) GTK_RESPONSE_NO);
	}
	_tmp12_ = dialog;
	gtk_window_set_position ((GtkWindow*) _tmp12_, GTK_WIN_POS_MOUSE);
	_tmp13_ = dialog;
	response = gtk_dialog_run ((GtkDialog*) _tmp13_);
	_tmp14_ = dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp14_);
	result = response;
	_g_object_unref0 (dialog);
	_g_free0 (icon_name);
	return result;
}

void
gnonograms_utils_show_error_dialog (const gchar* primary_text,
                                    const gchar* secondary_text,
                                    GtkWindow* parent)
{
	g_return_if_fail (primary_text != NULL);
	gnonograms_utils_show_dlg (primary_text, GTK_MESSAGE_ERROR, secondary_text, parent);
}

gboolean
gnonograms_utils_show_confirm_dialog (const gchar* primary_text,
                                      const gchar* secondary_text,
                                      GtkWindow* parent)
{
	gint response = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (primary_text != NULL, FALSE);
	response = gnonograms_utils_show_dlg (primary_text, GTK_MESSAGE_QUESTION, secondary_text, parent);
	result = response == ((gint) GTK_RESPONSE_YES);
	return result;
}

/** The @action parameter also indicates the default setting for saving the solution.
      * The user selected option is returned in @save_solution.
     **/
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gchar*
gnonograms_utils_get_file_path (GtkWindow* parent,
                                GnonogramsFileChooserAction action,
                                const gchar* dialogname,
                                GnonogramsFilterInfo* filters,
                                gint filters_length1,
                                const gchar* start_path,
                                gboolean* save_solution)
{
	gboolean _vala_save_solution = FALSE;
	gchar* file_path = NULL;
	gchar* button_label = NULL;
	gchar* _tmp0_;
	GtkFileChooserAction gtk_action = 0;
	GtkFileChooserDialog* dialog = NULL;
	const gchar* _tmp4_;
	GtkFileChooserDialog* _tmp5_;
	GtkFileChooserDialog* _tmp20_;
	GtkSwitch* save_solution_switch = NULL;
	GtkFileChooserDialog* _tmp36_;
	gint response = 0;
	GtkFileChooserDialog* _tmp37_;
	GtkFileChooserDialog* _tmp51_;
	gboolean _tmp52_ = FALSE;
	gchar* result = NULL;
	g_return_val_if_fail (dialogname != NULL, NULL);
	file_path = NULL;
	_vala_save_solution = action == GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION;
	_tmp0_ = g_strdup ("Error");
	button_label = _tmp0_;
	gtk_action = GTK_FILE_CHOOSER_ACTION_SAVE;
	switch (action) {
		case GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN:
		{
			gchar* _tmp1_;
			gtk_action = GTK_FILE_CHOOSER_ACTION_OPEN;
			_tmp1_ = g_strdup (_ ("Open"));
			_g_free0 (button_label);
			button_label = _tmp1_;
			break;
		}
		case GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION:
		case GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_NO_SOLUTION:
		{
			gchar* _tmp2_;
			gtk_action = GTK_FILE_CHOOSER_ACTION_SAVE;
			_tmp2_ = g_strdup (_ ("Save"));
			_g_free0 (button_label);
			button_label = _tmp2_;
			break;
		}
		case GNONOGRAMS_FILE_CHOOSER_ACTION_SELECT_FOLDER:
		{
			gchar* _tmp3_;
			gtk_action = GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER;
			_tmp3_ = g_strdup (_ ("Apply"));
			_g_free0 (button_label);
			button_label = _tmp3_;
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp4_ = button_label;
	_tmp5_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (dialogname, parent, gtk_action, _ ("Cancel"), GTK_RESPONSE_CANCEL, _tmp4_, GTK_RESPONSE_ACCEPT, NULL, NULL);
	g_object_ref_sink (_tmp5_);
	dialog = _tmp5_;
	{
		GnonogramsFilterInfo* info_collection = NULL;
		gint info_collection_length1 = 0;
		gint _info_collection_size_ = 0;
		gint info_it = 0;
		info_collection = filters;
		info_collection_length1 = filters_length1;
		for (info_it = 0; info_it < info_collection_length1; info_it = info_it + 1) {
			GnonogramsFilterInfo _tmp6_;
			GnonogramsFilterInfo _tmp7_ = {0};
			GnonogramsFilterInfo info = {0};
			_tmp6_ = info_collection[info_it];
			gnonograms_filter_info_copy (&_tmp6_, &_tmp7_);
			info = _tmp7_;
			{
				GtkFileFilter* fc = NULL;
				GtkFileFilter* _tmp8_;
				GtkFileFilter* _tmp9_;
				GnonogramsFilterInfo _tmp10_;
				const gchar* _tmp11_;
				GnonogramsFilterInfo _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				GtkFileChooserDialog* _tmp17_;
				GtkFileFilter* _tmp18_;
				GtkFileFilter* _tmp19_;
				_tmp8_ = gtk_file_filter_new ();
				g_object_ref_sink (_tmp8_);
				fc = _tmp8_;
				_tmp9_ = fc;
				_tmp10_ = info;
				_tmp11_ = _tmp10_.name;
				gtk_file_filter_set_name (_tmp9_, _tmp11_);
				_tmp12_ = info;
				_tmp13_ = _tmp12_.patterns;
				_tmp13__length1 = _tmp12_.patterns_length1;
				{
					gchar** pattern_collection = NULL;
					gint pattern_collection_length1 = 0;
					gint _pattern_collection_size_ = 0;
					gint pattern_it = 0;
					pattern_collection = _tmp13_;
					pattern_collection_length1 = _tmp13__length1;
					for (pattern_it = 0; pattern_it < pattern_collection_length1; pattern_it = pattern_it + 1) {
						gchar* _tmp14_;
						gchar* pattern = NULL;
						_tmp14_ = g_strdup (pattern_collection[pattern_it]);
						pattern = _tmp14_;
						{
							GtkFileFilter* _tmp15_;
							const gchar* _tmp16_;
							_tmp15_ = fc;
							_tmp16_ = pattern;
							gtk_file_filter_add_pattern (_tmp15_, _tmp16_);
							_g_free0 (pattern);
						}
					}
				}
				_tmp17_ = dialog;
				_tmp18_ = fc;
				_tmp19_ = _g_object_ref0 (_tmp18_);
				gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp17_, _tmp19_);
				_g_object_unref0 (fc);
				gnonograms_filter_info_destroy (&info);
			}
		}
	}
	_tmp20_ = dialog;
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp20_, FALSE);
	save_solution_switch = NULL;
	if (action != GNONOGRAMS_FILE_CHOOSER_ACTION_OPEN) {
		GtkGrid* grid = NULL;
		GtkGrid* _tmp21_;
		GtkGrid* _tmp22_;
		GtkGrid* _tmp23_;
		GtkFileChooserDialog* _tmp31_;
		GtkBox* _tmp32_;
		GtkGrid* _tmp33_;
		GtkGrid* _tmp34_;
		_tmp21_ = (GtkGrid*) gtk_grid_new ();
		g_object_ref_sink (_tmp21_);
		grid = _tmp21_;
		_tmp22_ = grid;
		gtk_orientable_set_orientation ((GtkOrientable*) _tmp22_, GTK_ORIENTATION_HORIZONTAL);
		_tmp23_ = grid;
		gtk_grid_set_column_spacing (_tmp23_, 6);
		if (action == GNONOGRAMS_FILE_CHOOSER_ACTION_SAVE_WITH_SOLUTION) {
			GtkSwitch* _tmp24_;
			GtkSwitch* _tmp25_;
			GtkLabel* save_solution_label = NULL;
			GtkLabel* _tmp26_;
			GtkGrid* _tmp27_;
			GtkLabel* _tmp28_;
			GtkGrid* _tmp29_;
			GtkSwitch* _tmp30_;
			_tmp24_ = (GtkSwitch*) gtk_switch_new ();
			g_object_ref_sink (_tmp24_);
			_g_object_unref0 (save_solution_switch);
			save_solution_switch = _tmp24_;
			_tmp25_ = save_solution_switch;
			gtk_switch_set_state (_tmp25_, _vala_save_solution);
			_tmp26_ = (GtkLabel*) gtk_label_new (_ ("Save solution too"));
			g_object_ref_sink (_tmp26_);
			save_solution_label = _tmp26_;
			_tmp27_ = grid;
			_tmp28_ = save_solution_label;
			gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
			_tmp29_ = grid;
			_tmp30_ = save_solution_switch;
			gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
			_g_object_unref0 (save_solution_label);
		}
		_tmp31_ = dialog;
		_tmp32_ = gtk_dialog_get_action_area ((GtkDialog*) _tmp31_);
		_tmp33_ = grid;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_container_get_type (), GtkContainer), (GtkWidget*) _tmp33_);
		_tmp34_ = grid;
		gtk_widget_show_all ((GtkWidget*) _tmp34_);
		_g_object_unref0 (grid);
	}
	if (start_path == NULL) {
		const gchar* _tmp35_;
		_tmp35_ = g_get_home_dir ();
		start_path = _tmp35_;
	}
	_tmp36_ = dialog;
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp36_, "/home/jeremy/Templates");
	_tmp37_ = dialog;
	response = gtk_dialog_run ((GtkDialog*) _tmp37_);
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkSwitch* _tmp47_;
		if (gtk_action == GTK_FILE_CHOOSER_ACTION_SAVE) {
			GtkFileChooserDialog* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			GtkFileChooserDialog* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			_tmp38_ = dialog;
			_tmp39_ = gtk_file_chooser_get_current_folder ((GtkFileChooser*) _tmp38_);
			_tmp40_ = _tmp39_;
			_tmp41_ = dialog;
			_tmp42_ = gtk_file_chooser_get_current_name ((GtkFileChooser*) _tmp41_);
			_tmp43_ = _tmp42_;
			_tmp44_ = g_build_path (G_DIR_SEPARATOR_S, _tmp40_, _tmp43_, NULL);
			_g_free0 (file_path);
			file_path = _tmp44_;
			_g_free0 (_tmp43_);
			_g_free0 (_tmp40_);
		} else {
			GtkFileChooserDialog* _tmp45_;
			gchar* _tmp46_;
			_tmp45_ = dialog;
			_tmp46_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp45_);
			_g_free0 (file_path);
			file_path = _tmp46_;
		}
		_tmp47_ = save_solution_switch;
		if (_tmp47_ != NULL) {
			GtkSwitch* _tmp48_;
			gboolean _tmp49_;
			gboolean _tmp50_;
			_tmp48_ = save_solution_switch;
			_tmp49_ = gtk_switch_get_state (_tmp48_);
			_tmp50_ = _tmp49_;
			_vala_save_solution = _tmp50_;
		}
	}
	_tmp51_ = dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp51_);
	if (gtk_action == GTK_FILE_CHOOSER_ACTION_SAVE) {
		const gchar* _tmp53_;
		_tmp53_ = file_path;
		_tmp52_ = _tmp53_ != NULL;
	} else {
		_tmp52_ = FALSE;
	}
	if (_tmp52_) {
		GFile* file = NULL;
		const gchar* _tmp54_;
		GFile* _tmp55_;
		gboolean _tmp56_ = FALSE;
		GFile* _tmp57_;
		_tmp54_ = file_path;
		_tmp55_ = g_file_new_for_commandline_arg (_tmp54_);
		file = _tmp55_;
		_tmp57_ = file;
		if (g_file_query_exists (_tmp57_, NULL)) {
			const gchar* _tmp58_;
			gchar* _tmp59_;
			gchar* _tmp60_;
			_tmp58_ = file_path;
			_tmp59_ = g_strdup_printf (_ ("Overwrite %s"), _tmp58_);
			_tmp60_ = _tmp59_;
			_tmp56_ = !gnonograms_utils_show_confirm_dialog (_tmp60_, _ ("This action will destroy contents of that file"), NULL);
			_g_free0 (_tmp60_);
		} else {
			_tmp56_ = FALSE;
		}
		if (_tmp56_) {
			_g_free0 (file_path);
			file_path = NULL;
		}
		_g_object_unref0 (file);
	}
	result = file_path;
	_g_object_unref0 (save_solution_switch);
	_g_object_unref0 (dialog);
	_g_free0 (button_label);
	if (save_solution) {
		*save_solution = _vala_save_solution;
	}
	return result;
}

void
gnonograms_utils_get_monitor_area (GdkScreen* screen,
                                   GdkWindow* window,
                                   GdkRectangle* result)
{
	GdkRectangle rect = {0};
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkMonitor* monitor = NULL;
	GdkMonitor* _tmp2_;
	GdkMonitor* _tmp3_;
	GdkRectangle _tmp4_ = {0};
	g_return_if_fail (screen != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	display = _tmp1_;
	_tmp2_ = gdk_display_get_monitor_at_window (display, window);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	monitor = _tmp3_;
	gdk_monitor_get_geometry (monitor, &_tmp4_);
	rect = _tmp4_;
	*result = rect;
	_g_object_unref0 (monitor);
	_g_object_unref0 (display);
	return;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

