/* Labelbox.c generated by valac 0.54.6, the Vala compiler
 * generated from Labelbox.vala, do not modify */

/* Holds all row or column clues for gnonograms
 * Copyright (C) 2010 - 2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gee.h>

#define GNONOGRAMS_TYPICAL_MAX_BLOCKS_RATIO 0.3
#define GNONOGRAMS_FONT_ASPECT_RATIO 1.2
#define GNONOGRAMS_BLANKLABELTEXT N_ ("?")
#define GNONOGRAMS_MAXSIZE ((guint) 50)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GNONOGRAMS_TYPE_LABEL_BOX (gnonograms_label_box_get_type ())
#define GNONOGRAMS_LABEL_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBox))
#define GNONOGRAMS_LABEL_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBoxClass))
#define GNONOGRAMS_IS_LABEL_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_LABEL_BOX))
#define GNONOGRAMS_IS_LABEL_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_LABEL_BOX))
#define GNONOGRAMS_LABEL_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBoxClass))

typedef struct _GnonogramsLabelBox GnonogramsLabelBox;
typedef struct _GnonogramsLabelBoxClass GnonogramsLabelBoxClass;
typedef struct _GnonogramsLabelBoxPrivate GnonogramsLabelBoxPrivate;

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;

#define GNONOGRAMS_TYPE_CLUE (gnonograms_clue_get_type ())
#define GNONOGRAMS_CLUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CLUE, GnonogramsClue))
#define GNONOGRAMS_CLUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CLUE, GnonogramsClueClass))
#define GNONOGRAMS_IS_CLUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CLUE))
#define GNONOGRAMS_IS_CLUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CLUE))
#define GNONOGRAMS_CLUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CLUE, GnonogramsClueClass))

typedef struct _GnonogramsClue GnonogramsClue;
typedef struct _GnonogramsClueClass GnonogramsClueClass;
enum  {
	GNONOGRAMS_LABEL_BOX_0_PROPERTY,
	GNONOGRAMS_LABEL_BOX_ATTACH_POSITION_PROPERTY,
	GNONOGRAMS_LABEL_BOX_VERTICAL_LABELS_PROPERTY,
	GNONOGRAMS_LABEL_BOX_DIMENSIONS_PROPERTY,
	GNONOGRAMS_LABEL_BOX_MIN_WIDTH_PROPERTY,
	GNONOGRAMS_LABEL_BOX_MIN_HEIGHT_PROPERTY,
	GNONOGRAMS_LABEL_BOX_FONTHEIGHT_PROPERTY,
	GNONOGRAMS_LABEL_BOX_NUM_PROPERTIES
};
static GParamSpec* gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GNONOGRAMS_TYPE_BLOCK (gnonograms_block_get_type ())
#define GNONOGRAMS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock))
#define GNONOGRAMS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))
#define GNONOGRAMS_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))

typedef struct _GnonogramsBlock GnonogramsBlock;
typedef struct _GnonogramsBlockClass GnonogramsBlockClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GnonogramsLabelBox {
	GtkGrid parent_instance;
	GnonogramsLabelBoxPrivate * priv;
};

struct _GnonogramsLabelBoxClass {
	GtkGridClass parent_class;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsLabelBoxPrivate {
	GnonogramsDimensions _dimensions;
	gint _min_width;
	gint _min_height;
	gdouble _fontheight;
	GnonogramsClue** labels;
	gint labels_length1;
	gint _labels_size_;
	gint size;
	gint other_size;
};

static gint GnonogramsLabelBox_private_offset;
static gpointer gnonograms_label_box_parent_class = NULL;

VALA_EXTERN GType gnonograms_label_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsLabelBox, g_object_unref)
VALA_EXTERN GType gnonograms_dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_dimensions_free (GnonogramsDimensions* self);
VALA_EXTERN GType gnonograms_clue_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsClue, g_object_unref)
VALA_EXTERN GnonogramsLabelBox* gnonograms_label_box_new (GtkOrientation _orientation);
VALA_EXTERN GnonogramsLabelBox* gnonograms_label_box_construct (GType object_type,
                                                    GtkOrientation _orientation);
static void gnonograms_label_box_recalc_size (GnonogramsLabelBox* self);
VALA_EXTERN void gnonograms_label_box_get_dimensions (GnonogramsLabelBox* self,
                                          GnonogramsDimensions * result);
VALA_EXTERN guint gnonograms_dimensions_rows (GnonogramsDimensions *self);
VALA_EXTERN guint gnonograms_dimensions_cols (GnonogramsDimensions *self);
VALA_EXTERN gdouble gnonograms_label_box_get_fontheight (GnonogramsLabelBox* self);
VALA_EXTERN gboolean gnonograms_label_box_get_vertical_labels (GnonogramsLabelBox* self);
static void gnonograms_label_box_set_min_width (GnonogramsLabelBox* self,
                                         gint value);
static void gnonograms_label_box_set_min_height (GnonogramsLabelBox* self,
                                          gint value);
VALA_EXTERN void gnonograms_label_box_highlight (GnonogramsLabelBox* self,
                                     guint index,
                                     gboolean is_highlight);
VALA_EXTERN void gnonograms_clue_highlight (GnonogramsClue* self,
                                gboolean is_highlight);
VALA_EXTERN void gnonograms_label_box_unhighlight_all (GnonogramsLabelBox* self);
VALA_EXTERN void gnonograms_label_box_update_label_text (GnonogramsLabelBox* self,
                                             guint index,
                                             const gchar* txt);
VALA_EXTERN void gnonograms_clue_set_clue (GnonogramsClue* self,
                               const gchar* value);
VALA_EXTERN void gnonograms_label_box_clear_formatting (GnonogramsLabelBox* self,
                                            guint index);
VALA_EXTERN void gnonograms_clue_clear_formatting (GnonogramsClue* self);
VALA_EXTERN gpointer gnonograms_block_ref (gpointer instance);
VALA_EXTERN void gnonograms_block_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_block (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_block (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void gnonograms_value_take_block (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_block (const GValue* value);
VALA_EXTERN GType gnonograms_block_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsBlock, gnonograms_block_unref)
VALA_EXTERN void gnonograms_label_box_update_label_complete (GnonogramsLabelBox* self,
                                                 guint index,
                                                 GeeList* grid_blocks);
VALA_EXTERN void gnonograms_clue_update_complete (GnonogramsClue* self,
                                      GeeList* _grid_blocks);
static GnonogramsClue* gnonograms_label_box_new_label (GnonogramsLabelBox* self,
                                                gboolean vertical);
VALA_EXTERN GnonogramsClue* gnonograms_clue_new (gboolean _vertical_text);
VALA_EXTERN GnonogramsClue* gnonograms_clue_construct (GType object_type,
                                           gboolean _vertical_text);
VALA_EXTERN void gnonograms_clue_set_size (GnonogramsClue* self,
                               guint value);
VALA_EXTERN void gnonograms_clue_set_fontheight (GnonogramsClue* self,
                                     gdouble value);
static void gnonograms_label_box_resize (GnonogramsLabelBox* self,
                                  GnonogramsDimensions* dimensions);
VALA_EXTERN GtkPositionType gnonograms_label_box_get_attach_position (GnonogramsLabelBox* self);
static void gnonograms_label_box_real_get_preferred_width (GtkWidget* base,
                                                    gint* _min_width,
                                                    gint* _nat_width);
VALA_EXTERN gint gnonograms_label_box_get_min_width (GnonogramsLabelBox* self);
static void gnonograms_label_box_real_get_preferred_height (GtkWidget* base,
                                                     gint* _min_height,
                                                     gint* _nat_height);
VALA_EXTERN gint gnonograms_label_box_get_min_height (GnonogramsLabelBox* self);
VALA_EXTERN void gnonograms_label_box_set_dimensions (GnonogramsLabelBox* self,
                                          GnonogramsDimensions * value);
static gboolean _gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                                       const GnonogramsDimensions * s2);
VALA_EXTERN void gnonograms_label_box_set_fontheight (GnonogramsLabelBox* self,
                                          gdouble value);
static GObject * gnonograms_label_box_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _gnonograms_label_box___lambda8_ (GnonogramsLabelBox* self);
static void __gnonograms_label_box___lambda8__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void _gnonograms_label_box___lambda9_ (GnonogramsLabelBox* self);
static void __gnonograms_label_box___lambda9__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void gnonograms_label_box_finalize (GObject * obj);
static GType gnonograms_label_box_get_type_once (void);
static void _vala_gnonograms_label_box_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_gnonograms_label_box_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
gnonograms_label_box_get_instance_private (GnonogramsLabelBox* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsLabelBox_private_offset);
}

GnonogramsLabelBox*
gnonograms_label_box_construct (GType object_type,
                                GtkOrientation _orientation)
{
	GnonogramsLabelBox * self = NULL;
	self = (GnonogramsLabelBox*) g_object_new (object_type, "column-homogeneous", TRUE, "row-homogeneous", TRUE, "column-spacing", 0, "row-spacing", 0, "orientation", _orientation, NULL);
	return self;
}

GnonogramsLabelBox*
gnonograms_label_box_new (GtkOrientation _orientation)
{
	return gnonograms_label_box_construct (GNONOGRAMS_TYPE_LABEL_BOX, _orientation);
}

static void
gnonograms_label_box_recalc_size (GnonogramsLabelBox* self)
{
	guint r = 0U;
	GnonogramsDimensions _tmp0_;
	guint c = 0U;
	GnonogramsDimensions _tmp1_;
	gdouble cell = 0.0;
	gdouble _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	if (self->priv->size < 1) {
		return;
	}
	_tmp0_ = self->priv->_dimensions;
	r = gnonograms_dimensions_rows (&_tmp0_);
	_tmp1_ = self->priv->_dimensions;
	c = gnonograms_dimensions_cols (&_tmp1_);
	_tmp2_ = self->priv->_fontheight;
	cell = 2 * _tmp2_;
	_tmp3_ = gnonograms_label_box_get_vertical_labels (self);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		gnonograms_label_box_set_min_width (self, (gint) (c * cell));
		gnonograms_label_box_set_min_height (self, (gint) (((r * GNONOGRAMS_TYPICAL_MAX_BLOCKS_RATIO) * cell) * GNONOGRAMS_FONT_ASPECT_RATIO));
	} else {
		gnonograms_label_box_set_min_width (self, (gint) (((c * GNONOGRAMS_TYPICAL_MAX_BLOCKS_RATIO) * cell) / GNONOGRAMS_FONT_ASPECT_RATIO));
		gnonograms_label_box_set_min_height (self, (gint) (r * cell));
	}
}

void
gnonograms_label_box_highlight (GnonogramsLabelBox* self,
                                guint index,
                                gboolean is_highlight)
{
	GnonogramsClue** _tmp0_;
	gint _tmp0__length1;
	GnonogramsClue* _tmp1_;
	g_return_if_fail (self != NULL);
	if (index >= ((guint) self->priv->size)) {
		return;
	}
	_tmp0_ = self->priv->labels;
	_tmp0__length1 = self->priv->labels_length1;
	_tmp1_ = _tmp0_[index];
	gnonograms_clue_highlight (_tmp1_, is_highlight);
}

void
gnonograms_label_box_unhighlight_all (GnonogramsLabelBox* self)
{
	g_return_if_fail (self != NULL);
	{
		guint index = 0U;
		index = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsClue** _tmp2_;
				gint _tmp2__length1;
				GnonogramsClue* _tmp3_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = index;
					index = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(index < ((guint) self->priv->size))) {
					break;
				}
				_tmp2_ = self->priv->labels;
				_tmp2__length1 = self->priv->labels_length1;
				_tmp3_ = _tmp2_[index];
				gnonograms_clue_highlight (_tmp3_, FALSE);
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
gnonograms_label_box_update_label_text (GnonogramsLabelBox* self,
                                        guint index,
                                        const gchar* txt)
{
	GnonogramsClue* label = NULL;
	GnonogramsClue** _tmp0_;
	gint _tmp0__length1;
	GnonogramsClue* _tmp1_;
	GnonogramsClue* _tmp2_;
	GnonogramsClue* _tmp3_;
	g_return_if_fail (self != NULL);
	if (txt == NULL) {
		txt = _ (GNONOGRAMS_BLANKLABELTEXT);
	}
	_tmp0_ = self->priv->labels;
	_tmp0__length1 = self->priv->labels_length1;
	_tmp1_ = _tmp0_[index];
	_tmp2_ = _g_object_ref0 (_tmp1_);
	label = _tmp2_;
	_tmp3_ = label;
	if (_tmp3_ != NULL) {
		GnonogramsClue* _tmp4_;
		_tmp4_ = label;
		gnonograms_clue_set_clue (_tmp4_, txt);
	}
	_g_object_unref0 (label);
}

void
gnonograms_label_box_clear_formatting (GnonogramsLabelBox* self,
                                       guint index)
{
	GnonogramsClue* label = NULL;
	GnonogramsClue** _tmp0_;
	gint _tmp0__length1;
	GnonogramsClue* _tmp1_;
	GnonogramsClue* _tmp2_;
	GnonogramsClue* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->labels;
	_tmp0__length1 = self->priv->labels_length1;
	_tmp1_ = _tmp0_[index];
	_tmp2_ = _g_object_ref0 (_tmp1_);
	label = _tmp2_;
	_tmp3_ = label;
	if (_tmp3_ != NULL) {
		GnonogramsClue* _tmp4_;
		_tmp4_ = label;
		gnonograms_clue_clear_formatting (_tmp4_);
	}
	_g_object_unref0 (label);
}

void
gnonograms_label_box_update_label_complete (GnonogramsLabelBox* self,
                                            guint index,
                                            GeeList* grid_blocks)
{
	GnonogramsClue* label = NULL;
	GnonogramsClue** _tmp0_;
	gint _tmp0__length1;
	GnonogramsClue* _tmp1_;
	GnonogramsClue* _tmp2_;
	GnonogramsClue* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (grid_blocks != NULL);
	_tmp0_ = self->priv->labels;
	_tmp0__length1 = self->priv->labels_length1;
	_tmp1_ = _tmp0_[index];
	_tmp2_ = _g_object_ref0 (_tmp1_);
	label = _tmp2_;
	_tmp3_ = label;
	if (_tmp3_ != NULL) {
		GnonogramsClue* _tmp4_;
		_tmp4_ = label;
		gnonograms_clue_update_complete (_tmp4_, grid_blocks);
	}
	_g_object_unref0 (label);
}

static GnonogramsClue*
gnonograms_label_box_new_label (GnonogramsLabelBox* self,
                                gboolean vertical)
{
	GnonogramsClue* label = NULL;
	GnonogramsClue* _tmp0_;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GnonogramsClue* _tmp6_;
	GnonogramsClue* _tmp7_;
	GnonogramsClue* _tmp8_;
	GnonogramsClue* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gnonograms_clue_new (vertical);
	g_object_ref_sink (_tmp0_);
	label = _tmp0_;
	_tmp2_ = gnonograms_label_box_get_vertical_labels (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GnonogramsDimensions _tmp4_;
		_tmp4_ = self->priv->_dimensions;
		_tmp1_ = _tmp4_.height;
	} else {
		GnonogramsDimensions _tmp5_;
		_tmp5_ = self->priv->_dimensions;
		_tmp1_ = _tmp5_.width;
	}
	_tmp6_ = label;
	gnonograms_clue_set_size (_tmp6_, (guint) ((gint) _tmp1_));
	_tmp7_ = label;
	gnonograms_clue_set_fontheight (_tmp7_, self->priv->_fontheight);
	_tmp8_ = label;
	gtk_widget_show_all ((GtkWidget*) _tmp8_);
	result = label;
	return result;
}

static void
gnonograms_label_box_resize (GnonogramsLabelBox* self,
                             GnonogramsDimensions* dimensions)
{
	guint _tmp0_ = 0U;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint new_size = 0;
	guint _tmp5_ = 0U;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gint new_other_size = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dimensions != NULL);
	_vala_assert (self->priv->size >= 0, "size >= 0");
	gnonograms_label_box_unhighlight_all (self);
	_tmp1_ = gnonograms_label_box_get_vertical_labels (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GnonogramsDimensions _tmp3_;
		_tmp3_ = *dimensions;
		_tmp0_ = _tmp3_.width;
	} else {
		GnonogramsDimensions _tmp4_;
		_tmp4_ = *dimensions;
		_tmp0_ = _tmp4_.height;
	}
	new_size = (gint) _tmp0_;
	_tmp6_ = gnonograms_label_box_get_vertical_labels (self);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		GnonogramsDimensions _tmp8_;
		_tmp8_ = *dimensions;
		_tmp5_ = _tmp8_.height;
	} else {
		GnonogramsDimensions _tmp9_;
		_tmp9_ = *dimensions;
		_tmp5_ = _tmp9_.width;
	}
	new_other_size = (gint) _tmp5_;
	while (TRUE) {
		GnonogramsClue* label = NULL;
		gboolean _tmp10_;
		gboolean _tmp11_;
		GnonogramsClue* _tmp12_;
		GnonogramsClue** _tmp21_;
		gint _tmp21__length1;
		GnonogramsClue* _tmp22_;
		GnonogramsClue* _tmp23_;
		gint _tmp24_;
		if (!(self->priv->size < new_size)) {
			break;
		}
		_tmp10_ = gnonograms_label_box_get_vertical_labels (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = gnonograms_label_box_new_label (self, _tmp11_);
		label = _tmp12_;
		if (self->priv->size > 0) {
			GnonogramsClue* last_label = NULL;
			GnonogramsClue** _tmp13_;
			gint _tmp13__length1;
			GnonogramsClue* _tmp14_;
			GnonogramsClue* _tmp15_;
			GnonogramsClue* _tmp16_;
			GnonogramsClue* _tmp17_;
			GtkPositionType _tmp18_;
			GtkPositionType _tmp19_;
			_tmp13_ = self->priv->labels;
			_tmp13__length1 = self->priv->labels_length1;
			_tmp14_ = _tmp13_[self->priv->size - 1];
			_tmp15_ = _g_object_ref0 (_tmp14_);
			last_label = _tmp15_;
			_tmp16_ = label;
			_tmp17_ = last_label;
			_tmp18_ = gnonograms_label_box_get_attach_position (self);
			_tmp19_ = _tmp18_;
			gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp16_, (GtkWidget*) _tmp17_, _tmp19_, 1, 1);
			_g_object_unref0 (last_label);
		} else {
			GnonogramsClue* _tmp20_;
			_tmp20_ = label;
			gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp20_, 0, 0, 1, 1);
		}
		_tmp21_ = self->priv->labels;
		_tmp21__length1 = self->priv->labels_length1;
		_tmp22_ = label;
		_tmp23_ = _g_object_ref0 (_tmp22_);
		_g_object_unref0 (_tmp21_[self->priv->size]);
		_tmp21_[self->priv->size] = _tmp23_;
		_tmp24_ = self->priv->size;
		self->priv->size = _tmp24_ + 1;
		_g_object_unref0 (label);
	}
	while (TRUE) {
		gboolean _tmp25_;
		gboolean _tmp26_;
		gint _tmp27_;
		if (!(self->priv->size > new_size)) {
			break;
		}
		_tmp25_ = gnonograms_label_box_get_vertical_labels (self);
		_tmp26_ = _tmp25_;
		if (_tmp26_) {
			gtk_grid_remove_column ((GtkGrid*) self, self->priv->size - 1);
		} else {
			gtk_grid_remove_row ((GtkGrid*) self, self->priv->size - 1);
		}
		_tmp27_ = self->priv->size;
		self->priv->size = _tmp27_ - 1;
	}
	self->priv->size = new_size;
	self->priv->other_size = new_other_size;
	{
		guint index = 0U;
		index = (guint) 0;
		{
			gboolean _tmp28_ = FALSE;
			_tmp28_ = TRUE;
			while (TRUE) {
				GnonogramsClue** _tmp30_;
				gint _tmp30__length1;
				GnonogramsClue* _tmp31_;
				if (!_tmp28_) {
					guint _tmp29_;
					_tmp29_ = index;
					index = _tmp29_ + 1;
				}
				_tmp28_ = FALSE;
				if (!(index < ((guint) self->priv->size))) {
					break;
				}
				_tmp30_ = self->priv->labels;
				_tmp30__length1 = self->priv->labels_length1;
				_tmp31_ = _tmp30_[index];
				gnonograms_clue_set_size (_tmp31_, (guint) self->priv->other_size);
			}
		}
	}
	{
		guint index = 0U;
		index = (guint) 0;
		{
			gboolean _tmp32_ = FALSE;
			_tmp32_ = TRUE;
			while (TRUE) {
				GnonogramsClue** _tmp34_;
				gint _tmp34__length1;
				GnonogramsClue* _tmp35_;
				if (!_tmp32_) {
					guint _tmp33_;
					_tmp33_ = index;
					index = _tmp33_ + 1;
				}
				_tmp32_ = FALSE;
				if (!(index < ((guint) self->priv->size))) {
					break;
				}
				_tmp34_ = self->priv->labels;
				_tmp34__length1 = self->priv->labels_length1;
				_tmp35_ = _tmp34_[index];
				gnonograms_clue_set_clue (_tmp35_, "0");
			}
		}
	}
}

static void
gnonograms_label_box_real_get_preferred_width (GtkWidget* base,
                                               gint* _min_width,
                                               gint* _nat_width)
{
	GnonogramsLabelBox * self;
	gint _vala__min_width = 0;
	gint _vala__nat_width = 0;
	gint _tmp0_;
	gint _tmp1_;
	self = (GnonogramsLabelBox*) base;
	_tmp0_ = self->priv->_min_width;
	_vala__min_width = _tmp0_;
	_tmp1_ = self->priv->_min_width;
	_vala__nat_width = _tmp1_;
	if (_min_width) {
		*_min_width = _vala__min_width;
	}
	if (_nat_width) {
		*_nat_width = _vala__nat_width;
	}
}

static void
gnonograms_label_box_real_get_preferred_height (GtkWidget* base,
                                                gint* _min_height,
                                                gint* _nat_height)
{
	GnonogramsLabelBox * self;
	gint _vala__min_height = 0;
	gint _vala__nat_height = 0;
	gint _tmp0_;
	gint _tmp1_;
	self = (GnonogramsLabelBox*) base;
	_tmp0_ = self->priv->_min_height;
	_vala__min_height = _tmp0_;
	_tmp1_ = self->priv->_min_height;
	_vala__nat_height = _tmp1_;
	if (_min_height) {
		*_min_height = _vala__min_height;
	}
	if (_nat_height) {
		*_nat_height = _vala__nat_height;
	}
}

GtkPositionType
gnonograms_label_box_get_attach_position (GnonogramsLabelBox* self)
{
	GtkPositionType result;
	GtkOrientation _tmp0_;
	GtkOrientation _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = gtk_orientable_get_orientation ((GtkOrientable*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == GTK_ORIENTATION_HORIZONTAL) {
		result = GTK_POS_RIGHT;
		return result;
	} else {
		result = GTK_POS_BOTTOM;
		return result;
	}
}

gboolean
gnonograms_label_box_get_vertical_labels (GnonogramsLabelBox* self)
{
	gboolean result;
	GtkOrientation _tmp0_;
	GtkOrientation _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_orientable_get_orientation ((GtkOrientable*) self);
	_tmp1_ = _tmp0_;
	result = _tmp1_ == GTK_ORIENTATION_HORIZONTAL;
	return result;
}

void
gnonograms_label_box_get_dimensions (GnonogramsLabelBox* self,
                                     GnonogramsDimensions * result)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_dimensions;
	*result = _tmp0_;
	return;
}

static gboolean
_gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                              const GnonogramsDimensions * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->width != s2->width) {
		return FALSE;
	}
	if (s1->height != s2->height) {
		return FALSE;
	}
	return TRUE;
}

void
gnonograms_label_box_set_dimensions (GnonogramsLabelBox* self,
                                     GnonogramsDimensions * value)
{
	GnonogramsDimensions old_value;
	g_return_if_fail (self != NULL);
	gnonograms_label_box_get_dimensions (self, &old_value);
	if (_gnonograms_dimensions_equal (value, &old_value) != TRUE) {
		GnonogramsDimensions _tmp0_;
		_tmp0_ = *value;
		self->priv->_dimensions = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_DIMENSIONS_PROPERTY]);
	}
}

gint
gnonograms_label_box_get_min_width (GnonogramsLabelBox* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_min_width;
	return result;
}

static void
gnonograms_label_box_set_min_width (GnonogramsLabelBox* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_label_box_get_min_width (self);
	if (old_value != value) {
		self->priv->_min_width = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_MIN_WIDTH_PROPERTY]);
	}
}

gint
gnonograms_label_box_get_min_height (GnonogramsLabelBox* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_min_height;
	return result;
}

static void
gnonograms_label_box_set_min_height (GnonogramsLabelBox* self,
                                     gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_label_box_get_min_height (self);
	if (old_value != value) {
		self->priv->_min_height = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_MIN_HEIGHT_PROPERTY]);
	}
}

gdouble
gnonograms_label_box_get_fontheight (GnonogramsLabelBox* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_fontheight;
	return result;
}

void
gnonograms_label_box_set_fontheight (GnonogramsLabelBox* self,
                                     gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_label_box_get_fontheight (self);
	if (old_value != value) {
		self->priv->_fontheight = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_FONTHEIGHT_PROPERTY]);
	}
}

static void
_gnonograms_label_box___lambda8_ (GnonogramsLabelBox* self)
{
	{
		guint index = 0U;
		index = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GnonogramsClue** _tmp2_;
				gint _tmp2__length1;
				GnonogramsClue* _tmp3_;
				gdouble _tmp4_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = index;
					index = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(index < ((guint) self->priv->size))) {
					break;
				}
				_tmp2_ = self->priv->labels;
				_tmp2__length1 = self->priv->labels_length1;
				_tmp3_ = _tmp2_[index];
				_tmp4_ = self->priv->_fontheight;
				gnonograms_clue_set_fontheight (_tmp3_, _tmp4_);
			}
		}
	}
	gnonograms_label_box_recalc_size (self);
}

static void
__gnonograms_label_box___lambda8__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
	_gnonograms_label_box___lambda8_ ((GnonogramsLabelBox*) self);
}

static void
_gnonograms_label_box___lambda9_ (GnonogramsLabelBox* self)
{
	GnonogramsDimensions _tmp0_;
	_tmp0_ = self->priv->_dimensions;
	gnonograms_label_box_resize (self, &_tmp0_);
	gnonograms_label_box_recalc_size (self);
}

static void
__gnonograms_label_box___lambda9__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
	_gnonograms_label_box___lambda9_ ((GnonogramsLabelBox*) self);
}

static GObject *
gnonograms_label_box_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsLabelBox * self;
	GnonogramsClue** _tmp0_;
	parent_class = G_OBJECT_CLASS (gnonograms_label_box_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBox);
	_tmp0_ = g_new0 (GnonogramsClue*, GNONOGRAMS_MAXSIZE + 1);
	self->priv->labels = (_vala_array_free (self->priv->labels, self->priv->labels_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->labels = _tmp0_;
	self->priv->labels_length1 = GNONOGRAMS_MAXSIZE;
	self->priv->_labels_size_ = self->priv->labels_length1;
	self->priv->size = 0;
	gtk_grid_set_row_spacing ((GtkGrid*) self, 0);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 0);
	gnonograms_label_box_set_min_width (self, 0);
	gnonograms_label_box_set_min_height (self, 0);
	g_signal_connect_object ((GObject*) self, "notify::fontheight", (GCallback) __gnonograms_label_box___lambda8__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::dimensions", (GCallback) __gnonograms_label_box___lambda9__g_object_notify, self, 0);
	return obj;
}

static void
gnonograms_label_box_class_init (GnonogramsLabelBoxClass * klass,
                                 gpointer klass_data)
{
	gnonograms_label_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsLabelBox_private_offset);
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) gnonograms_label_box_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) gnonograms_label_box_real_get_preferred_height;
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_label_box_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_label_box_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_label_box_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_label_box_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_LABEL_BOX_ATTACH_POSITION_PROPERTY, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_ATTACH_POSITION_PROPERTY] = g_param_spec_enum ("attach-position", "attach-position", "attach-position", gtk_position_type_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_LABEL_BOX_VERTICAL_LABELS_PROPERTY, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_VERTICAL_LABELS_PROPERTY] = g_param_spec_boolean ("vertical-labels", "vertical-labels", "vertical-labels", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_LABEL_BOX_DIMENSIONS_PROPERTY, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_DIMENSIONS_PROPERTY] = g_param_spec_boxed ("dimensions", "dimensions", "dimensions", GNONOGRAMS_TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_LABEL_BOX_MIN_WIDTH_PROPERTY, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_MIN_WIDTH_PROPERTY] = g_param_spec_int ("min-width", "min-width", "min-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_LABEL_BOX_MIN_HEIGHT_PROPERTY, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_MIN_HEIGHT_PROPERTY] = g_param_spec_int ("min-height", "min-height", "min-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_LABEL_BOX_FONTHEIGHT_PROPERTY, gnonograms_label_box_properties[GNONOGRAMS_LABEL_BOX_FONTHEIGHT_PROPERTY] = g_param_spec_double ("fontheight", "fontheight", "fontheight", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_label_box_instance_init (GnonogramsLabelBox * self,
                                    gpointer klass)
{
	self->priv = gnonograms_label_box_get_instance_private (self);
}

static void
gnonograms_label_box_finalize (GObject * obj)
{
	GnonogramsLabelBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBox);
	self->priv->labels = (_vala_array_free (self->priv->labels, self->priv->labels_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (gnonograms_label_box_parent_class)->finalize (obj);
}

/** Widget to hold variable number of clues, with either vertical or horizontal orientation **/
static GType
gnonograms_label_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsLabelBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_label_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsLabelBox), 0, (GInstanceInitFunc) gnonograms_label_box_instance_init, NULL };
	GType gnonograms_label_box_type_id;
	gnonograms_label_box_type_id = g_type_register_static (gtk_grid_get_type (), "GnonogramsLabelBox", &g_define_type_info, 0);
	GnonogramsLabelBox_private_offset = g_type_add_instance_private (gnonograms_label_box_type_id, sizeof (GnonogramsLabelBoxPrivate));
	return gnonograms_label_box_type_id;
}

GType
gnonograms_label_box_get_type (void)
{
	static volatile gsize gnonograms_label_box_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_label_box_type_id__volatile)) {
		GType gnonograms_label_box_type_id;
		gnonograms_label_box_type_id = gnonograms_label_box_get_type_once ();
		g_once_init_leave (&gnonograms_label_box_type_id__volatile, gnonograms_label_box_type_id);
	}
	return gnonograms_label_box_type_id__volatile;
}

static void
_vala_gnonograms_label_box_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GnonogramsLabelBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBox);
	switch (property_id) {
		case GNONOGRAMS_LABEL_BOX_ATTACH_POSITION_PROPERTY:
		g_value_set_enum (value, gnonograms_label_box_get_attach_position (self));
		break;
		case GNONOGRAMS_LABEL_BOX_VERTICAL_LABELS_PROPERTY:
		g_value_set_boolean (value, gnonograms_label_box_get_vertical_labels (self));
		break;
		case GNONOGRAMS_LABEL_BOX_DIMENSIONS_PROPERTY:
		{
			GnonogramsDimensions boxed;
			gnonograms_label_box_get_dimensions (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_LABEL_BOX_MIN_WIDTH_PROPERTY:
		g_value_set_int (value, gnonograms_label_box_get_min_width (self));
		break;
		case GNONOGRAMS_LABEL_BOX_MIN_HEIGHT_PROPERTY:
		g_value_set_int (value, gnonograms_label_box_get_min_height (self));
		break;
		case GNONOGRAMS_LABEL_BOX_FONTHEIGHT_PROPERTY:
		g_value_set_double (value, gnonograms_label_box_get_fontheight (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_label_box_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GnonogramsLabelBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBox);
	switch (property_id) {
		case GNONOGRAMS_LABEL_BOX_DIMENSIONS_PROPERTY:
		gnonograms_label_box_set_dimensions (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_LABEL_BOX_MIN_WIDTH_PROPERTY:
		gnonograms_label_box_set_min_width (self, g_value_get_int (value));
		break;
		case GNONOGRAMS_LABEL_BOX_MIN_HEIGHT_PROPERTY:
		gnonograms_label_box_set_min_height (self, g_value_get_int (value));
		break;
		case GNONOGRAMS_LABEL_BOX_FONTHEIGHT_PROPERTY:
		gnonograms_label_box_set_fontheight (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

