/* View.c generated by valac 0.54.6, the Vala compiler
 * generated from View.vala, do not modify */

/* View class for gnonograms - displays user interface
 * Copyright (C) 2010-2017  Jeremy Wootten
 *
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Author:
 *  Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>
#include <gee.h>

#define GNONOGRAMS_VIEW_PROGRESS_DELAY_MSEC ((guint) 500)
#define GNONOGRAMS_PALE_TEXT "#fafafa"
#define GNONOGRAMS_DARK_SHADOW "#1a1a1a"
#define GNONOGRAMS_GNONOGRAMS_DARK_PURPLE "#180297"
#define GNONOGRAMS_GNONOGRAMS_PALE_PURPLE "#cdc9e0"
#define GNONOGRAMS_USABLE_MONITOR_HEIGHT 0.85
#define GNONOGRAMS_HEADER_HEIGHT ((gint) GTK_ICON_SIZE_LARGE_TOOLBAR)
#define GNONOGRAMS_GRID_BORDER 6
#define GNONOGRAMS_TYPICAL_MAX_BLOCKS_RATIO 0.3
#define GNONOGRAMS_FONT_ASPECT_RATIO 1.2
#define GNONOGRAMS_USABLE_MONITOR_WIDTH 0.95
#define GNONOGRAMS_GRID_COLUMN_SPACING 6
#define GNONOGRAMS_MINFONTSIZE 8.0
#define GNONOGRAMS_MAXFONTSIZE 36.0
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GNONOGRAMS_TYPE_VIEW (gnonograms_view_get_type ())
#define GNONOGRAMS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_VIEW, GnonogramsView))
#define GNONOGRAMS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_VIEW, GnonogramsViewClass))
#define GNONOGRAMS_IS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_VIEW))
#define GNONOGRAMS_IS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_VIEW))
#define GNONOGRAMS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_VIEW, GnonogramsViewClass))

typedef struct _GnonogramsView GnonogramsView;
typedef struct _GnonogramsViewClass GnonogramsViewClass;
typedef struct _GnonogramsViewPrivate GnonogramsViewPrivate;

#define GNONOGRAMS_TYPE_MODEL (gnonograms_model_get_type ())
#define GNONOGRAMS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModel))
#define GNONOGRAMS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))
#define GNONOGRAMS_IS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_IS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MODEL))
#define GNONOGRAMS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MODEL, GnonogramsModelClass))

typedef struct _GnonogramsModel GnonogramsModel;
typedef struct _GnonogramsModelClass GnonogramsModelClass;

#define GNONOGRAMS_TYPE_CONTROLLER (gnonograms_controller_get_type ())
#define GNONOGRAMS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsController))
#define GNONOGRAMS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsControllerClass))
#define GNONOGRAMS_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CONTROLLER))
#define GNONOGRAMS_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CONTROLLER))
#define GNONOGRAMS_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CONTROLLER, GnonogramsControllerClass))

typedef struct _GnonogramsController GnonogramsController;
typedef struct _GnonogramsControllerClass GnonogramsControllerClass;

#define GNONOGRAMS_TYPE_DIMENSIONS (gnonograms_dimensions_get_type ())
typedef struct _GnonogramsDimensions GnonogramsDimensions;
typedef enum  {
	GNONOGRAMS_DIFFICULTY_TRIVIAL = 0,
	GNONOGRAMS_DIFFICULTY_VERY_EASY = 1,
	GNONOGRAMS_DIFFICULTY_EASY = 2,
	GNONOGRAMS_DIFFICULTY_MODERATE = 3,
	GNONOGRAMS_DIFFICULTY_HARD = 4,
	GNONOGRAMS_DIFFICULTY_CHALLENGING = 5,
	GNONOGRAMS_DIFFICULTY_ADVANCED = 6,
	GNONOGRAMS_DIFFICULTY_MAXIMUM = 7,
	GNONOGRAMS_DIFFICULTY_COMPUTER = 8,
	GNONOGRAMS_DIFFICULTY_UNDEFINED = 99
} GnonogramsDifficulty;

#define GNONOGRAMS_TYPE_DIFFICULTY (gnonograms_difficulty_get_type ())
typedef enum  {
	GNONOGRAMS_GAME_STATE_SETTING,
	GNONOGRAMS_GAME_STATE_SOLVING,
	GNONOGRAMS_GAME_STATE_GENERATING,
	GNONOGRAMS_GAME_STATE_UNDEFINED = 99
} GnonogramsGameState;

#define GNONOGRAMS_TYPE_GAME_STATE (gnonograms_game_state_get_type ())

#define GNONOGRAMS_TYPE_CELL (gnonograms_cell_get_type ())
typedef struct _GnonogramsCell GnonogramsCell;
typedef enum  {
	GNONOGRAMS_CELL_STATE_UNKNOWN,
	GNONOGRAMS_CELL_STATE_EMPTY,
	GNONOGRAMS_CELL_STATE_FILLED,
	GNONOGRAMS_CELL_STATE_COMPLETED,
	GNONOGRAMS_CELL_STATE_UNDEFINED
} GnonogramsCellState;

#define GNONOGRAMS_TYPE_CELL_STATE (gnonograms_cell_state_get_type ())

#define GNONOGRAMS_TYPE_LABEL_BOX (gnonograms_label_box_get_type ())
#define GNONOGRAMS_LABEL_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBox))
#define GNONOGRAMS_LABEL_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBoxClass))
#define GNONOGRAMS_IS_LABEL_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_LABEL_BOX))
#define GNONOGRAMS_IS_LABEL_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_LABEL_BOX))
#define GNONOGRAMS_LABEL_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_LABEL_BOX, GnonogramsLabelBoxClass))

typedef struct _GnonogramsLabelBox GnonogramsLabelBox;
typedef struct _GnonogramsLabelBoxClass GnonogramsLabelBoxClass;

#define GNONOGRAMS_TYPE_CELL_GRID (gnonograms_cell_grid_get_type ())
#define GNONOGRAMS_CELL_GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGrid))
#define GNONOGRAMS_CELL_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGridClass))
#define GNONOGRAMS_IS_CELL_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_CELL_GRID))
#define GNONOGRAMS_IS_CELL_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_CELL_GRID))
#define GNONOGRAMS_CELL_GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_CELL_GRID, GnonogramsCellGridClass))

typedef struct _GnonogramsCellGrid GnonogramsCellGrid;
typedef struct _GnonogramsCellGridClass GnonogramsCellGridClass;

#define GNONOGRAMS_TYPE_APP_MENU (gnonograms_app_menu_get_type ())
#define GNONOGRAMS_APP_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_APP_MENU, GnonogramsAppMenu))
#define GNONOGRAMS_APP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_APP_MENU, GnonogramsAppMenuClass))
#define GNONOGRAMS_IS_APP_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_APP_MENU))
#define GNONOGRAMS_IS_APP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_APP_MENU))
#define GNONOGRAMS_APP_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_APP_MENU, GnonogramsAppMenuClass))

typedef struct _GnonogramsAppMenu GnonogramsAppMenu;
typedef struct _GnonogramsAppMenuClass GnonogramsAppMenuClass;

#define GNONOGRAMS_TYPE_PROGRESS_INDICATOR (gnonograms_progress_indicator_get_type ())
#define GNONOGRAMS_PROGRESS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_PROGRESS_INDICATOR, GnonogramsProgressIndicator))
#define GNONOGRAMS_PROGRESS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_PROGRESS_INDICATOR, GnonogramsProgressIndicatorClass))
#define GNONOGRAMS_IS_PROGRESS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_PROGRESS_INDICATOR))
#define GNONOGRAMS_IS_PROGRESS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_PROGRESS_INDICATOR))
#define GNONOGRAMS_PROGRESS_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_PROGRESS_INDICATOR, GnonogramsProgressIndicatorClass))

typedef struct _GnonogramsProgressIndicator GnonogramsProgressIndicator;
typedef struct _GnonogramsProgressIndicatorClass GnonogramsProgressIndicatorClass;

#define GNONOGRAMS_TYPE_VIEW_MODE_BUTTON (gnonograms_view_mode_button_get_type ())
#define GNONOGRAMS_VIEW_MODE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButton))
#define GNONOGRAMS_VIEW_MODE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButtonClass))
#define GNONOGRAMS_IS_VIEW_MODE_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON))
#define GNONOGRAMS_IS_VIEW_MODE_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON))
#define GNONOGRAMS_VIEW_MODE_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_VIEW_MODE_BUTTON, GnonogramsViewModeButtonClass))

typedef struct _GnonogramsViewModeButton GnonogramsViewModeButton;
typedef struct _GnonogramsViewModeButtonClass GnonogramsViewModeButtonClass;
enum  {
	GNONOGRAMS_VIEW_0_PROPERTY,
	GNONOGRAMS_VIEW_MODEL_PROPERTY,
	GNONOGRAMS_VIEW_CONTROLLER_PROPERTY,
	GNONOGRAMS_VIEW_DIMENSIONS_PROPERTY,
	GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY,
	GNONOGRAMS_VIEW_GAME_STATE_PROPERTY,
	GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY,
	GNONOGRAMS_VIEW_GAME_NAME_PROPERTY,
	GNONOGRAMS_VIEW_READONLY_PROPERTY,
	GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY,
	GNONOGRAMS_VIEW_FONTHEIGHT_PROPERTY,
	GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY,
	GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY,
	GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY,
	GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY,
	GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY,
	GNONOGRAMS_VIEW_NUM_PROPERTIES
};
static GParamSpec* gnonograms_view_properties[GNONOGRAMS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define GNONOGRAMS_TYPE_MOVE (gnonograms_move_get_type ())
#define GNONOGRAMS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMove))
#define GNONOGRAMS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))
#define GNONOGRAMS_IS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_IS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_MOVE))
#define GNONOGRAMS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_MOVE, GnonogramsMoveClass))

typedef struct _GnonogramsMove GnonogramsMove;
typedef struct _GnonogramsMoveClass GnonogramsMoveClass;
typedef struct _GnonogramsMovePrivate GnonogramsMovePrivate;

#define GNONOGRAMS_TYPE_BLOCK (gnonograms_block_get_type ())
#define GNONOGRAMS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlock))
#define GNONOGRAMS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))
#define GNONOGRAMS_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_BLOCK))
#define GNONOGRAMS_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_BLOCK, GnonogramsBlockClass))

typedef struct _GnonogramsBlock GnonogramsBlock;
typedef struct _GnonogramsBlockClass GnonogramsBlockClass;
typedef struct _Block4Data Block4Data;
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))

#define GNONOGRAMS_TYPE_APP (gnonograms_app_get_type ())
#define GNONOGRAMS_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_APP, GnonogramsApp))
#define GNONOGRAMS_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_APP, GnonogramsAppClass))
#define GNONOGRAMS_IS_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_APP))
#define GNONOGRAMS_IS_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_APP))
#define GNONOGRAMS_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_APP, GnonogramsAppClass))

typedef struct _GnonogramsApp GnonogramsApp;
typedef struct _GnonogramsAppClass GnonogramsAppClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define GNONOGRAMS_TYPE_HEADER_BUTTON (gnonograms_header_button_get_type ())
#define GNONOGRAMS_HEADER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_HEADER_BUTTON, GnonogramsHeaderButton))
#define GNONOGRAMS_HEADER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_HEADER_BUTTON, GnonogramsHeaderButtonClass))
#define GNONOGRAMS_IS_HEADER_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_HEADER_BUTTON))
#define GNONOGRAMS_IS_HEADER_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_HEADER_BUTTON))
#define GNONOGRAMS_HEADER_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_HEADER_BUTTON, GnonogramsHeaderButtonClass))

typedef struct _GnonogramsHeaderButton GnonogramsHeaderButton;
typedef struct _GnonogramsHeaderButtonClass GnonogramsHeaderButtonClass;

#define GNONOGRAMS_TYPE_RESTART_BUTTON (gnonograms_restart_button_get_type ())
#define GNONOGRAMS_RESTART_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNONOGRAMS_TYPE_RESTART_BUTTON, GnonogramsRestartButton))
#define GNONOGRAMS_RESTART_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNONOGRAMS_TYPE_RESTART_BUTTON, GnonogramsRestartButtonClass))
#define GNONOGRAMS_IS_RESTART_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNONOGRAMS_TYPE_RESTART_BUTTON))
#define GNONOGRAMS_IS_RESTART_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNONOGRAMS_TYPE_RESTART_BUTTON))
#define GNONOGRAMS_RESTART_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNONOGRAMS_TYPE_RESTART_BUTTON, GnonogramsRestartButtonClass))

typedef struct _GnonogramsRestartButton GnonogramsRestartButton;
typedef struct _GnonogramsRestartButtonClass GnonogramsRestartButtonClass;
enum  {
	GNONOGRAMS_VIEW_RANDOM_GAME_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_REWIND_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_NEXT_MOVE_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_PREVIOUS_MOVE_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_SAVE_GAME_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_SAVE_GAME_AS_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_OPEN_GAME_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_SOLVE_THIS_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_RESTART_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_HINT_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_DEBUG_REQUEST_SIGNAL,
	GNONOGRAMS_VIEW_CHANGED_CELL_SIGNAL,
	GNONOGRAMS_VIEW_NUM_SIGNALS
};
static guint gnonograms_view_signals[GNONOGRAMS_VIEW_NUM_SIGNALS] = {0};
typedef struct _GnonogramsHeaderButtonPrivate GnonogramsHeaderButtonPrivate;
typedef struct _GnonogramsRestartButtonPrivate GnonogramsRestartButtonPrivate;
enum  {
	GNONOGRAMS_RESTART_BUTTON_0_PROPERTY,
	GNONOGRAMS_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY,
	GNONOGRAMS_RESTART_BUTTON_NUM_PROPERTIES
};
static GParamSpec* gnonograms_restart_button_properties[GNONOGRAMS_RESTART_BUTTON_NUM_PROPERTIES];
enum  {
	GNONOGRAMS_HEADER_BUTTON_0_PROPERTY,
	GNONOGRAMS_HEADER_BUTTON_NUM_PROPERTIES
};
static GParamSpec* gnonograms_header_button_properties[GNONOGRAMS_HEADER_BUTTON_NUM_PROPERTIES];

struct _GnonogramsView {
	GtkApplicationWindow parent_instance;
	GnonogramsViewPrivate * priv;
};

struct _GnonogramsViewClass {
	GtkApplicationWindowClass parent_class;
};

struct _GnonogramsDimensions {
	guint width;
	guint height;
};

struct _GnonogramsCell {
	guint row;
	guint col;
	GnonogramsCellState state;
};

struct _GnonogramsViewPrivate {
	GnonogramsModel* _model;
	GnonogramsController* _controller;
	GnonogramsDimensions _dimensions;
	GnonogramsDifficulty _generator_grade;
	GnonogramsGameState _game_state;
	gboolean _strikeout_complete;
	gboolean _readonly;
	GnonogramsDifficulty _game_grade;
	gdouble _fontheight;
	gboolean _can_go_back;
	gboolean _can_go_forward;
	gboolean _restart_destructive;
	GnonogramsCell _current_cell;
	GnonogramsCell _previous_cell;
	gchar* brand_stylesheet;
	GnonogramsLabelBox* row_clue_box;
	GnonogramsLabelBox* column_clue_box;
	GnonogramsCellGrid* cell_grid;
	GtkHeaderBar* header_bar;
	GnonogramsAppMenu* app_menu;
	GtkGrid* main_grid;
	GtkOverlay* overlay;
	GnonogramsProgressIndicator* progress_indicator;
	GtkStack* progress_stack;
	GtkLabel* title_label;
	GraniteWidgetsToast* toast;
	GnonogramsViewModeButton* mode_switch;
	GtkButton* load_game_button;
	GtkButton* save_game_button;
	GtkButton* save_game_as_button;
	GtkButton* undo_button;
	GtkButton* redo_button;
	GtkButton* check_correct_button;
	GtkButton* hint_button;
	GtkButton* auto_solve_button;
	GtkButton* restart_button;
	GnonogramsCellState drawing_with_state;
	guint drawing_with_key;
	guint progress_timeout_id;
};

struct _GnonogramsMove {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GnonogramsMovePrivate * priv;
	GnonogramsCell cell;
	GnonogramsCellState previous_state;
};

struct _GnonogramsMoveClass {
	GTypeClass parent_class;
	void (*finalize) (GnonogramsMove *self);
};

struct _Block4Data {
	int _ref_count_;
	GnonogramsView* self;
	GCancellable* cancellable;
};

struct _GnonogramsHeaderButton {
	GtkButton parent_instance;
	GnonogramsHeaderButtonPrivate * priv;
};

struct _GnonogramsHeaderButtonClass {
	GtkButtonClass parent_class;
};

struct _GnonogramsRestartButton {
	GnonogramsHeaderButton parent_instance;
	GnonogramsRestartButtonPrivate * priv;
};

struct _GnonogramsRestartButtonClass {
	GnonogramsHeaderButtonClass parent_class;
};

struct _GnonogramsRestartButtonPrivate {
	gboolean _restart_destructive;
};

static gint GnonogramsView_private_offset;
static gpointer gnonograms_view_parent_class = NULL;
static gint GnonogramsRestartButton_private_offset;
static gpointer gnonograms_restart_button_parent_class = NULL;
static gpointer gnonograms_header_button_parent_class = NULL;

VALA_EXTERN GType gnonograms_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsView, g_object_unref)
VALA_EXTERN GType gnonograms_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsModel, g_object_unref)
VALA_EXTERN GType gnonograms_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsController, g_object_unref)
VALA_EXTERN GType gnonograms_dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsDimensions* gnonograms_dimensions_dup (const GnonogramsDimensions* self);
VALA_EXTERN void gnonograms_dimensions_free (GnonogramsDimensions* self);
VALA_EXTERN GType gnonograms_difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_game_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_cell_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType gnonograms_cell_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GnonogramsCell* gnonograms_cell_dup (const GnonogramsCell* self);
VALA_EXTERN void gnonograms_cell_free (GnonogramsCell* self);
VALA_EXTERN GType gnonograms_label_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsLabelBox, g_object_unref)
VALA_EXTERN GType gnonograms_cell_grid_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsCellGrid, g_object_unref)
VALA_EXTERN GType gnonograms_app_menu_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsAppMenu, g_object_unref)
VALA_EXTERN GType gnonograms_progress_indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsProgressIndicator, g_object_unref)
VALA_EXTERN GType gnonograms_view_mode_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsViewModeButton, g_object_unref)
static void gnonograms_view_action_undo (GnonogramsView* self);
static void _gnonograms_view_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_redo (GnonogramsView* self);
static void _gnonograms_view_action_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_zoom (GnonogramsView* self,
                                  GSimpleAction* action,
                                  GVariant* param);
static void _gnonograms_view_action_zoom_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_move_cursor (GnonogramsView* self,
                                         GSimpleAction* action,
                                         GVariant* param);
static void _gnonograms_view_action_move_cursor_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void gnonograms_view_action_set_mode (GnonogramsView* self,
                                      GSimpleAction* action,
                                      GVariant* param);
static void _gnonograms_view_action_set_mode_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void gnonograms_view_action_open (GnonogramsView* self);
static void _gnonograms_view_action_open_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_save (GnonogramsView* self);
static void _gnonograms_view_action_save_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_save_as (GnonogramsView* self);
static void _gnonograms_view_action_save_as_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void gnonograms_view_action_paint_cell (GnonogramsView* self,
                                        GSimpleAction* action,
                                        GVariant* param);
static void _gnonograms_view_action_paint_cell_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void gnonograms_view_action_check_errors (GnonogramsView* self);
static void _gnonograms_view_action_check_errors_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void gnonograms_view_action_restart (GnonogramsView* self);
static void _gnonograms_view_action_restart_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void gnonograms_view_action_solve (GnonogramsView* self);
static void _gnonograms_view_action_solve_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
static void gnonograms_view_action_hint (GnonogramsView* self);
static void _gnonograms_view_action_hint_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void gnonograms_view_action_debug_row (GnonogramsView* self);
static void _gnonograms_view_action_debug_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void gnonograms_view_action_debug_col (GnonogramsView* self);
static void _gnonograms_view_action_debug_col_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
VALA_EXTERN GnonogramsView* gnonograms_view_new (GnonogramsModel* _model,
                                     GnonogramsController* controller);
VALA_EXTERN GnonogramsView* gnonograms_view_construct (GType object_type,
                                           GnonogramsModel* _model,
                                           GnonogramsController* controller);
VALA_EXTERN void gnonograms_view_update_labels_from_string_array (GnonogramsView* self,
                                                      gchar** clues,
                                                      gint clues_length1,
                                                      gboolean is_column);
static guint gnonograms_view_get_cols (GnonogramsView* self);
static guint gnonograms_view_get_rows (GnonogramsView* self);
VALA_EXTERN void gnonograms_label_box_update_label_text (GnonogramsLabelBox* self,
                                             guint index,
                                             const gchar* txt);
VALA_EXTERN void gnonograms_view_update_labels_from_solution (GnonogramsView* self);
static GnonogramsModel* gnonograms_view_get_model (GnonogramsView* self);
VALA_EXTERN gchar* gnonograms_model_get_label_text_from_solution (GnonogramsModel* self,
                                                      guint idx,
                                                      gboolean is_column);
static void gnonograms_view_update_all_labels_completeness (GnonogramsView* self);
VALA_EXTERN gpointer gnonograms_move_ref (gpointer instance);
VALA_EXTERN void gnonograms_move_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_move (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_move (GValue* value,
                                gpointer v_object);
VALA_EXTERN void gnonograms_value_take_move (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_move (const GValue* value);
VALA_EXTERN GType gnonograms_move_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsMove, gnonograms_move_unref)
VALA_EXTERN void gnonograms_view_make_move (GnonogramsView* self,
                                GnonogramsMove* m);
VALA_EXTERN gboolean gnonograms_move_is_null (GnonogramsMove* self);
static void gnonograms_view_update_current_and_model (GnonogramsView* self,
                                               GnonogramsCellState state,
                                               GnonogramsCell* target,
                                               GnonogramsCell* result);
VALA_EXTERN void gnonograms_view_send_notification (GnonogramsView* self,
                                        const gchar* text);
VALA_EXTERN void gnonograms_view_show_working (GnonogramsView* self,
                                   GCancellable* cancellable,
                                   const gchar* text);
VALA_EXTERN void gnonograms_cell_grid_set_frozen (GnonogramsCellGrid* self,
                                      gboolean value);
VALA_EXTERN void gnonograms_progress_indicator_set_text (GnonogramsProgressIndicator* self,
                                             const gchar* value);
static void gnonograms_view_schedule_show_progress (GnonogramsView* self,
                                             GCancellable* cancellable);
VALA_EXTERN void gnonograms_view_end_working (GnonogramsView* self);
static void gnonograms_view_update_header_bar (GnonogramsView* self);
static gdouble gnonograms_view_get_default_fontheight_from_dimensions (GnonogramsView* self);
VALA_EXTERN void gnonograms_utils_get_monitor_area (GdkScreen* screen,
                                        GdkWindow* window,
                                        GdkRectangle* result);
static void gnonograms_view_set_window_size (GnonogramsView* self);
VALA_EXTERN gint gnonograms_label_box_get_min_width (GnonogramsLabelBox* self);
VALA_EXTERN gint gnonograms_label_box_get_min_height (GnonogramsLabelBox* self);
VALA_EXTERN GnonogramsGameState gnonograms_view_get_game_state (GnonogramsView* self);
static void gnonograms_view_set_buttons_sensitive (GnonogramsView* self,
                                            gboolean sensitive);
VALA_EXTERN gboolean gnonograms_model_is_blank (GnonogramsModel* self,
                                    GnonogramsGameState state);
VALA_EXTERN void gnonograms_view_set_restart_destructive (GnonogramsView* self,
                                              gboolean value);
VALA_EXTERN gboolean gnonograms_view_get_can_go_back (GnonogramsView* self);
VALA_EXTERN gboolean gnonograms_view_get_can_go_forward (GnonogramsView* self);
static gboolean gnonograms_view_get_is_solving (GnonogramsView* self);
static void gnonograms_view_highlight_labels (GnonogramsView* self,
                                       GnonogramsCell* c,
                                       gboolean is_highlight);
VALA_EXTERN void gnonograms_label_box_highlight (GnonogramsLabelBox* self,
                                     guint index,
                                     gboolean is_highlight);
static void gnonograms_view_update_label_complete (GnonogramsView* self,
                                            guint idx,
                                            gboolean is_col);
VALA_EXTERN gboolean gnonograms_view_get_strikeout_complete (GnonogramsView* self);
VALA_EXTERN gpointer gnonograms_block_ref (gpointer instance);
VALA_EXTERN void gnonograms_block_unref (gpointer instance);
VALA_EXTERN GParamSpec* gnonograms_param_spec_block (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void gnonograms_value_set_block (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void gnonograms_value_take_block (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer gnonograms_value_get_block (const GValue* value);
VALA_EXTERN GType gnonograms_block_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsBlock, gnonograms_block_unref)
VALA_EXTERN GeeArrayList* gnonograms_model_get_complete_blocks_from_working (GnonogramsModel* self,
                                                                 guint index,
                                                                 gboolean is_column);
VALA_EXTERN void gnonograms_label_box_update_label_complete (GnonogramsLabelBox* self,
                                                 guint index,
                                                 GeeList* grid_blocks);
VALA_EXTERN void gnonograms_label_box_clear_formatting (GnonogramsLabelBox* self,
                                            guint index);
static void gnonograms_view_make_move_at_cell (GnonogramsView* self,
                                        GnonogramsCellState state,
                                        GnonogramsCell* target);
static gboolean _gnonograms_cell_equal (const GnonogramsCell * s1,
                                 const GnonogramsCell * s2);
VALA_EXTERN GnonogramsCellState gnonograms_model_get_data_for_cell (GnonogramsModel* self,
                                                        GnonogramsCell* cell);
VALA_EXTERN void gnonograms_cell_clone (GnonogramsCell *self,
                            GnonogramsCell* result);
VALA_EXTERN void gnonograms_model_set_data_from_cell (GnonogramsModel* self,
                                          GnonogramsCell* cell);
static void gnonograms_view_update_current_cell (GnonogramsView* self,
                                          GnonogramsCell* target);
VALA_EXTERN void gnonograms_view_get_current_cell (GnonogramsView* self,
                                       GnonogramsCell * result);
VALA_EXTERN void gnonograms_view_set_previous_cell (GnonogramsView* self,
                                        GnonogramsCell * value);
VALA_EXTERN void gnonograms_view_set_current_cell (GnonogramsView* self,
                                       GnonogramsCell * value);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda26_ (Block4Data* _data4_);
VALA_EXTERN void gnonograms_progress_indicator_set_cancellable (GnonogramsProgressIndicator* self,
                                                    GCancellable* value);
static gboolean ___lambda26__gsource_func (gpointer self);
static gboolean gnonograms_view_on_grid_leave (GnonogramsView* self);
VALA_EXTERN void gnonograms_label_box_unhighlight_all (GnonogramsLabelBox* self);
static gboolean gnonograms_view_on_grid_button_press (GnonogramsView* self,
                                               GdkEventButton* event);
static gboolean gnonograms_view_on_key_release_event (GnonogramsView* self,
                                               GdkEventKey* event);
static gboolean gnonograms_view_stop_painting (GnonogramsView* self);
static gboolean gnonograms_view_on_grid_scroll_event (GnonogramsView* self,
                                               GdkEventScroll* event);
VALA_EXTERN gdouble gnonograms_view_get_fontheight (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_set_fontheight (GnonogramsView* self,
                                     gdouble value);
VALA_EXTERN void gnonograms_view_set_game_state (GnonogramsView* self,
                                     GnonogramsGameState value);
static void _vala_GdkEvent_free (GdkEvent* self);
static void gnonograms_view_set_model (GnonogramsView* self,
                                GnonogramsModel* value);
VALA_EXTERN GnonogramsController* gnonograms_view_get_controller (GnonogramsView* self);
static void gnonograms_view_set_controller (GnonogramsView* self,
                                     GnonogramsController* value);
VALA_EXTERN void gnonograms_view_get_dimensions (GnonogramsView* self,
                                     GnonogramsDimensions * result);
VALA_EXTERN void gnonograms_view_set_dimensions (GnonogramsView* self,
                                     GnonogramsDimensions * value);
static gboolean _gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                                       const GnonogramsDimensions * s2);
VALA_EXTERN GnonogramsDifficulty gnonograms_view_get_generator_grade (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_set_generator_grade (GnonogramsView* self,
                                          GnonogramsDifficulty value);
VALA_EXTERN void gnonograms_view_set_strikeout_complete (GnonogramsView* self,
                                             gboolean value);
VALA_EXTERN const gchar* gnonograms_view_get_game_name (GnonogramsView* self);
VALA_EXTERN const gchar* gnonograms_controller_get_game_name (GnonogramsController* self);
VALA_EXTERN gboolean gnonograms_view_get_readonly (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_set_readonly (GnonogramsView* self,
                                   gboolean value);
VALA_EXTERN GnonogramsDifficulty gnonograms_view_get_game_grade (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_set_game_grade (GnonogramsView* self,
                                     GnonogramsDifficulty value);
VALA_EXTERN void gnonograms_view_set_can_go_back (GnonogramsView* self,
                                      gboolean value);
VALA_EXTERN void gnonograms_view_set_can_go_forward (GnonogramsView* self,
                                         gboolean value);
VALA_EXTERN gboolean gnonograms_view_get_restart_destructive (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_get_previous_cell (GnonogramsView* self,
                                        GnonogramsCell * result);
VALA_EXTERN guint gnonograms_dimensions_rows (GnonogramsDimensions *self);
VALA_EXTERN guint gnonograms_dimensions_cols (GnonogramsDimensions *self);
static void g_cclosure_user_marshal_UINT__VOID (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__VOID (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UINT_BOOLEAN (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__BOXED_ENUM (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static GObject * gnonograms_view_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
VALA_EXTERN GType gnonograms_app_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsApp, g_object_unref)
VALA_EXTERN GnonogramsApp* gnonograms_get_app (void);
VALA_EXTERN GnonogramsHeaderButton* gnonograms_header_button_new (const gchar* icon_name,
                                                      const gchar* tooltip,
                                                      gboolean sensitive);
VALA_EXTERN GnonogramsHeaderButton* gnonograms_header_button_construct (GType object_type,
                                                            const gchar* icon_name,
                                                            const gchar* tooltip,
                                                            gboolean sensitive);
VALA_EXTERN GType gnonograms_header_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsHeaderButton, g_object_unref)
VALA_EXTERN GnonogramsRestartButton* gnonograms_restart_button_new (const gchar* icon_name,
                                                        const gchar* tooltip,
                                                        gboolean sensitive);
VALA_EXTERN GnonogramsRestartButton* gnonograms_restart_button_construct (GType object_type,
                                                              const gchar* icon_name,
                                                              const gchar* tooltip,
                                                              gboolean sensitive);
VALA_EXTERN GType gnonograms_restart_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GnonogramsRestartButton, g_object_unref)
VALA_EXTERN GnonogramsAppMenu* gnonograms_app_menu_new (GnonogramsController* controller);
VALA_EXTERN GnonogramsAppMenu* gnonograms_app_menu_construct (GType object_type,
                                                  GnonogramsController* controller);
VALA_EXTERN GnonogramsViewModeButton* gnonograms_view_mode_button_new (void);
VALA_EXTERN GnonogramsViewModeButton* gnonograms_view_mode_button_construct (GType object_type);
VALA_EXTERN GnonogramsProgressIndicator* gnonograms_progress_indicator_new (void);
VALA_EXTERN GnonogramsProgressIndicator* gnonograms_progress_indicator_construct (GType object_type);
VALA_EXTERN GnonogramsLabelBox* gnonograms_label_box_new (GtkOrientation _orientation);
VALA_EXTERN GnonogramsLabelBox* gnonograms_label_box_construct (GType object_type,
                                                    GtkOrientation _orientation);
VALA_EXTERN GnonogramsCellGrid* gnonograms_cell_grid_new (GnonogramsModel* model);
VALA_EXTERN GnonogramsCellGrid* gnonograms_cell_grid_construct (GType object_type,
                                                    GnonogramsModel* model);
static gboolean _gnonograms_view_on_grid_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                        GdkEventScroll* event,
                                                                        gpointer self);
static gboolean _gnonograms_view_on_grid_leave_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                       GdkEventCrossing* event,
                                                                       gpointer self);
static gboolean _gnonograms_view_on_grid_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                              GdkEventButton* event,
                                                                              gpointer self);
static gboolean _gnonograms_view_stop_painting_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self);
static gboolean _gnonograms_view_on_key_release_event_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                             GdkEventKey* event,
                                                                             gpointer self);
static void _gnonograms_view___lambda28_ (GnonogramsView* self);
static void __gnonograms_view___lambda28__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda29_ (GnonogramsView* self);
static void __gnonograms_view___lambda29__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda30_ (GnonogramsView* self);
VALA_EXTERN void gnonograms_view_mode_button_set_grade (GnonogramsViewModeButton* self,
                                            GnonogramsDifficulty value);
static void __gnonograms_view___lambda30__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda31_ (GnonogramsView* self);
static void __gnonograms_view___lambda31__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda32_ (GnonogramsView* self);
static void __gnonograms_view___lambda32__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda33_ (GnonogramsView* self);
static void __gnonograms_view___lambda33__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda34_ (GnonogramsView* self);
static void __gnonograms_view___lambda34__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda35_ (GnonogramsView* self);
static void __gnonograms_view___lambda35__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda36_ (GnonogramsView* self);
static void __gnonograms_view___lambda36__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view___lambda37_ (GnonogramsView* self);
static void __gnonograms_view___lambda37__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void _gnonograms_view_set_window_size_gtk_widget_realize (GtkWidget* _sender,
                                                          gpointer self);
static void gnonograms_view_finalize (GObject * obj);
static GType gnonograms_view_get_type_once (void);
static void _vala_gnonograms_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_gnonograms_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
VALA_EXTERN gboolean gnonograms_restart_button_get_restart_destructive (GnonogramsRestartButton* self);
VALA_EXTERN void gnonograms_restart_button_set_restart_destructive (GnonogramsRestartButton* self,
                                                        gboolean value);
static GObject * gnonograms_restart_button_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _gnonograms_restart_button___lambda27_ (GnonogramsRestartButton* self);
static void __gnonograms_restart_button___lambda27__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void gnonograms_restart_button_finalize (GObject * obj);
static GType gnonograms_restart_button_get_type_once (void);
static void _vala_gnonograms_restart_button_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_gnonograms_restart_button_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static GObject * gnonograms_header_button_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static GType gnonograms_header_button_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry GNONOGRAMS_VIEW_VIEW_ACTION_ENTRIES[15] = {{"undo", _gnonograms_view_action_undo_gsimple_action_activate_callback}, {"redo", _gnonograms_view_action_redo_gsimple_action_activate_callback}, {"zoom", _gnonograms_view_action_zoom_gsimple_action_activate_callback, "i"}, {"move-cursor", _gnonograms_view_action_move_cursor_gsimple_action_activate_callback, "(ii)"}, {"set-mode", _gnonograms_view_action_set_mode_gsimple_action_activate_callback, "u"}, {"open", _gnonograms_view_action_open_gsimple_action_activate_callback}, {"save", _gnonograms_view_action_save_gsimple_action_activate_callback}, {"save-as", _gnonograms_view_action_save_as_gsimple_action_activate_callback}, {"paint-cell", _gnonograms_view_action_paint_cell_gsimple_action_activate_callback, "u"}, {"check-errors", _gnonograms_view_action_check_errors_gsimple_action_activate_callback}, {"restart", _gnonograms_view_action_restart_gsimple_action_activate_callback}, {"solve", _gnonograms_view_action_solve_gsimple_action_activate_callback}, {"hint", _gnonograms_view_action_hint_gsimple_action_activate_callback}, {"debug-row", _gnonograms_view_action_debug_row_gsimple_action_activate_callback}, {"debug-col", _gnonograms_view_action_debug_col_gsimple_action_activate_callback}};
VALA_EXTERN const GnonogramsCell GNONOGRAMS_NULL_CELL;

static inline gpointer
gnonograms_view_get_instance_private (GnonogramsView* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsView_private_offset);
}

static void
_gnonograms_view_action_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_undo ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_redo ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_zoom_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_zoom ((GnonogramsView*) self, action, parameter);
}

static void
_gnonograms_view_action_move_cursor_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
	gnonograms_view_action_move_cursor ((GnonogramsView*) self, action, parameter);
}

static void
_gnonograms_view_action_set_mode_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
	gnonograms_view_action_set_mode ((GnonogramsView*) self, action, parameter);
}

static void
_gnonograms_view_action_open_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_open ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_save_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_save ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_save_as_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
	gnonograms_view_action_save_as ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_paint_cell_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
	gnonograms_view_action_paint_cell ((GnonogramsView*) self, action, parameter);
}

static void
_gnonograms_view_action_check_errors_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
	gnonograms_view_action_check_errors ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_restart_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
	gnonograms_view_action_restart ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_solve_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
	gnonograms_view_action_solve ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_hint_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	gnonograms_view_action_hint ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_debug_row_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
	gnonograms_view_action_debug_row ((GnonogramsView*) self);
}

static void
_gnonograms_view_action_debug_col_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
	gnonograms_view_action_debug_col ((GnonogramsView*) self);
}

GnonogramsView*
gnonograms_view_construct (GType object_type,
                           GnonogramsModel* _model,
                           GnonogramsController* controller)
{
	GnonogramsView * self = NULL;
	g_return_val_if_fail (_model != NULL, NULL);
	g_return_val_if_fail (controller != NULL, NULL);
	self = (GnonogramsView*) g_object_new (object_type, "model", _model, "controller", controller, NULL);
	return self;
}

GnonogramsView*
gnonograms_view_new (GnonogramsModel* _model,
                     GnonogramsController* controller)
{
	return gnonograms_view_construct (GNONOGRAMS_TYPE_VIEW, _model, controller);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
gnonograms_view_update_labels_from_string_array (GnonogramsView* self,
                                                 gchar** clues,
                                                 gint clues_length1,
                                                 gboolean is_column)
{
	GnonogramsLabelBox* _tmp0_ = NULL;
	GnonogramsLabelBox* clue_box = NULL;
	GnonogramsLabelBox* _tmp3_;
	guint _tmp4_ = 0U;
	guint lim = 0U;
	g_return_if_fail (self != NULL);
	if (is_column) {
		GnonogramsLabelBox* _tmp1_;
		_tmp1_ = self->priv->column_clue_box;
		_tmp0_ = _tmp1_;
	} else {
		GnonogramsLabelBox* _tmp2_;
		_tmp2_ = self->priv->row_clue_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	clue_box = _tmp3_;
	if (is_column) {
		guint _tmp5_;
		guint _tmp6_;
		_tmp5_ = gnonograms_view_get_cols (self);
		_tmp6_ = _tmp5_;
		_tmp4_ = _tmp6_;
	} else {
		guint _tmp7_;
		guint _tmp8_;
		_tmp7_ = gnonograms_view_get_rows (self);
		_tmp8_ = _tmp7_;
		_tmp4_ = _tmp8_;
	}
	lim = _tmp4_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				GnonogramsLabelBox* _tmp11_;
				const gchar* _tmp12_;
				if (!_tmp9_) {
					gint _tmp10_;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				if (!(((guint) i) < lim)) {
					break;
				}
				_tmp11_ = clue_box;
				_tmp12_ = clues[i];
				gnonograms_label_box_update_label_text (_tmp11_, (guint) i, _tmp12_);
			}
		}
	}
	_g_object_unref0 (clue_box);
}

void
gnonograms_view_update_labels_from_solution (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				GnonogramsLabelBox* _tmp4_;
				GnonogramsModel* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_view_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->row_clue_box;
				_tmp5_ = self->priv->_model;
				_tmp6_ = gnonograms_model_get_label_text_from_solution (_tmp5_, (guint) r, FALSE);
				_tmp7_ = _tmp6_;
				gnonograms_label_box_update_label_text (_tmp4_, (guint) r, _tmp7_);
				_g_free0 (_tmp7_);
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				guint _tmp10_;
				guint _tmp11_;
				GnonogramsLabelBox* _tmp12_;
				GnonogramsModel* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = c;
					c = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = gnonograms_view_get_cols (self);
				_tmp11_ = _tmp10_;
				if (!(((guint) c) < _tmp11_)) {
					break;
				}
				_tmp12_ = self->priv->column_clue_box;
				_tmp13_ = self->priv->_model;
				_tmp14_ = gnonograms_model_get_label_text_from_solution (_tmp13_, (guint) c, TRUE);
				_tmp15_ = _tmp14_;
				gnonograms_label_box_update_label_text (_tmp12_, (guint) c, _tmp15_);
				_g_free0 (_tmp15_);
			}
		}
	}
	gnonograms_view_update_all_labels_completeness (self);
}

void
gnonograms_view_make_move (GnonogramsView* self,
                           GnonogramsMove* m)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	if (!gnonograms_move_is_null (m)) {
		GnonogramsCell _tmp0_;
		GnonogramsCell _tmp1_;
		GnonogramsCell _tmp2_ = {0};
		_tmp0_ = m->cell;
		_tmp1_ = m->cell;
		gnonograms_view_update_current_and_model (self, _tmp0_.state, &_tmp1_, &_tmp2_);
	}
}

void
gnonograms_view_send_notification (GnonogramsView* self,
                                   const gchar* text)
{
	GraniteWidgetsToast* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GraniteWidgetsToast* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->toast;
	_tmp1_ = g_strdup (text);
	_tmp2_ = _tmp1_;
	granite_widgets_toast_set_title (_tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->toast;
	granite_widgets_toast_send_notification (_tmp3_);
}

void
gnonograms_view_show_working (GnonogramsView* self,
                              GCancellable* cancellable,
                              const gchar* text)
{
	GnonogramsCellGrid* _tmp0_;
	GnonogramsProgressIndicator* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cancellable != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->cell_grid;
	gnonograms_cell_grid_set_frozen (_tmp0_, TRUE);
	_tmp1_ = self->priv->progress_indicator;
	gnonograms_progress_indicator_set_text (_tmp1_, text);
	gnonograms_view_schedule_show_progress (self, cancellable);
}

void
gnonograms_view_end_working (GnonogramsView* self)
{
	GnonogramsCellGrid* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->cell_grid;
	gnonograms_cell_grid_set_frozen (_tmp0_, FALSE);
	if (self->priv->progress_timeout_id > ((guint) 0)) {
		g_source_remove (self->priv->progress_timeout_id);
		self->priv->progress_timeout_id = (guint) 0;
	} else {
		GtkStack* _tmp1_;
		_tmp1_ = self->priv->progress_stack;
		gtk_stack_set_visible_child_name (_tmp1_, "Title");
	}
	gnonograms_view_update_all_labels_completeness (self);
	gnonograms_view_update_header_bar (self);
}

/*** PRIVATE ***/
static gdouble
gnonograms_view_get_default_fontheight_from_dimensions (GnonogramsView* self)
{
	GdkRectangle monitor_area = {0};
	GdkRectangle _tmp0_ = {0};
	GdkWindow* window = NULL;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	gdouble max_h = 0.0;
	GdkRectangle _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	gdouble max_w = 0.0;
	GdkRectangle _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	gdouble result = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	memset (&_tmp0_, 0, sizeof (GdkRectangle));
	_tmp0_.width = 1024;
	_tmp0_.height = 768;
	monitor_area = _tmp0_;
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	window = _tmp2_;
	_tmp3_ = window;
	if (_tmp3_ != NULL) {
		GdkScreen* _tmp4_;
		GdkScreen* _tmp5_;
		GdkWindow* _tmp6_;
		GdkRectangle _tmp7_ = {0};
		_tmp4_ = gtk_window_get_screen ((GtkWindow*) self);
		_tmp5_ = _tmp4_;
		_tmp6_ = window;
		gnonograms_utils_get_monitor_area (_tmp5_, _tmp6_, &_tmp7_);
		monitor_area = _tmp7_;
	}
	_tmp8_ = monitor_area;
	_tmp9_ = gnonograms_view_get_rows (self);
	_tmp10_ = _tmp9_;
	max_h = (((_tmp8_.height * GNONOGRAMS_USABLE_MONITOR_HEIGHT) - GNONOGRAMS_HEADER_HEIGHT) - (2 * GNONOGRAMS_GRID_BORDER)) / ((_tmp10_ * (1.0 + (GNONOGRAMS_TYPICAL_MAX_BLOCKS_RATIO * GNONOGRAMS_FONT_ASPECT_RATIO))) * 2.0);
	_tmp11_ = monitor_area;
	_tmp12_ = gnonograms_view_get_cols (self);
	_tmp13_ = _tmp12_;
	max_w = (((_tmp11_.width * GNONOGRAMS_USABLE_MONITOR_WIDTH) - (2 * GNONOGRAMS_GRID_BORDER)) - GNONOGRAMS_GRID_COLUMN_SPACING) / ((_tmp13_ * (1.0 + (GNONOGRAMS_TYPICAL_MAX_BLOCKS_RATIO / GNONOGRAMS_FONT_ASPECT_RATIO))) * 2.0);
	result = MIN (max_h, max_w);
	_g_object_unref0 (window);
	return result;
}

static void
gnonograms_view_set_window_size (GnonogramsView* self)
{
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkRectangle monitor_area = {0};
	GdkScreen* _tmp3_;
	GdkScreen* _tmp4_;
	GdkWindow* _tmp5_;
	GdkRectangle _tmp6_ = {0};
	gint usable_width = 0;
	GdkRectangle _tmp7_;
	gint w = 0;
	GnonogramsLabelBox* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GnonogramsLabelBox* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint usable_height = 0;
	GdkRectangle _tmp14_;
	gint h = 0;
	GnonogramsLabelBox* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GnonogramsLabelBox* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GdkGeometry hints = {0};
	GtkOverlay* _tmp21_;
	GdkGeometry _tmp22_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	window = _tmp1_;
	_tmp2_ = window;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (window);
		return;
	}
	_tmp3_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = window;
	gnonograms_utils_get_monitor_area (_tmp4_, _tmp5_, &_tmp6_);
	monitor_area = _tmp6_;
	_tmp7_ = monitor_area;
	usable_width = (gint) (_tmp7_.width * GNONOGRAMS_USABLE_MONITOR_WIDTH);
	_tmp8_ = self->priv->row_clue_box;
	_tmp9_ = gnonograms_label_box_get_min_width (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = self->priv->column_clue_box;
	_tmp12_ = gnonograms_label_box_get_min_width (_tmp11_);
	_tmp13_ = _tmp12_;
	w = MIN (usable_width, ((_tmp10_ + _tmp13_) + (2 * GNONOGRAMS_GRID_BORDER)) + GNONOGRAMS_GRID_COLUMN_SPACING);
	_tmp14_ = monitor_area;
	usable_height = (gint) (_tmp14_.height * GNONOGRAMS_USABLE_MONITOR_HEIGHT);
	_tmp15_ = self->priv->row_clue_box;
	_tmp16_ = gnonograms_label_box_get_min_height (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = self->priv->column_clue_box;
	_tmp19_ = gnonograms_label_box_get_min_height (_tmp18_);
	_tmp20_ = _tmp19_;
	h = MIN (usable_height, ((_tmp17_ + _tmp20_) + (2 * GNONOGRAMS_GRID_BORDER)) + GNONOGRAMS_HEADER_HEIGHT);
	memset (&hints, 0, sizeof (GdkGeometry));
	hints.min_width = w;
	hints.min_height = h;
	_tmp21_ = self->priv->overlay;
	_tmp22_ = hints;
	gtk_window_set_geometry_hints ((GtkWindow*) self, (GtkWidget*) _tmp21_, &_tmp22_, GDK_HINT_MIN_SIZE);
	gtk_window_resize ((GtkWindow*) self, w, h);
	_g_object_unref0 (window);
}

static void
gnonograms_view_update_header_bar (GnonogramsView* self)
{
	GnonogramsGameState _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_game_state;
	switch (_tmp0_) {
		case GNONOGRAMS_GAME_STATE_SETTING:
		{
			GtkButton* _tmp1_;
			_tmp1_ = self->priv->restart_button;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, _ ("Clear canvas"));
			gnonograms_view_set_buttons_sensitive (self, TRUE);
			break;
		}
		case GNONOGRAMS_GAME_STATE_SOLVING:
		{
			GtkButton* _tmp2_;
			_tmp2_ = self->priv->restart_button;
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _ ("Restart solving"));
			gnonograms_view_set_buttons_sensitive (self, TRUE);
			break;
		}
		case GNONOGRAMS_GAME_STATE_GENERATING:
		{
			gnonograms_view_set_buttons_sensitive (self, FALSE);
			break;
		}
		default:
		{
			break;
		}
	}
}

static void
gnonograms_view_set_buttons_sensitive (GnonogramsView* self,
                                       gboolean sensitive)
{
	GnonogramsViewModeButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp7_ = FALSE;
	GtkButton* _tmp9_;
	gboolean _tmp10_ = FALSE;
	GtkButton* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	GtkButton* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mode_switch;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, sensitive);
	_tmp1_ = self->priv->load_game_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, sensitive);
	_tmp2_ = self->priv->save_game_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, sensitive);
	_tmp3_ = self->priv->save_game_as_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, sensitive);
	if (sensitive) {
		GnonogramsModel* _tmp5_;
		GnonogramsGameState _tmp6_;
		_tmp5_ = self->priv->_model;
		_tmp6_ = self->priv->_game_state;
		_tmp4_ = !gnonograms_model_is_blank (_tmp5_, _tmp6_);
	} else {
		_tmp4_ = FALSE;
	}
	gnonograms_view_set_restart_destructive (self, _tmp4_);
	if (sensitive) {
		gboolean _tmp8_;
		_tmp8_ = self->priv->_can_go_back;
		_tmp7_ = _tmp8_;
	} else {
		_tmp7_ = FALSE;
	}
	_tmp9_ = self->priv->undo_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, _tmp7_);
	if (sensitive) {
		gboolean _tmp11_;
		_tmp11_ = self->priv->_can_go_forward;
		_tmp10_ = _tmp11_;
	} else {
		_tmp10_ = FALSE;
	}
	_tmp12_ = self->priv->redo_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, _tmp10_);
	if (sensitive) {
		gboolean _tmp15_;
		gboolean _tmp16_;
		_tmp15_ = gnonograms_view_get_is_solving (self);
		_tmp16_ = _tmp15_;
		_tmp14_ = _tmp16_;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		gboolean _tmp17_;
		_tmp17_ = self->priv->_can_go_back;
		_tmp13_ = _tmp17_;
	} else {
		_tmp13_ = FALSE;
	}
	_tmp18_ = self->priv->check_correct_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, _tmp13_);
	if (sensitive) {
		GnonogramsGameState _tmp20_;
		_tmp20_ = self->priv->_game_state;
		_tmp19_ = _tmp20_ == GNONOGRAMS_GAME_STATE_SOLVING;
	} else {
		_tmp19_ = FALSE;
	}
	_tmp21_ = self->priv->hint_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp21_, _tmp19_);
	_tmp22_ = self->priv->auto_solve_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, sensitive);
}

static void
gnonograms_view_highlight_labels (GnonogramsView* self,
                                  GnonogramsCell* c,
                                  gboolean is_highlight)
{
	GnonogramsLabelBox* _tmp0_;
	GnonogramsCell _tmp1_;
	GnonogramsLabelBox* _tmp2_;
	GnonogramsCell _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->row_clue_box;
	_tmp1_ = *c;
	gnonograms_label_box_highlight (_tmp0_, _tmp1_.row, is_highlight);
	_tmp2_ = self->priv->column_clue_box;
	_tmp3_ = *c;
	gnonograms_label_box_highlight (_tmp2_, _tmp3_.col, is_highlight);
}

static void
gnonograms_view_update_all_labels_completeness (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = gnonograms_view_get_rows (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) r) < _tmp3_)) {
					break;
				}
				gnonograms_view_update_label_complete (self, (guint) r, FALSE);
			}
		}
	}
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				guint _tmp6_;
				guint _tmp7_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = c;
					c = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = gnonograms_view_get_cols (self);
				_tmp7_ = _tmp6_;
				if (!(((guint) c) < _tmp7_)) {
					break;
				}
				gnonograms_view_update_label_complete (self, (guint) c, TRUE);
			}
		}
	}
}

static void
gnonograms_view_update_label_complete (GnonogramsView* self,
                                       guint idx,
                                       gboolean is_col)
{
	GnonogramsLabelBox* _tmp0_ = NULL;
	GnonogramsLabelBox* lbox = NULL;
	GnonogramsLabelBox* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GnonogramsGameState _tmp5_;
	g_return_if_fail (self != NULL);
	if (is_col) {
		GnonogramsLabelBox* _tmp1_;
		_tmp1_ = self->priv->column_clue_box;
		_tmp0_ = _tmp1_;
	} else {
		GnonogramsLabelBox* _tmp2_;
		_tmp2_ = self->priv->row_clue_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	lbox = _tmp3_;
	_tmp5_ = self->priv->_game_state;
	if (_tmp5_ == GNONOGRAMS_GAME_STATE_SOLVING) {
		gboolean _tmp6_;
		_tmp6_ = self->priv->_strikeout_complete;
		_tmp4_ = _tmp6_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GeeList* blocks = NULL;
		GeeList* _tmp7_;
		GnonogramsModel* _tmp8_;
		GeeArrayList* _tmp9_;
		GnonogramsLabelBox* _tmp10_;
		GeeList* _tmp11_;
		_tmp7_ = gee_list_empty (GNONOGRAMS_TYPE_BLOCK, (GBoxedCopyFunc) gnonograms_block_ref, (GDestroyNotify) gnonograms_block_unref);
		blocks = _tmp7_;
		_tmp8_ = self->priv->_model;
		_tmp9_ = gnonograms_model_get_complete_blocks_from_working (_tmp8_, idx, is_col);
		_g_object_unref0 (blocks);
		blocks = (GeeList*) _tmp9_;
		_tmp10_ = lbox;
		_tmp11_ = blocks;
		gnonograms_label_box_update_label_complete (_tmp10_, idx, _tmp11_);
		_g_object_unref0 (blocks);
	} else {
		GnonogramsLabelBox* _tmp12_;
		_tmp12_ = lbox;
		gnonograms_label_box_clear_formatting (_tmp12_, idx);
	}
	_g_object_unref0 (lbox);
}

static gboolean
_gnonograms_cell_equal (const GnonogramsCell * s1,
                        const GnonogramsCell * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->row != s2->row) {
		return FALSE;
	}
	if (s1->col != s2->col) {
		return FALSE;
	}
	if (s1->state != s2->state) {
		return FALSE;
	}
	return TRUE;
}

static void
gnonograms_view_make_move_at_cell (GnonogramsView* self,
                                   GnonogramsCellState state,
                                   GnonogramsCell* target)
{
	GnonogramsCell _tmp0_;
	GnonogramsCellState prev_state = 0;
	GnonogramsModel* _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCell cell = {0};
	GnonogramsCell _tmp3_;
	GnonogramsCell _tmp4_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	_tmp0_ = *target;
	if (_gnonograms_cell_equal (&_tmp0_, &GNONOGRAMS_NULL_CELL) == TRUE) {
		return;
	}
	_tmp1_ = self->priv->_model;
	_tmp2_ = *target;
	prev_state = gnonograms_model_get_data_for_cell (_tmp1_, &_tmp2_);
	_tmp3_ = *target;
	gnonograms_view_update_current_and_model (self, state, &_tmp3_, &_tmp4_);
	cell = _tmp4_;
	if (prev_state != state) {
		GnonogramsCell _tmp5_;
		_tmp5_ = cell;
		g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_CHANGED_CELL_SIGNAL], 0, &_tmp5_, prev_state);
	}
}

static void
gnonograms_view_update_current_and_model (GnonogramsView* self,
                                          GnonogramsCellState state,
                                          GnonogramsCell* target,
                                          GnonogramsCell* result)
{
	GnonogramsCell cell = {0};
	GnonogramsCell _tmp0_ = {0};
	GnonogramsModel* _tmp1_;
	GnonogramsCell _tmp2_;
	GnonogramsCell _tmp3_;
	guint row = 0U;
	GnonogramsCell _tmp4_;
	guint col = 0U;
	GnonogramsCell _tmp5_;
	GnonogramsGameState _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	gnonograms_cell_clone (target, &_tmp0_);
	cell = _tmp0_;
	cell.state = state;
	_tmp1_ = self->priv->_model;
	_tmp2_ = cell;
	gnonograms_model_set_data_from_cell (_tmp1_, &_tmp2_);
	_tmp3_ = cell;
	gnonograms_view_update_current_cell (self, &_tmp3_);
	_tmp4_ = self->priv->_current_cell;
	row = _tmp4_.row;
	_tmp5_ = self->priv->_current_cell;
	col = _tmp5_.col;
	_tmp6_ = self->priv->_game_state;
	if (_tmp6_ == GNONOGRAMS_GAME_STATE_SETTING) {
		GnonogramsLabelBox* _tmp7_;
		GnonogramsModel* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GnonogramsLabelBox* _tmp11_;
		GnonogramsModel* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		_tmp7_ = self->priv->row_clue_box;
		_tmp8_ = self->priv->_model;
		_tmp9_ = gnonograms_model_get_label_text_from_solution (_tmp8_, row, FALSE);
		_tmp10_ = _tmp9_;
		gnonograms_label_box_update_label_text (_tmp7_, row, _tmp10_);
		_g_free0 (_tmp10_);
		_tmp11_ = self->priv->column_clue_box;
		_tmp12_ = self->priv->_model;
		_tmp13_ = gnonograms_model_get_label_text_from_solution (_tmp12_, col, TRUE);
		_tmp14_ = _tmp13_;
		gnonograms_label_box_update_label_text (_tmp11_, col, _tmp14_);
		_g_free0 (_tmp14_);
	} else {
		gnonograms_view_update_label_complete (self, row, FALSE);
		gnonograms_view_update_label_complete (self, col, TRUE);
	}
	*result = cell;
	return;
}

static void
gnonograms_view_update_current_cell (GnonogramsView* self,
                                     GnonogramsCell* target)
{
	GnonogramsCell _tmp0_;
	GnonogramsCell _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	_tmp0_ = self->priv->_current_cell;
	gnonograms_view_set_previous_cell (self, &_tmp0_);
	_tmp1_ = *target;
	gnonograms_view_set_current_cell (self, &_tmp1_);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		GnonogramsView* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->cancellable);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static gboolean
__lambda26_ (Block4Data* _data4_)
{
	GnonogramsView* self;
	GnonogramsProgressIndicator* _tmp0_;
	GtkStack* _tmp1_;
	gboolean result = FALSE;
	self = _data4_->self;
	_tmp0_ = self->priv->progress_indicator;
	gnonograms_progress_indicator_set_cancellable (_tmp0_, _data4_->cancellable);
	_tmp1_ = self->priv->progress_stack;
	gtk_stack_set_visible_child_name (_tmp1_, "Progress");
	self->priv->progress_timeout_id = (guint) 0;
	result = FALSE;
	return result;
}

static gboolean
___lambda26__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda26_ (self);
	return result;
}

static void
gnonograms_view_schedule_show_progress (GnonogramsView* self,
                                        GCancellable* cancellable)
{
	Block4Data* _data4_;
	GCancellable* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cancellable != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data4_->cancellable);
	_data4_->cancellable = _tmp0_;
	self->priv->progress_timeout_id = g_timeout_add_full (G_PRIORITY_HIGH_IDLE, GNONOGRAMS_VIEW_PROGRESS_DELAY_MSEC, ___lambda26__gsource_func, block4_data_ref (_data4_), block4_data_unref);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

/*** Signal handlers ***/
static gboolean
gnonograms_view_on_grid_leave (GnonogramsView* self)
{
	GnonogramsLabelBox* _tmp0_;
	GnonogramsLabelBox* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->row_clue_box;
	gnonograms_label_box_unhighlight_all (_tmp0_);
	_tmp1_ = self->priv->column_clue_box;
	gnonograms_label_box_unhighlight_all (_tmp1_);
	result = FALSE;
	return result;
}

static gboolean
gnonograms_view_on_grid_button_press (GnonogramsView* self,
                                      GdkEventButton* event)
{
	gboolean _tmp0_ = FALSE;
	GnonogramsCell _tmp5_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->type == GDK_2BUTTON_PRESS) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = event->button == ((guint) GDK_BUTTON_MIDDLE);
	}
	if (_tmp0_) {
		GnonogramsCellState _tmp1_ = 0;
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = gnonograms_view_get_is_solving (self);
		_tmp3_ = _tmp2_;
		if (_tmp3_) {
			_tmp1_ = GNONOGRAMS_CELL_STATE_UNKNOWN;
		} else {
			_tmp1_ = GNONOGRAMS_CELL_STATE_EMPTY;
		}
		self->priv->drawing_with_state = _tmp1_;
	} else {
		GnonogramsCellState _tmp4_ = 0;
		if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
			_tmp4_ = GNONOGRAMS_CELL_STATE_FILLED;
		} else {
			_tmp4_ = GNONOGRAMS_CELL_STATE_EMPTY;
		}
		self->priv->drawing_with_state = _tmp4_;
	}
	_tmp5_ = self->priv->_current_cell;
	gnonograms_view_make_move_at_cell (self, self->priv->drawing_with_state, &_tmp5_);
	result = TRUE;
	return result;
}

static gboolean
gnonograms_view_on_key_release_event (GnonogramsView* self,
                                      GdkEventKey* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->keyval == self->priv->drawing_with_key) {
		gnonograms_view_stop_painting (self);
	}
	result = FALSE;
	return result;
}

static gboolean
gnonograms_view_stop_painting (GnonogramsView* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->drawing_with_state = GNONOGRAMS_CELL_STATE_UNDEFINED;
	self->priv->drawing_with_key = (guint) 0;
	result = FALSE;
	return result;
}

/** With Control pressed, zoom using the fontsize. **/
static gboolean
gnonograms_view_on_grid_scroll_event (GnonogramsView* self,
                                      GdkEventScroll* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if ((event->state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
		switch (event->direction) {
			case GDK_SCROLL_UP:
			{
				gdouble _tmp0_;
				_tmp0_ = self->priv->_fontheight;
				gnonograms_view_set_fontheight (self, _tmp0_ - 1.0);
				break;
			}
			case GDK_SCROLL_DOWN:
			{
				gdouble _tmp1_;
				_tmp1_ = self->priv->_fontheight;
				gnonograms_view_set_fontheight (self, _tmp1_ + 1.0);
				break;
			}
			default:
			{
				break;
			}
		}
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

/** Action callbacks **/
static void
gnonograms_view_action_restart (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_RESTART_REQUEST_SIGNAL], 0);
}

static void
gnonograms_view_action_solve (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_SOLVE_THIS_REQUEST_SIGNAL], 0);
}

static void
gnonograms_view_action_hint (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_HINT_REQUEST_SIGNAL], 0);
}

static void
gnonograms_view_action_debug_row (GnonogramsView* self)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_cell;
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_DEBUG_REQUEST_SIGNAL], 0, _tmp0_.row, FALSE);
}

static void
gnonograms_view_action_debug_col (GnonogramsView* self)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_cell;
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_DEBUG_REQUEST_SIGNAL], 0, _tmp0_.col, TRUE);
}

static void
gnonograms_view_action_undo (GnonogramsView* self)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_PREVIOUS_MOVE_REQUEST_SIGNAL], 0, &_tmp0_);
}

static void
gnonograms_view_action_redo (GnonogramsView* self)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_NEXT_MOVE_REQUEST_SIGNAL], 0, &_tmp0_);
}

static void
gnonograms_view_action_open (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_OPEN_GAME_REQUEST_SIGNAL], 0);
}

static void
gnonograms_view_action_save (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_SAVE_GAME_REQUEST_SIGNAL], 0);
}

static void
gnonograms_view_action_save_as (GnonogramsView* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_SAVE_GAME_AS_REQUEST_SIGNAL], 0);
}

static void
gnonograms_view_action_zoom (GnonogramsView* self,
                             GSimpleAction* action,
                             GVariant* param)
{
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->priv->_fontheight;
	gnonograms_view_set_fontheight (self, _tmp0_ + g_variant_get_int32 (param));
}

static void
gnonograms_view_action_check_errors (GnonogramsView* self)
{
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	g_signal_emit (self, gnonograms_view_signals[GNONOGRAMS_VIEW_REWIND_REQUEST_SIGNAL], 0, &_tmp0_);
	if (_tmp0_ == ((guint) 0)) {
		gnonograms_view_send_notification (self, _ ("No errors"));
	}
}

static void
gnonograms_view_action_move_cursor (GnonogramsView* self,
                                    GSimpleAction* action,
                                    GVariant* param)
{
	gint dr = 0;
	gint dc = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GnonogramsCell _tmp2_;
	GnonogramsCell target = {0};
	GnonogramsCell _tmp3_;
	GnonogramsCell _tmp4_;
	GnonogramsCell _tmp5_ = {0};
	gboolean _tmp6_ = FALSE;
	GnonogramsCell _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	GnonogramsCell _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	g_variant_get_child (param, (gsize) 0, "i", &_tmp0_, NULL);
	dr = _tmp0_;
	g_variant_get_child (param, (gsize) 1, "i", &_tmp1_, NULL);
	dc = _tmp1_;
	_tmp2_ = self->priv->_current_cell;
	if (_gnonograms_cell_equal (&_tmp2_, &GNONOGRAMS_NULL_CELL) == TRUE) {
		return;
	}
	_tmp3_ = self->priv->_current_cell;
	_tmp4_ = self->priv->_current_cell;
	_tmp5_.row = _tmp3_.row + dr;
	_tmp5_.col = _tmp4_.col + dc;
	_tmp5_.state = GNONOGRAMS_CELL_STATE_UNDEFINED;
	target = _tmp5_;
	_tmp7_ = target;
	_tmp8_ = gnonograms_view_get_rows (self);
	_tmp9_ = _tmp8_;
	if (_tmp7_.row >= _tmp9_) {
		_tmp6_ = TRUE;
	} else {
		GnonogramsCell _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
		_tmp10_ = target;
		_tmp11_ = gnonograms_view_get_cols (self);
		_tmp12_ = _tmp11_;
		_tmp6_ = _tmp10_.col >= _tmp12_;
	}
	if (_tmp6_) {
		return;
	}
	_tmp13_ = target;
	gnonograms_view_update_current_cell (self, &_tmp13_);
}

static void
gnonograms_view_action_set_mode (GnonogramsView* self,
                                 GSimpleAction* action,
                                 GVariant* param)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	gnonograms_view_set_game_state (self, (GnonogramsGameState) g_variant_get_uint32 (param));
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
	g_boxed_free (gdk_event_get_type (), self);
}

static void
gnonograms_view_action_paint_cell (GnonogramsView* self,
                                   GSimpleAction* action,
                                   GVariant* param)
{
	GnonogramsCellState cs = 0;
	gboolean _tmp0_ = FALSE;
	GdkEvent* current_event = NULL;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GnonogramsCell _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	cs = (GnonogramsCellState) g_variant_get_uint32 (param);
	if (cs == GNONOGRAMS_CELL_STATE_UNKNOWN) {
		gboolean _tmp1_;
		gboolean _tmp2_;
		_tmp1_ = gnonograms_view_get_is_solving (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = !_tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	self->priv->drawing_with_state = cs;
	_tmp3_ = gtk_get_current_event ();
	current_event = _tmp3_;
	_tmp4_ = current_event;
	if (_tmp4_->type == GDK_KEY_PRESS) {
		GdkEvent* _tmp5_;
		_tmp5_ = current_event;
		self->priv->drawing_with_key = ((GdkEventKey*) _tmp5_)->keyval;
	}
	_tmp6_ = self->priv->_current_cell;
	gnonograms_view_make_move_at_cell (self, self->priv->drawing_with_state, &_tmp6_);
	__vala_GdkEvent_free0 (current_event);
}

static GnonogramsModel*
gnonograms_view_get_model (GnonogramsView* self)
{
	GnonogramsModel* result;
	GnonogramsModel* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_model;
	result = _tmp0_;
	return result;
}

static void
gnonograms_view_set_model (GnonogramsView* self,
                           GnonogramsModel* value)
{
	GnonogramsModel* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_model (self);
	if (old_value != value) {
		GnonogramsModel* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_model);
		self->priv->_model = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_MODEL_PROPERTY]);
	}
}

GnonogramsController*
gnonograms_view_get_controller (GnonogramsView* self)
{
	GnonogramsController* result;
	GnonogramsController* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_controller;
	result = _tmp0_;
	return result;
}

static void
gnonograms_view_set_controller (GnonogramsView* self,
                                GnonogramsController* value)
{
	GnonogramsController* old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_controller (self);
	if (old_value != value) {
		self->priv->_controller = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CONTROLLER_PROPERTY]);
	}
}

void
gnonograms_view_get_dimensions (GnonogramsView* self,
                                GnonogramsDimensions * result)
{
	GnonogramsDimensions _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_dimensions;
	*result = _tmp0_;
	return;
}

static gboolean
_gnonograms_dimensions_equal (const GnonogramsDimensions * s1,
                              const GnonogramsDimensions * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->width != s2->width) {
		return FALSE;
	}
	if (s1->height != s2->height) {
		return FALSE;
	}
	return TRUE;
}

void
gnonograms_view_set_dimensions (GnonogramsView* self,
                                GnonogramsDimensions * value)
{
	GnonogramsDimensions old_value;
	g_return_if_fail (self != NULL);
	gnonograms_view_get_dimensions (self, &old_value);
	if (_gnonograms_dimensions_equal (value, &old_value) != TRUE) {
		GnonogramsDimensions _tmp0_;
		_tmp0_ = *value;
		self->priv->_dimensions = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_DIMENSIONS_PROPERTY]);
	}
}

GnonogramsDifficulty
gnonograms_view_get_generator_grade (GnonogramsView* self)
{
	GnonogramsDifficulty result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_generator_grade;
	return result;
}

void
gnonograms_view_set_generator_grade (GnonogramsView* self,
                                     GnonogramsDifficulty value)
{
	GnonogramsDifficulty old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_generator_grade (self);
	if (old_value != value) {
		self->priv->_generator_grade = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY]);
	}
}

GnonogramsGameState
gnonograms_view_get_game_state (GnonogramsView* self)
{
	GnonogramsGameState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_game_state;
	return result;
}

void
gnonograms_view_set_game_state (GnonogramsView* self,
                                GnonogramsGameState value)
{
	GnonogramsGameState old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_game_state (self);
	if (old_value != value) {
		self->priv->_game_state = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_GAME_STATE_PROPERTY]);
	}
}

gboolean
gnonograms_view_get_strikeout_complete (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_strikeout_complete;
	return result;
}

void
gnonograms_view_set_strikeout_complete (GnonogramsView* self,
                                        gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_strikeout_complete (self);
	if (old_value != value) {
		self->priv->_strikeout_complete = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY]);
	}
}

const gchar*
gnonograms_view_get_game_name (GnonogramsView* self)
{
	const gchar* result;
	GnonogramsController* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_controller;
	_tmp1_ = gnonograms_controller_get_game_name (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

gboolean
gnonograms_view_get_readonly (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_readonly;
	return result;
}

void
gnonograms_view_set_readonly (GnonogramsView* self,
                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_readonly (self);
	if (old_value != value) {
		self->priv->_readonly = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_READONLY_PROPERTY]);
	}
}

GnonogramsDifficulty
gnonograms_view_get_game_grade (GnonogramsView* self)
{
	GnonogramsDifficulty result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_game_grade;
	return result;
}

void
gnonograms_view_set_game_grade (GnonogramsView* self,
                                GnonogramsDifficulty value)
{
	GnonogramsDifficulty old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_game_grade (self);
	if (old_value != value) {
		self->priv->_game_grade = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY]);
	}
}

gdouble
gnonograms_view_get_fontheight (GnonogramsView* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_fontheight;
	return result;
}

void
gnonograms_view_set_fontheight (GnonogramsView* self,
                                gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_fontheight (self);
	if (old_value != value) {
		self->priv->_fontheight = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_FONTHEIGHT_PROPERTY]);
	}
}

gboolean
gnonograms_view_get_can_go_back (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_go_back;
	return result;
}

void
gnonograms_view_set_can_go_back (GnonogramsView* self,
                                 gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_can_go_back (self);
	if (old_value != value) {
		self->priv->_can_go_back = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY]);
	}
}

gboolean
gnonograms_view_get_can_go_forward (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_go_forward;
	return result;
}

void
gnonograms_view_set_can_go_forward (GnonogramsView* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_can_go_forward (self);
	if (old_value != value) {
		self->priv->_can_go_forward = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY]);
	}
}

gboolean
gnonograms_view_get_restart_destructive (GnonogramsView* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_restart_destructive;
	return result;
}

void
gnonograms_view_set_restart_destructive (GnonogramsView* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_view_get_restart_destructive (self);
	if (old_value != value) {
		self->priv->_restart_destructive = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY]);
	}
}

void
gnonograms_view_get_current_cell (GnonogramsView* self,
                                  GnonogramsCell * result)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_cell;
	*result = _tmp0_;
	return;
}

void
gnonograms_view_set_current_cell (GnonogramsView* self,
                                  GnonogramsCell * value)
{
	GnonogramsCell old_value;
	g_return_if_fail (self != NULL);
	gnonograms_view_get_current_cell (self, &old_value);
	if (_gnonograms_cell_equal (value, &old_value) != TRUE) {
		GnonogramsCell _tmp0_;
		_tmp0_ = *value;
		self->priv->_current_cell = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY]);
	}
}

void
gnonograms_view_get_previous_cell (GnonogramsView* self,
                                   GnonogramsCell * result)
{
	GnonogramsCell _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_previous_cell;
	*result = _tmp0_;
	return;
}

void
gnonograms_view_set_previous_cell (GnonogramsView* self,
                                   GnonogramsCell * value)
{
	GnonogramsCell old_value;
	g_return_if_fail (self != NULL);
	gnonograms_view_get_previous_cell (self, &old_value);
	if (_gnonograms_cell_equal (value, &old_value) != TRUE) {
		GnonogramsCell _tmp0_;
		_tmp0_ = *value;
		self->priv->_previous_cell = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_view_properties[GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY]);
	}
}

static guint
gnonograms_view_get_rows (GnonogramsView* self)
{
	guint result;
	GnonogramsDimensions _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_dimensions;
	result = gnonograms_dimensions_rows (&_tmp0_);
	return result;
}

static guint
gnonograms_view_get_cols (GnonogramsView* self)
{
	guint result;
	GnonogramsDimensions _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_dimensions;
	result = gnonograms_dimensions_cols (&_tmp0_);
	return result;
}

static gboolean
gnonograms_view_get_is_solving (GnonogramsView* self)
{
	gboolean result;
	GnonogramsGameState _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_game_state;
	result = _tmp0_ == GNONOGRAMS_GAME_STATE_SOLVING;
	return result;
}

static void
g_cclosure_user_marshal_UINT__VOID (GClosure * closure,
                                    GValue * return_value,
                                    guint n_param_values,
                                    const GValue * param_values,
                                    gpointer invocation_hint,
                                    gpointer marshal_data)
{
	typedef guint (*GMarshalFunc_UINT__VOID) (gpointer data1, gpointer data2);
	register GMarshalFunc_UINT__VOID callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	guint v_return;
	cc = (GCClosure *) closure;
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 1);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_UINT__VOID) (marshal_data ? marshal_data : cc->callback);
	v_return = callback (data1, data2);
	g_value_set_uint (return_value, v_return);
}

static void
g_cclosure_user_marshal_BOOLEAN__VOID (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__VOID) (gpointer data1, gpointer data2);
	register GMarshalFunc_BOOLEAN__VOID callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 1);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_BOOLEAN__VOID) (marshal_data ? marshal_data : cc->callback);
	v_return = callback (data1, data2);
	g_value_set_boolean (return_value, v_return);
}

static void
g_cclosure_user_marshal_VOID__UINT_BOOLEAN (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_BOOLEAN) (gpointer data1, guint arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__BOXED_ENUM (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_enum (param_values + 2), data2);
}

static gboolean
_gnonograms_view_on_grid_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                               GdkEventScroll* event,
                                                               gpointer self)
{
	gboolean result;
	result = gnonograms_view_on_grid_scroll_event ((GnonogramsView*) self, event);
	return result;
}

static gboolean
_gnonograms_view_on_grid_leave_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                              GdkEventCrossing* event,
                                                              gpointer self)
{
	gboolean result;
	result = gnonograms_view_on_grid_leave ((GnonogramsView*) self);
	return result;
}

static gboolean
_gnonograms_view_on_grid_button_press_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                     GdkEventButton* event,
                                                                     gpointer self)
{
	gboolean result;
	result = gnonograms_view_on_grid_button_press ((GnonogramsView*) self, event);
	return result;
}

static gboolean
_gnonograms_view_stop_painting_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                GdkEventButton* event,
                                                                gpointer self)
{
	gboolean result;
	result = gnonograms_view_stop_painting ((GnonogramsView*) self);
	return result;
}

static gboolean
_gnonograms_view_on_key_release_event_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                    GdkEventKey* event,
                                                                    gpointer self)
{
	gboolean result;
	result = gnonograms_view_on_key_release_event ((GnonogramsView*) self, event);
	return result;
}

static void
_gnonograms_view___lambda28_ (GnonogramsView* self)
{
	GnonogramsGameState _tmp0_;
	_tmp0_ = self->priv->_game_state;
	if (_tmp0_ != GNONOGRAMS_GAME_STATE_UNDEFINED) {
		gnonograms_view_update_all_labels_completeness (self);
	}
}

static void
__gnonograms_view___lambda28__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda28_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda29_ (GnonogramsView* self)
{
	gnonograms_view_set_fontheight (self, gnonograms_view_get_default_fontheight_from_dimensions (self));
	gnonograms_view_set_window_size (self);
}

static void
__gnonograms_view___lambda29__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda29_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda30_ (GnonogramsView* self)
{
	GnonogramsViewModeButton* _tmp0_;
	GnonogramsDifficulty _tmp1_;
	_tmp0_ = self->priv->mode_switch;
	_tmp1_ = self->priv->_generator_grade;
	gnonograms_view_mode_button_set_grade (_tmp0_, _tmp1_);
}

static void
__gnonograms_view___lambda30__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda30_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda31_ (GnonogramsView* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->title_label;
	_tmp1_ = gnonograms_view_get_game_name (self);
	_tmp2_ = _tmp1_;
	gtk_label_set_label (_tmp0_, _tmp2_);
}

static void
__gnonograms_view___lambda31__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda31_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda32_ (GnonogramsView* self)
{
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->save_game_button;
	_tmp1_ = self->priv->_readonly;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp1_);
}

static void
__gnonograms_view___lambda32__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda32_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda33_ (GnonogramsView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	_tmp1_ = self->priv->_can_go_back;
	if (_tmp1_) {
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp2_ = gnonograms_view_get_is_solving (self);
		_tmp3_ = _tmp2_;
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp4_ = self->priv->check_correct_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, _tmp0_);
	_tmp5_ = self->priv->undo_button;
	_tmp6_ = self->priv->_can_go_back;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, _tmp6_);
	_tmp7_ = self->priv->_restart_destructive;
	_tmp8_ = self->priv->_can_go_back;
	gnonograms_view_set_restart_destructive (self, _tmp7_ | _tmp8_);
}

static void
__gnonograms_view___lambda33__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda33_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda34_ (GnonogramsView* self)
{
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = self->priv->redo_button;
	_tmp1_ = self->priv->_can_go_forward;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp1_);
}

static void
__gnonograms_view___lambda34__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda34_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda35_ (GnonogramsView* self)
{
	GnonogramsCell _tmp0_;
	GnonogramsCell _tmp1_;
	_tmp0_ = self->priv->_previous_cell;
	gnonograms_view_highlight_labels (self, &_tmp0_, FALSE);
	_tmp1_ = self->priv->_current_cell;
	gnonograms_view_highlight_labels (self, &_tmp1_, TRUE);
	if (self->priv->drawing_with_state != GNONOGRAMS_CELL_STATE_UNDEFINED) {
		GnonogramsCell _tmp2_;
		_tmp2_ = self->priv->_current_cell;
		gnonograms_view_make_move_at_cell (self, self->priv->drawing_with_state, &_tmp2_);
	}
}

static void
__gnonograms_view___lambda35__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda35_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda36_ (GnonogramsView* self)
{
	gnonograms_view_update_all_labels_completeness (self);
}

static void
__gnonograms_view___lambda36__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda36_ ((GnonogramsView*) self);
}

static void
_gnonograms_view___lambda37_ (GnonogramsView* self)
{
	gdouble _tmp0_;
	_tmp0_ = self->priv->_fontheight;
	gnonograms_view_set_fontheight (self, CLAMP (_tmp0_, GNONOGRAMS_MINFONTSIZE, GNONOGRAMS_MAXFONTSIZE));
	gnonograms_view_set_window_size (self);
}

static void
__gnonograms_view___lambda37__g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	_gnonograms_view___lambda37_ ((GnonogramsView*) self);
}

static void
_gnonograms_view_set_window_size_gtk_widget_realize (GtkWidget* _sender,
                                                     gpointer self)
{
	gnonograms_view_set_window_size ((GnonogramsView*) self);
}

static GObject *
gnonograms_view_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsView * self;
	GSimpleActionGroup* view_actions = NULL;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GnonogramsApp* application = NULL;
	GnonogramsApp* _tmp4_;
	GnonogramsApp* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GnonogramsApp* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	GnonogramsApp* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	GnonogramsApp* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	GnonogramsApp* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	GnonogramsApp* _tmp25_;
	gchar* _tmp26_;
	gchar** _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	GnonogramsApp* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	GnonogramsApp* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar** _tmp38_;
	gchar** _tmp39_;
	gint _tmp39__length1;
	GnonogramsApp* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar** _tmp44_;
	gchar** _tmp45_;
	gint _tmp45__length1;
	GnonogramsApp* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar** _tmp50_;
	gchar** _tmp51_;
	gint _tmp51__length1;
	GnonogramsApp* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar** _tmp57_;
	gchar** _tmp58_;
	gint _tmp58__length1;
	GnonogramsApp* _tmp59_;
	gchar* _tmp60_;
	gchar** _tmp61_;
	gchar** _tmp62_;
	gint _tmp62__length1;
	GnonogramsApp* _tmp63_;
	gchar* _tmp64_;
	gchar** _tmp65_;
	gchar** _tmp66_;
	gint _tmp66__length1;
	GnonogramsApp* _tmp67_;
	gchar* _tmp68_;
	gchar** _tmp69_;
	gchar** _tmp70_;
	gint _tmp70__length1;
	GnonogramsApp* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar** _tmp75_;
	gchar** _tmp76_;
	gint _tmp76__length1;
	GnonogramsApp* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	gchar** _tmp81_;
	gchar** _tmp82_;
	gint _tmp82__length1;
	GnonogramsApp* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* _tmp86_;
	gchar** _tmp87_;
	gchar** _tmp88_;
	gint _tmp88__length1;
	GnonogramsApp* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	gchar** _tmp93_;
	gchar** _tmp94_;
	gint _tmp94__length1;
	GnonogramsApp* _tmp95_;
	gchar* _tmp96_;
	gchar* _tmp97_;
	gchar** _tmp98_;
	gchar** _tmp99_;
	gint _tmp99__length1;
	GnonogramsApp* _tmp100_;
	gchar* _tmp101_;
	gchar* _tmp102_;
	gchar** _tmp103_;
	gchar** _tmp104_;
	gint _tmp104__length1;
	GnonogramsApp* _tmp105_;
	gchar* _tmp106_;
	gchar** _tmp107_;
	gchar** _tmp108_;
	gint _tmp108__length1;
	GnonogramsApp* _tmp109_;
	gchar* _tmp110_;
	gchar** _tmp111_;
	gchar** _tmp112_;
	gint _tmp112__length1;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp113_;
	GtkIconTheme* default_theme = NULL;
	GtkIconTheme* _tmp120_;
	GtkIconTheme* _tmp121_;
	GtkHeaderBar* _tmp122_;
	GtkHeaderBar* _tmp123_;
	GtkStyleContext* _tmp124_;
	GtkHeaderBar* _tmp125_;
	GtkStyleContext* _tmp126_;
	GtkHeaderBar* _tmp127_;
	GtkHeaderBar* _tmp128_;
	GnonogramsHeaderButton* _tmp129_;
	GnonogramsHeaderButton* _tmp130_;
	GnonogramsHeaderButton* _tmp131_;
	GnonogramsHeaderButton* _tmp132_;
	GtkButton* _tmp133_;
	GnonogramsHeaderButton* _tmp134_;
	GtkButton* _tmp135_;
	GnonogramsHeaderButton* _tmp136_;
	GtkButton* _tmp137_;
	GnonogramsRestartButton* _tmp138_;
	GnonogramsHeaderButton* _tmp139_;
	GtkButton* _tmp140_;
	GnonogramsHeaderButton* _tmp141_;
	GtkButton* _tmp142_;
	GnonogramsController* _tmp143_;
	GnonogramsAppMenu* _tmp144_;
	GnonogramsViewModeButton* _tmp145_;
	GnonogramsViewModeButton* _tmp146_;
	GnonogramsViewModeButton* _tmp147_;
	GnonogramsViewModeButton* _tmp148_;
	GtkStyleContext* _tmp149_;
	GnonogramsProgressIndicator* _tmp150_;
	GnonogramsProgressIndicator* _tmp151_;
	GtkStyleContext* _tmp152_;
	GtkLabel* _tmp153_;
	GtkLabel* _tmp154_;
	GtkStyleContext* _tmp155_;
	GtkLabel* _tmp156_;
	GtkStyleContext* _tmp157_;
	GtkLabel* _tmp158_;
	GtkStack* _tmp159_;
	GtkStack* _tmp160_;
	GnonogramsProgressIndicator* _tmp161_;
	GtkStack* _tmp162_;
	GtkLabel* _tmp163_;
	GtkStack* _tmp164_;
	GtkStack* _tmp165_;
	GtkHeaderBar* _tmp166_;
	GtkButton* _tmp167_;
	GtkHeaderBar* _tmp168_;
	GtkButton* _tmp169_;
	GtkHeaderBar* _tmp170_;
	GtkButton* _tmp171_;
	GtkHeaderBar* _tmp172_;
	GtkSeparator* _tmp173_;
	GtkSeparator* _tmp174_;
	GtkHeaderBar* _tmp175_;
	GtkButton* _tmp176_;
	GtkHeaderBar* _tmp177_;
	GtkButton* _tmp178_;
	GtkHeaderBar* _tmp179_;
	GtkButton* _tmp180_;
	GtkHeaderBar* _tmp181_;
	GtkButton* _tmp182_;
	GtkHeaderBar* _tmp183_;
	GnonogramsAppMenu* _tmp184_;
	GtkHeaderBar* _tmp185_;
	GtkSeparator* _tmp186_;
	GtkSeparator* _tmp187_;
	GtkHeaderBar* _tmp188_;
	GnonogramsViewModeButton* _tmp189_;
	GtkHeaderBar* _tmp190_;
	GtkSeparator* _tmp191_;
	GtkSeparator* _tmp192_;
	GtkHeaderBar* _tmp193_;
	GtkButton* _tmp194_;
	GtkHeaderBar* _tmp195_;
	GtkButton* _tmp196_;
	GtkHeaderBar* _tmp197_;
	GtkStack* _tmp198_;
	GtkHeaderBar* _tmp199_;
	GtkOverlay* _tmp200_;
	GraniteWidgetsToast* _tmp201_;
	GraniteWidgetsToast* _tmp202_;
	GraniteWidgetsToast* _tmp203_;
	GraniteWidgetsToast* _tmp204_;
	GtkOverlay* _tmp205_;
	GraniteWidgetsToast* _tmp206_;
	GnonogramsLabelBox* _tmp207_;
	GnonogramsLabelBox* _tmp208_;
	GnonogramsModel* _tmp209_;
	GnonogramsCellGrid* _tmp210_;
	GtkGrid* _tmp211_;
	GtkGrid* _tmp212_;
	GnonogramsCellGrid* _tmp213_;
	GtkGrid* _tmp214_;
	GtkGrid* _tmp215_;
	GtkGrid* _tmp216_;
	GtkGrid* _tmp217_;
	GnonogramsLabelBox* _tmp218_;
	GtkGrid* _tmp219_;
	GnonogramsLabelBox* _tmp220_;
	GtkEventBox* ev = NULL;
	GtkEventBox* _tmp221_;
	GtkEventBox* _tmp222_;
	GtkEventBox* _tmp223_;
	GtkEventBox* _tmp224_;
	GtkGrid* _tmp225_;
	GtkScrolledWindow* sw = NULL;
	GtkScrolledWindow* _tmp226_;
	GtkScrolledWindow* _tmp227_;
	GtkEventBox* _tmp228_;
	GtkOverlay* _tmp229_;
	GtkScrolledWindow* _tmp230_;
	GtkOverlay* _tmp231_;
	GnonogramsCellGrid* _tmp232_;
	GnonogramsCellGrid* _tmp233_;
	GnonogramsCellGrid* _tmp234_;
	GtkButton* _tmp235_;
	GtkButton* _tmp236_;
	GtkButton* _tmp237_;
	GtkButton* _tmp238_;
	GtkButton* _tmp239_;
	GtkButton* _tmp240_;
	GtkButton* _tmp241_;
	GtkButton* _tmp242_;
	GtkButton* _tmp243_;
	GBindingFlags flags = 0U;
	GtkButton* _tmp244_;
	GnonogramsAppMenu* _tmp245_;
	GnonogramsAppMenu* _tmp246_;
	GnonogramsController* _tmp247_;
	GnonogramsAppMenu* _tmp248_;
	GnonogramsAppMenu* _tmp249_;
	GnonogramsViewModeButton* _tmp250_;
	GnonogramsCellGrid* _tmp251_;
	GnonogramsCellGrid* _tmp252_;
	GnonogramsLabelBox* _tmp253_;
	GnonogramsLabelBox* _tmp254_;
	GnonogramsLabelBox* _tmp255_;
	GnonogramsLabelBox* _tmp256_;
	GnonogramsController* _tmp257_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (gnonograms_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_VIEW, GnonogramsView);
	_tmp0_ = g_simple_action_group_new ();
	view_actions = _tmp0_;
	_tmp1_ = view_actions;
	g_action_map_add_action_entries ((GActionMap*) _tmp1_, GNONOGRAMS_VIEW_VIEW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (GNONOGRAMS_VIEW_VIEW_ACTION_ENTRIES), self);
	_tmp2_ = view_actions;
	g_action_map_add_action_entries ((GActionMap*) _tmp2_, GNONOGRAMS_VIEW_VIEW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (GNONOGRAMS_VIEW_VIEW_ACTION_ENTRIES), self);
	_tmp3_ = view_actions;
	gtk_widget_insert_action_group ((GtkWidget*) self, "view", (GActionGroup*) _tmp3_);
	_tmp4_ = gnonograms_get_app ();
	application = _tmp4_;
	_tmp5_ = application;
	_tmp6_ = g_strdup ("<Ctrl>Z");
	_tmp7_ = g_new0 (gchar*, 1 + 1);
	_tmp7_[0] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp5_, "view.undo", _tmp8_);
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
	_tmp9_ = application;
	_tmp10_ = g_strdup ("<Ctrl><Shift>Z");
	_tmp11_ = g_new0 (gchar*, 1 + 1);
	_tmp11_[0] = _tmp10_;
	_tmp12_ = _tmp11_;
	_tmp12__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp9_, "view.redo", _tmp12_);
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
	_tmp13_ = application;
	_tmp14_ = g_strdup ("Up");
	_tmp15_ = g_new0 (gchar*, 1 + 1);
	_tmp15_[0] = _tmp14_;
	_tmp16_ = _tmp15_;
	_tmp16__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp13_, "view.move-cursor((-1, 0))", _tmp16_);
	_tmp16_ = (_vala_array_free (_tmp16_, _tmp16__length1, (GDestroyNotify) g_free), NULL);
	_tmp17_ = application;
	_tmp18_ = g_strdup ("Down");
	_tmp19_ = g_new0 (gchar*, 1 + 1);
	_tmp19_[0] = _tmp18_;
	_tmp20_ = _tmp19_;
	_tmp20__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp17_, "view.move-cursor((1, 0))", _tmp20_);
	_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
	_tmp21_ = application;
	_tmp22_ = g_strdup ("Left");
	_tmp23_ = g_new0 (gchar*, 1 + 1);
	_tmp23_[0] = _tmp22_;
	_tmp24_ = _tmp23_;
	_tmp24__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp21_, "view.move-cursor((0, -1))", _tmp24_);
	_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) g_free), NULL);
	_tmp25_ = application;
	_tmp26_ = g_strdup ("Right");
	_tmp27_ = g_new0 (gchar*, 1 + 1);
	_tmp27_[0] = _tmp26_;
	_tmp28_ = _tmp27_;
	_tmp28__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp25_, "view.move-cursor((0, 1))", _tmp28_);
	_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
	_tmp29_ = application;
	_tmp30_ = g_strdup ("<Ctrl>plus");
	_tmp31_ = g_strdup ("<Ctrl>equal");
	_tmp32_ = g_strdup ("<Ctrl>KP_Add");
	_tmp33_ = g_new0 (gchar*, 3 + 1);
	_tmp33_[0] = _tmp30_;
	_tmp33_[1] = _tmp31_;
	_tmp33_[2] = _tmp32_;
	_tmp34_ = _tmp33_;
	_tmp34__length1 = 3;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp29_, "view.zoom(int32 1)", _tmp34_);
	_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
	_tmp35_ = application;
	_tmp36_ = g_strdup ("<Ctrl>minus");
	_tmp37_ = g_strdup ("<Ctrl>KP_Subtract");
	_tmp38_ = g_new0 (gchar*, 2 + 1);
	_tmp38_[0] = _tmp36_;
	_tmp38_[1] = _tmp37_;
	_tmp39_ = _tmp38_;
	_tmp39__length1 = 2;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp35_, "view.zoom(int32 -1)", _tmp39_);
	_tmp39_ = (_vala_array_free (_tmp39_, _tmp39__length1, (GDestroyNotify) g_free), NULL);
	_tmp40_ = application;
	_tmp41_ = g_strdup_printf ("view.set-mode(uint32 %u)", (guint) GNONOGRAMS_GAME_STATE_SETTING);
	_tmp42_ = _tmp41_;
	_tmp43_ = g_strdup ("<Ctrl>1");
	_tmp44_ = g_new0 (gchar*, 1 + 1);
	_tmp44_[0] = _tmp43_;
	_tmp45_ = _tmp44_;
	_tmp45__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp40_, _tmp42_, _tmp45_);
	_tmp45_ = (_vala_array_free (_tmp45_, _tmp45__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp42_);
	_tmp46_ = application;
	_tmp47_ = g_strdup_printf ("view.set-mode(uint32 %u)", (guint) GNONOGRAMS_GAME_STATE_SOLVING);
	_tmp48_ = _tmp47_;
	_tmp49_ = g_strdup ("<Ctrl>2");
	_tmp50_ = g_new0 (gchar*, 1 + 1);
	_tmp50_[0] = _tmp49_;
	_tmp51_ = _tmp50_;
	_tmp51__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp46_, _tmp48_, _tmp51_);
	_tmp51_ = (_vala_array_free (_tmp51_, _tmp51__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp48_);
	_tmp52_ = application;
	_tmp53_ = g_strdup_printf ("view.set-mode(uint32 %u)", (guint) GNONOGRAMS_GAME_STATE_GENERATING);
	_tmp54_ = _tmp53_;
	_tmp55_ = g_strdup ("<Ctrl>3");
	_tmp56_ = g_strdup ("<Ctrl>N");
	_tmp57_ = g_new0 (gchar*, 2 + 1);
	_tmp57_[0] = _tmp55_;
	_tmp57_[1] = _tmp56_;
	_tmp58_ = _tmp57_;
	_tmp58__length1 = 2;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp52_, _tmp54_, _tmp58_);
	_tmp58_ = (_vala_array_free (_tmp58_, _tmp58__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp54_);
	_tmp59_ = application;
	_tmp60_ = g_strdup ("<Ctrl>O");
	_tmp61_ = g_new0 (gchar*, 1 + 1);
	_tmp61_[0] = _tmp60_;
	_tmp62_ = _tmp61_;
	_tmp62__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp59_, "view.open", _tmp62_);
	_tmp62_ = (_vala_array_free (_tmp62_, _tmp62__length1, (GDestroyNotify) g_free), NULL);
	_tmp63_ = application;
	_tmp64_ = g_strdup ("<Ctrl>S");
	_tmp65_ = g_new0 (gchar*, 1 + 1);
	_tmp65_[0] = _tmp64_;
	_tmp66_ = _tmp65_;
	_tmp66__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp63_, "view.save", _tmp66_);
	_tmp66_ = (_vala_array_free (_tmp66_, _tmp66__length1, (GDestroyNotify) g_free), NULL);
	_tmp67_ = application;
	_tmp68_ = g_strdup ("<Ctrl><Shift>S");
	_tmp69_ = g_new0 (gchar*, 1 + 1);
	_tmp69_[0] = _tmp68_;
	_tmp70_ = _tmp69_;
	_tmp70__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp67_, "view.save-as", _tmp70_);
	_tmp70_ = (_vala_array_free (_tmp70_, _tmp70__length1, (GDestroyNotify) g_free), NULL);
	_tmp71_ = application;
	_tmp72_ = g_strdup_printf ("view.paint-cell(uint32 %u)", (guint) GNONOGRAMS_CELL_STATE_FILLED);
	_tmp73_ = _tmp72_;
	_tmp74_ = g_strdup ("F");
	_tmp75_ = g_new0 (gchar*, 1 + 1);
	_tmp75_[0] = _tmp74_;
	_tmp76_ = _tmp75_;
	_tmp76__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp71_, _tmp73_, _tmp76_);
	_tmp76_ = (_vala_array_free (_tmp76_, _tmp76__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp73_);
	_tmp77_ = application;
	_tmp78_ = g_strdup_printf ("view.paint-cell(uint32 %u)", (guint) GNONOGRAMS_CELL_STATE_EMPTY);
	_tmp79_ = _tmp78_;
	_tmp80_ = g_strdup ("E");
	_tmp81_ = g_new0 (gchar*, 1 + 1);
	_tmp81_[0] = _tmp80_;
	_tmp82_ = _tmp81_;
	_tmp82__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp77_, _tmp79_, _tmp82_);
	_tmp82_ = (_vala_array_free (_tmp82_, _tmp82__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp79_);
	_tmp83_ = application;
	_tmp84_ = g_strdup_printf ("view.paint-cell(uint32 %u)", (guint) GNONOGRAMS_CELL_STATE_UNKNOWN);
	_tmp85_ = _tmp84_;
	_tmp86_ = g_strdup ("X");
	_tmp87_ = g_new0 (gchar*, 1 + 1);
	_tmp87_[0] = _tmp86_;
	_tmp88_ = _tmp87_;
	_tmp88__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp83_, _tmp85_, _tmp88_);
	_tmp88_ = (_vala_array_free (_tmp88_, _tmp88__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp85_);
	_tmp89_ = application;
	_tmp90_ = g_strdup ("F7");
	_tmp91_ = g_strdup ("less");
	_tmp92_ = g_strdup ("comma");
	_tmp93_ = g_new0 (gchar*, 3 + 1);
	_tmp93_[0] = _tmp90_;
	_tmp93_[1] = _tmp91_;
	_tmp93_[2] = _tmp92_;
	_tmp94_ = _tmp93_;
	_tmp94__length1 = 3;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp89_, "view.check-errors", _tmp94_);
	_tmp94_ = (_vala_array_free (_tmp94_, _tmp94__length1, (GDestroyNotify) g_free), NULL);
	_tmp95_ = application;
	_tmp96_ = g_strdup ("F5");
	_tmp97_ = g_strdup ("<Ctrl>R");
	_tmp98_ = g_new0 (gchar*, 2 + 1);
	_tmp98_[0] = _tmp96_;
	_tmp98_[1] = _tmp97_;
	_tmp99_ = _tmp98_;
	_tmp99__length1 = 2;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp95_, "view.restart", _tmp99_);
	_tmp99_ = (_vala_array_free (_tmp99_, _tmp99__length1, (GDestroyNotify) g_free), NULL);
	_tmp100_ = application;
	_tmp101_ = g_strdup ("F9");
	_tmp102_ = g_strdup ("<Ctrl>H");
	_tmp103_ = g_new0 (gchar*, 2 + 1);
	_tmp103_[0] = _tmp101_;
	_tmp103_[1] = _tmp102_;
	_tmp104_ = _tmp103_;
	_tmp104__length1 = 2;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp100_, "view.hint", _tmp104_);
	_tmp104_ = (_vala_array_free (_tmp104_, _tmp104__length1, (GDestroyNotify) g_free), NULL);
	_tmp105_ = application;
	_tmp106_ = g_strdup ("<Alt>R");
	_tmp107_ = g_new0 (gchar*, 1 + 1);
	_tmp107_[0] = _tmp106_;
	_tmp108_ = _tmp107_;
	_tmp108__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp105_, "view.debug-row", _tmp108_);
	_tmp108_ = (_vala_array_free (_tmp108_, _tmp108__length1, (GDestroyNotify) g_free), NULL);
	_tmp109_ = application;
	_tmp110_ = g_strdup ("<Alt>C");
	_tmp111_ = g_new0 (gchar*, 1 + 1);
	_tmp111_[0] = _tmp110_;
	_tmp112_ = _tmp111_;
	_tmp112__length1 = 1;
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp109_, "view.debug-col", _tmp112_);
	_tmp112_ = (_vala_array_free (_tmp112_, _tmp112__length1, (GDestroyNotify) g_free), NULL);
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
	self->priv->drawing_with_state = GNONOGRAMS_CELL_STATE_UNDEFINED;
	_tmp113_ = gtk_css_provider_new ();
	provider = _tmp113_;
	{
		GtkCssProvider* _tmp114_;
		const gchar* _tmp115_;
		GdkScreen* _tmp116_;
		GtkCssProvider* _tmp117_;
		_tmp114_ = provider;
		_tmp115_ = self->priv->brand_stylesheet;
		gtk_css_provider_load_from_data (_tmp114_, _tmp115_, (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp116_ = gtk_window_get_screen ((GtkWindow*) self);
		_tmp117_ = provider;
		gtk_style_context_add_provider_for_screen (_tmp116_, (GtkStyleProvider*) _tmp117_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp118_;
		const gchar* _tmp119_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp118_ = e;
		_tmp119_ = _tmp118_->message;
		g_warning ("View.vala:229: Could not create CSS Provider: %s", _tmp119_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (provider);
		_g_object_unref0 (application);
		_g_object_unref0 (view_actions);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_tmp120_ = gtk_icon_theme_get_default ();
	default_theme = _tmp120_;
	_tmp121_ = default_theme;
	gtk_icon_theme_add_resource_path (_tmp121_, "/com/gnonograms/icons");
	_tmp122_ = (GtkHeaderBar*) gtk_header_bar_new ();
	g_object_ref_sink (_tmp122_);
	_g_object_unref0 (self->priv->header_bar);
	self->priv->header_bar = _tmp122_;
	_tmp123_ = self->priv->header_bar;
	_tmp124_ = gtk_widget_get_style_context ((GtkWidget*) _tmp123_);
	gtk_style_context_add_class (_tmp124_, "default-decoration");
	_tmp125_ = self->priv->header_bar;
	_tmp126_ = gtk_widget_get_style_context ((GtkWidget*) _tmp125_);
	gtk_style_context_add_class (_tmp126_, "headerbar");
	_tmp127_ = self->priv->header_bar;
	gtk_header_bar_set_has_subtitle (_tmp127_, FALSE);
	_tmp128_ = self->priv->header_bar;
	gtk_header_bar_set_show_close_button (_tmp128_, TRUE);
	_tmp129_ = gnonograms_header_button_new ("document-open", _ ("Load a Game from File"), TRUE);
	g_object_ref_sink (_tmp129_);
	_g_object_unref0 (self->priv->load_game_button);
	self->priv->load_game_button = (GtkButton*) _tmp129_;
	_tmp130_ = gnonograms_header_button_new ("document-save", _ ("Save Game"), TRUE);
	g_object_ref_sink (_tmp130_);
	_g_object_unref0 (self->priv->save_game_button);
	self->priv->save_game_button = (GtkButton*) _tmp130_;
	_tmp131_ = gnonograms_header_button_new ("document-save-as", _ ("Save Game to Different File"), TRUE);
	g_object_ref_sink (_tmp131_);
	_g_object_unref0 (self->priv->save_game_as_button);
	self->priv->save_game_as_button = (GtkButton*) _tmp131_;
	_tmp132_ = gnonograms_header_button_new ("edit-undo", _ ("Undo Last Move"), TRUE);
	g_object_ref_sink (_tmp132_);
	_g_object_unref0 (self->priv->undo_button);
	self->priv->undo_button = (GtkButton*) _tmp132_;
	_tmp133_ = self->priv->undo_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp133_, FALSE);
	_tmp134_ = gnonograms_header_button_new ("edit-redo", _ ("Redo Last Move"), TRUE);
	g_object_ref_sink (_tmp134_);
	_g_object_unref0 (self->priv->redo_button);
	self->priv->redo_button = (GtkButton*) _tmp134_;
	_tmp135_ = self->priv->redo_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp135_, FALSE);
	_tmp136_ = gnonograms_header_button_new ("media-seek-backward", _ ("Go Back to Last Correct Position"), TRUE);
	g_object_ref_sink (_tmp136_);
	_g_object_unref0 (self->priv->check_correct_button);
	self->priv->check_correct_button = (GtkButton*) _tmp136_;
	_tmp137_ = self->priv->check_correct_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp137_, FALSE);
	_tmp138_ = gnonograms_restart_button_new ("view-refresh", "", TRUE);
	g_object_ref_sink (_tmp138_);
	_g_object_unref0 (self->priv->restart_button);
	self->priv->restart_button = (GtkButton*) _tmp138_;
	_tmp139_ = gnonograms_header_button_new ("help-contents", _ ("Suggest next move"), TRUE);
	g_object_ref_sink (_tmp139_);
	_g_object_unref0 (self->priv->hint_button);
	self->priv->hint_button = (GtkButton*) _tmp139_;
	_tmp140_ = self->priv->hint_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp140_, FALSE);
	_tmp141_ = gnonograms_header_button_new ("system", _ ("Solve by Computer"), TRUE);
	g_object_ref_sink (_tmp141_);
	_g_object_unref0 (self->priv->auto_solve_button);
	self->priv->auto_solve_button = (GtkButton*) _tmp141_;
	_tmp142_ = self->priv->auto_solve_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp142_, FALSE);
	_tmp143_ = self->priv->_controller;
	_tmp144_ = gnonograms_app_menu_new (_tmp143_);
	g_object_ref_sink (_tmp144_);
	_g_object_unref0 (self->priv->app_menu);
	self->priv->app_menu = _tmp144_;
	_tmp145_ = gnonograms_view_mode_button_new ();
	g_object_ref_sink (_tmp145_);
	_g_object_unref0 (self->priv->mode_switch);
	self->priv->mode_switch = _tmp145_;
	_tmp146_ = self->priv->mode_switch;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp146_, 6);
	_tmp147_ = self->priv->mode_switch;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp147_, 6);
	_tmp148_ = self->priv->mode_switch;
	_tmp149_ = gtk_widget_get_style_context ((GtkWidget*) _tmp148_);
	gtk_style_context_add_class (_tmp149_, "mode-switch");
	_tmp150_ = gnonograms_progress_indicator_new ();
	g_object_ref_sink (_tmp150_);
	_g_object_unref0 (self->priv->progress_indicator);
	self->priv->progress_indicator = _tmp150_;
	_tmp151_ = self->priv->progress_indicator;
	_tmp152_ = gtk_widget_get_style_context ((GtkWidget*) _tmp151_);
	gtk_style_context_add_class (_tmp152_, "progress");
	_tmp153_ = (GtkLabel*) gtk_label_new ("Gnonograms");
	g_object_ref_sink (_tmp153_);
	_g_object_unref0 (self->priv->title_label);
	self->priv->title_label = _tmp153_;
	_tmp154_ = self->priv->title_label;
	_tmp155_ = gtk_widget_get_style_context ((GtkWidget*) _tmp154_);
	gtk_style_context_add_class (_tmp155_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp156_ = self->priv->title_label;
	_tmp157_ = gtk_widget_get_style_context ((GtkWidget*) _tmp156_);
	gtk_style_context_add_class (_tmp157_, "title");
	_tmp158_ = self->priv->title_label;
	gtk_widget_show ((GtkWidget*) _tmp158_);
	_tmp159_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp159_);
	_g_object_unref0 (self->priv->progress_stack);
	self->priv->progress_stack = _tmp159_;
	_tmp160_ = self->priv->progress_stack;
	_tmp161_ = self->priv->progress_indicator;
	gtk_stack_add_named (_tmp160_, (GtkWidget*) _tmp161_, "Progress");
	_tmp162_ = self->priv->progress_stack;
	_tmp163_ = self->priv->title_label;
	gtk_stack_add_named (_tmp162_, (GtkWidget*) _tmp163_, "Title");
	_tmp164_ = self->priv->progress_stack;
	gtk_stack_set_visible_child_name (_tmp164_, "Title");
	_tmp165_ = self->priv->progress_stack;
	gtk_widget_set_size_request ((GtkWidget*) _tmp165_, 150, -1);
	_tmp166_ = self->priv->header_bar;
	_tmp167_ = self->priv->load_game_button;
	gtk_header_bar_pack_start (_tmp166_, (GtkWidget*) _tmp167_);
	_tmp168_ = self->priv->header_bar;
	_tmp169_ = self->priv->save_game_button;
	gtk_header_bar_pack_start (_tmp168_, (GtkWidget*) _tmp169_);
	_tmp170_ = self->priv->header_bar;
	_tmp171_ = self->priv->save_game_as_button;
	gtk_header_bar_pack_start (_tmp170_, (GtkWidget*) _tmp171_);
	_tmp172_ = self->priv->header_bar;
	_tmp173_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp173_);
	_tmp174_ = _tmp173_;
	gtk_header_bar_pack_start (_tmp172_, (GtkWidget*) _tmp174_);
	_g_object_unref0 (_tmp174_);
	_tmp175_ = self->priv->header_bar;
	_tmp176_ = self->priv->restart_button;
	gtk_header_bar_pack_start (_tmp175_, (GtkWidget*) _tmp176_);
	_tmp177_ = self->priv->header_bar;
	_tmp178_ = self->priv->undo_button;
	gtk_header_bar_pack_start (_tmp177_, (GtkWidget*) _tmp178_);
	_tmp179_ = self->priv->header_bar;
	_tmp180_ = self->priv->redo_button;
	gtk_header_bar_pack_start (_tmp179_, (GtkWidget*) _tmp180_);
	_tmp181_ = self->priv->header_bar;
	_tmp182_ = self->priv->check_correct_button;
	gtk_header_bar_pack_start (_tmp181_, (GtkWidget*) _tmp182_);
	_tmp183_ = self->priv->header_bar;
	_tmp184_ = self->priv->app_menu;
	gtk_header_bar_pack_end (_tmp183_, (GtkWidget*) _tmp184_);
	_tmp185_ = self->priv->header_bar;
	_tmp186_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp186_);
	_tmp187_ = _tmp186_;
	gtk_header_bar_pack_end (_tmp185_, (GtkWidget*) _tmp187_);
	_g_object_unref0 (_tmp187_);
	_tmp188_ = self->priv->header_bar;
	_tmp189_ = self->priv->mode_switch;
	gtk_header_bar_pack_end (_tmp188_, (GtkWidget*) _tmp189_);
	_tmp190_ = self->priv->header_bar;
	_tmp191_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp191_);
	_tmp192_ = _tmp191_;
	gtk_header_bar_pack_end (_tmp190_, (GtkWidget*) _tmp192_);
	_g_object_unref0 (_tmp192_);
	_tmp193_ = self->priv->header_bar;
	_tmp194_ = self->priv->auto_solve_button;
	gtk_header_bar_pack_end (_tmp193_, (GtkWidget*) _tmp194_);
	_tmp195_ = self->priv->header_bar;
	_tmp196_ = self->priv->hint_button;
	gtk_header_bar_pack_end (_tmp195_, (GtkWidget*) _tmp196_);
	_tmp197_ = self->priv->header_bar;
	_tmp198_ = self->priv->progress_stack;
	gtk_header_bar_set_custom_title (_tmp197_, (GtkWidget*) _tmp198_);
	_tmp199_ = self->priv->header_bar;
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp199_);
	_tmp200_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp200_);
	_g_object_unref0 (self->priv->overlay);
	self->priv->overlay = _tmp200_;
	_tmp201_ = granite_widgets_toast_new ("");
	g_object_ref_sink (_tmp201_);
	_g_object_unref0 (self->priv->toast);
	self->priv->toast = _tmp201_;
	_tmp202_ = self->priv->toast;
	granite_widgets_toast_set_default_action (_tmp202_, NULL);
	_tmp203_ = self->priv->toast;
	gtk_widget_set_halign ((GtkWidget*) _tmp203_, GTK_ALIGN_START);
	_tmp204_ = self->priv->toast;
	gtk_widget_set_valign ((GtkWidget*) _tmp204_, GTK_ALIGN_START);
	_tmp205_ = self->priv->overlay;
	_tmp206_ = self->priv->toast;
	gtk_overlay_add_overlay (_tmp205_, (GtkWidget*) _tmp206_);
	_tmp207_ = gnonograms_label_box_new (GTK_ORIENTATION_VERTICAL);
	g_object_ref_sink (_tmp207_);
	_g_object_unref0 (self->priv->row_clue_box);
	self->priv->row_clue_box = _tmp207_;
	_tmp208_ = gnonograms_label_box_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp208_);
	_g_object_unref0 (self->priv->column_clue_box);
	self->priv->column_clue_box = _tmp208_;
	_tmp209_ = self->priv->_model;
	_tmp210_ = gnonograms_cell_grid_new (_tmp209_);
	g_object_ref_sink (_tmp210_);
	_g_object_unref0 (self->priv->cell_grid);
	self->priv->cell_grid = _tmp210_;
	_tmp211_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp211_);
	_g_object_unref0 (self->priv->main_grid);
	self->priv->main_grid = _tmp211_;
	_tmp212_ = self->priv->main_grid;
	_tmp213_ = self->priv->cell_grid;
	gtk_grid_attach (_tmp212_, (GtkWidget*) _tmp213_, 1, 1, 1, 1);
	_tmp214_ = self->priv->main_grid;
	gtk_grid_set_row_spacing (_tmp214_, 0);
	_tmp215_ = self->priv->main_grid;
	gtk_grid_set_column_spacing (_tmp215_, GNONOGRAMS_GRID_COLUMN_SPACING);
	_tmp216_ = self->priv->main_grid;
	gtk_container_set_border_width ((GtkContainer*) _tmp216_, (guint) GNONOGRAMS_GRID_BORDER);
	_tmp217_ = self->priv->main_grid;
	_tmp218_ = self->priv->row_clue_box;
	gtk_grid_attach (_tmp217_, (GtkWidget*) _tmp218_, 0, 1, 1, 1);
	_tmp219_ = self->priv->main_grid;
	_tmp220_ = self->priv->column_clue_box;
	gtk_grid_attach (_tmp219_, (GtkWidget*) _tmp220_, 1, 0, 1, 1);
	_tmp221_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp221_);
	ev = _tmp221_;
	_tmp222_ = ev;
	gtk_widget_add_events ((GtkWidget*) _tmp222_, (gint) GDK_SCROLL_MASK);
	_tmp223_ = ev;
	g_signal_connect_object ((GtkWidget*) _tmp223_, "scroll-event", (GCallback) _gnonograms_view_on_grid_scroll_event_gtk_widget_scroll_event, self, 0);
	_tmp224_ = ev;
	_tmp225_ = self->priv->main_grid;
	gtk_container_add ((GtkContainer*) _tmp224_, (GtkWidget*) _tmp225_);
	_tmp226_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp226_);
	sw = _tmp226_;
	_tmp227_ = sw;
	_tmp228_ = ev;
	gtk_container_add ((GtkContainer*) _tmp227_, (GtkWidget*) _tmp228_);
	_tmp229_ = self->priv->overlay;
	_tmp230_ = sw;
	gtk_container_add ((GtkContainer*) _tmp229_, (GtkWidget*) _tmp230_);
	_tmp231_ = self->priv->overlay;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp231_);
	_tmp232_ = self->priv->cell_grid;
	g_signal_connect_object ((GtkWidget*) _tmp232_, "leave-notify-event", (GCallback) _gnonograms_view_on_grid_leave_gtk_widget_leave_notify_event, self, 0);
	_tmp233_ = self->priv->cell_grid;
	g_signal_connect_object ((GtkWidget*) _tmp233_, "button-press-event", (GCallback) _gnonograms_view_on_grid_button_press_gtk_widget_button_press_event, self, 0);
	_tmp234_ = self->priv->cell_grid;
	g_signal_connect_object ((GtkWidget*) _tmp234_, "button-release-event", (GCallback) _gnonograms_view_stop_painting_gtk_widget_button_release_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) _gnonograms_view_on_key_release_event_gtk_widget_key_release_event, self, 0);
	_tmp235_ = self->priv->undo_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp235_, "view.undo");
	_tmp236_ = self->priv->redo_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp236_, "view.redo");
	_tmp237_ = self->priv->load_game_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp237_, "view.open");
	_tmp238_ = self->priv->save_game_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp238_, "view.save");
	_tmp239_ = self->priv->save_game_as_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp239_, "view.save-as");
	_tmp240_ = self->priv->check_correct_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp240_, "view.check-errors");
	_tmp241_ = self->priv->restart_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp241_, "view.restart");
	_tmp242_ = self->priv->hint_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp242_, "view.hint");
	_tmp243_ = self->priv->auto_solve_button;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp243_, "view.solve");
	flags = G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE;
	_tmp244_ = self->priv->restart_button;
	g_object_bind_property_with_closures ((GObject*) self, "restart-destructive", (GObject*) _tmp244_, "restart-destructive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp245_ = self->priv->app_menu;
	g_object_bind_property_with_closures ((GObject*) self, "dimensions", (GObject*) _tmp245_, "dimensions", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp246_ = self->priv->app_menu;
	g_object_bind_property_with_closures ((GObject*) self, "generator-grade", (GObject*) _tmp246_, "grade", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp247_ = self->priv->_controller;
	_tmp248_ = self->priv->app_menu;
	g_object_bind_property_with_closures ((GObject*) _tmp247_, "game-name", (GObject*) _tmp248_, "title", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp249_ = self->priv->app_menu;
	g_object_bind_property_with_closures ((GObject*) self, "strikeout-complete", (GObject*) _tmp249_, "strikeout-complete", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp250_ = self->priv->mode_switch;
	g_object_bind_property_with_closures ((GObject*) self, "game-state", (GObject*) _tmp250_, "mode", flags, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp251_ = self->priv->cell_grid;
	g_object_bind_property_with_closures ((GObject*) self, "current-cell", (GObject*) _tmp251_, "current-cell", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp252_ = self->priv->cell_grid;
	g_object_bind_property_with_closures ((GObject*) self, "previous-cell", (GObject*) _tmp252_, "previous-cell", G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp253_ = self->priv->row_clue_box;
	g_object_bind_property_with_closures ((GObject*) self, "fontheight", (GObject*) _tmp253_, "fontheight", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp254_ = self->priv->column_clue_box;
	g_object_bind_property_with_closures ((GObject*) self, "fontheight", (GObject*) _tmp254_, "fontheight", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp255_ = self->priv->row_clue_box;
	g_object_bind_property_with_closures ((GObject*) self, "dimensions", (GObject*) _tmp255_, "dimensions", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp256_ = self->priv->column_clue_box;
	g_object_bind_property_with_closures ((GObject*) self, "dimensions", (GObject*) _tmp256_, "dimensions", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	g_signal_connect_object ((GObject*) self, "notify::game-state", (GCallback) __gnonograms_view___lambda28__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::dimensions", (GCallback) __gnonograms_view___lambda29__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::generator-grade", (GCallback) __gnonograms_view___lambda30__g_object_notify, self, 0);
	_tmp257_ = self->priv->_controller;
	g_signal_connect_object ((GObject*) _tmp257_, "notify::game-name", (GCallback) __gnonograms_view___lambda31__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::readonly", (GCallback) __gnonograms_view___lambda32__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::can-go-back", (GCallback) __gnonograms_view___lambda33__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::can-go-forward", (GCallback) __gnonograms_view___lambda34__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::current-cell", (GCallback) __gnonograms_view___lambda35__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::strikeout-complete", (GCallback) __gnonograms_view___lambda36__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::fontheight", (GCallback) __gnonograms_view___lambda37__g_object_notify, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) _gnonograms_view_set_window_size_gtk_widget_realize, self, 0);
	_g_object_unref0 (sw);
	_g_object_unref0 (ev);
	_g_object_unref0 (provider);
	_g_object_unref0 (application);
	_g_object_unref0 (view_actions);
	return obj;
}

static void
gnonograms_view_class_init (GnonogramsViewClass * klass,
                            gpointer klass_data)
{
	gnonograms_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_MODEL_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_MODEL_PROPERTY] = g_param_spec_object ("model", "model", "model", GNONOGRAMS_TYPE_MODEL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CONTROLLER_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", GNONOGRAMS_TYPE_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_DIMENSIONS_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_DIMENSIONS_PROPERTY] = g_param_spec_boxed ("dimensions", "dimensions", "dimensions", GNONOGRAMS_TYPE_DIMENSIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY] = g_param_spec_enum ("generator-grade", "generator-grade", "generator-grade", GNONOGRAMS_TYPE_DIFFICULTY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_GAME_STATE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_GAME_STATE_PROPERTY] = g_param_spec_enum ("game-state", "game-state", "game-state", GNONOGRAMS_TYPE_GAME_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY] = g_param_spec_boolean ("strikeout-complete", "strikeout-complete", "strikeout-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_GAME_NAME_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_GAME_NAME_PROPERTY] = g_param_spec_string ("game-name", "game-name", "game-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_READONLY_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_READONLY_PROPERTY] = g_param_spec_boolean ("readonly", "readonly", "readonly", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY] = g_param_spec_enum ("game-grade", "game-grade", "game-grade", GNONOGRAMS_TYPE_DIFFICULTY, GNONOGRAMS_DIFFICULTY_UNDEFINED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_FONTHEIGHT_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_FONTHEIGHT_PROPERTY] = g_param_spec_double ("fontheight", "fontheight", "fontheight", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY] = g_param_spec_boolean ("can-go-back", "can-go-back", "can-go-back", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY] = g_param_spec_boolean ("can-go-forward", "can-go-forward", "can-go-forward", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY] = g_param_spec_boolean ("restart-destructive", "restart-destructive", "restart-destructive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY] = g_param_spec_boxed ("current-cell", "current-cell", "current-cell", GNONOGRAMS_TYPE_CELL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY, gnonograms_view_properties[GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY] = g_param_spec_boxed ("previous-cell", "previous-cell", "previous-cell", GNONOGRAMS_TYPE_CELL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**PUBLIC**/
	gnonograms_view_signals[GNONOGRAMS_VIEW_RANDOM_GAME_REQUEST_SIGNAL] = g_signal_new ("random-game-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_REWIND_REQUEST_SIGNAL] = g_signal_new ("rewind-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_UINT__VOID, G_TYPE_UINT, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_NEXT_MOVE_REQUEST_SIGNAL] = g_signal_new ("next-move-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__VOID, G_TYPE_BOOLEAN, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_PREVIOUS_MOVE_REQUEST_SIGNAL] = g_signal_new ("previous-move-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__VOID, G_TYPE_BOOLEAN, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_SAVE_GAME_REQUEST_SIGNAL] = g_signal_new ("save-game-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_SAVE_GAME_AS_REQUEST_SIGNAL] = g_signal_new ("save-game-as-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_OPEN_GAME_REQUEST_SIGNAL] = g_signal_new ("open-game-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_SOLVE_THIS_REQUEST_SIGNAL] = g_signal_new ("solve-this-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_RESTART_REQUEST_SIGNAL] = g_signal_new ("restart-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_HINT_REQUEST_SIGNAL] = g_signal_new ("hint-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gnonograms_view_signals[GNONOGRAMS_VIEW_DEBUG_REQUEST_SIGNAL] = g_signal_new ("debug-request", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_BOOLEAN);
	gnonograms_view_signals[GNONOGRAMS_VIEW_CHANGED_CELL_SIGNAL] = g_signal_new ("changed-cell", GNONOGRAMS_TYPE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_ENUM, G_TYPE_NONE, 2, GNONOGRAMS_TYPE_CELL, GNONOGRAMS_TYPE_CELL_STATE);
}

static void
gnonograms_view_instance_init (GnonogramsView * self,
                               gpointer klass)
{
	gchar* _tmp0_;
	self->priv = gnonograms_view_get_instance_private (self);
	self->priv->_readonly = FALSE;
	self->priv->_game_grade = GNONOGRAMS_DIFFICULTY_UNDEFINED;
	self->priv->_restart_destructive = FALSE;
	_tmp0_ = g_strdup_printf ("\n" \
"        @define-color textColorPrimary %s;\n" \
"        @define-color textColorPrimaryShadow %s;\n" \
"        @define-color colorPrimary %s;\n" \
"        @define-color colorDarkBackground %s;\n" \
"        @define-color colorPaleBackground %s;\n" \
"\n" \
"        .linked .toggle {\n" \
"            background-color: shade (@textColorPrimary, 0.6);\n" \
"            border-radius: 6px 6px 6px 6px;\n" \
"            border-width: 1px;\n" \
"            border-color: #000;\n" \
"        }\n" \
"\n" \
"        .linked .toggle:checked {\n" \
"            border-color: #FFF;\n" \
"            border-width: 1px;\n" \
"            border-radius: 4px 4px 4px 4px;\n" \
"            background-color: @colorPaleBackground;\n" \
"        }\n" \
"\n" \
"        .headerbutton {\n" \
"            border-radius: 12px 12px 12px 12px;\n" \
"            background-color: alpha (#FFF, 0.75);\n" \
"        }\n" \
"\n" \
"        .title {\n" \
"            border-radius: 12px 12px 12px 12px;\n" \
"            background-color: alpha (#FFF, 0.75);\n" \
"            color: @textColorPrimaryShadow;\n" \
"        }\n" \
"\n" \
"        *.label:selected {\n" \
"            background-color: @colorPaleBackground;\n" \
"        }\n" \
"\n" \
"        *.dim {\n" \
"            color: shade (@textColorPrimary, 0.6);\n" \
"        }\n" \
"\n" \
"        .tooltip {\n" \
"            background-color: @colorPrimary;\n" \
"            border-radius: 4px 4px 4px 4px;\n" \
"        }\n" \
"\n" \
"        .progress  {\n" \
"            opacity: 1.0;\n" \
"            color: @textColorPrimary;\n" \
"            font-weight: bold\n" \
"        }\n" \
"\n" \
"        .warn {\n" \
"          color:  @error_color;\n" \
"        }\n" \
"\n" \
"        separator.vertical {\n" \
"            margin: 2px;\n" \
"        }\n" \
"\n" \
"    ", GNONOGRAMS_PALE_TEXT, GNONOGRAMS_DARK_SHADOW, GNONOGRAMS_GNONOGRAMS_DARK_PURPLE, GNONOGRAMS_GNONOGRAMS_DARK_PURPLE, GNONOGRAMS_GNONOGRAMS_PALE_PURPLE);
	self->priv->brand_stylesheet = _tmp0_;
	self->priv->progress_timeout_id = (guint) 0;
}

static void
gnonograms_view_finalize (GObject * obj)
{
	GnonogramsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_VIEW, GnonogramsView);
	_g_object_unref0 (self->priv->_model);
	_g_free0 (self->priv->brand_stylesheet);
	_g_object_unref0 (self->priv->row_clue_box);
	_g_object_unref0 (self->priv->column_clue_box);
	_g_object_unref0 (self->priv->cell_grid);
	_g_object_unref0 (self->priv->header_bar);
	_g_object_unref0 (self->priv->app_menu);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->overlay);
	_g_object_unref0 (self->priv->progress_indicator);
	_g_object_unref0 (self->priv->progress_stack);
	_g_object_unref0 (self->priv->title_label);
	_g_object_unref0 (self->priv->toast);
	_g_object_unref0 (self->priv->mode_switch);
	_g_object_unref0 (self->priv->load_game_button);
	_g_object_unref0 (self->priv->save_game_button);
	_g_object_unref0 (self->priv->save_game_as_button);
	_g_object_unref0 (self->priv->undo_button);
	_g_object_unref0 (self->priv->redo_button);
	_g_object_unref0 (self->priv->check_correct_button);
	_g_object_unref0 (self->priv->hint_button);
	_g_object_unref0 (self->priv->auto_solve_button);
	_g_object_unref0 (self->priv->restart_button);
	G_OBJECT_CLASS (gnonograms_view_parent_class)->finalize (obj);
}

/*** The View class manages the header, clue label widgets and the drawing widget under instruction
   * from the controller. It signals user interaction to the controller.
***/
static GType
gnonograms_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsView), 0, (GInstanceInitFunc) gnonograms_view_instance_init, NULL };
	GType gnonograms_view_type_id;
	gnonograms_view_type_id = g_type_register_static (gtk_application_window_get_type (), "GnonogramsView", &g_define_type_info, 0);
	GnonogramsView_private_offset = g_type_add_instance_private (gnonograms_view_type_id, sizeof (GnonogramsViewPrivate));
	return gnonograms_view_type_id;
}

GType
gnonograms_view_get_type (void)
{
	static volatile gsize gnonograms_view_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_view_type_id__volatile)) {
		GType gnonograms_view_type_id;
		gnonograms_view_type_id = gnonograms_view_get_type_once ();
		g_once_init_leave (&gnonograms_view_type_id__volatile, gnonograms_view_type_id);
	}
	return gnonograms_view_type_id__volatile;
}

static void
_vala_gnonograms_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	GnonogramsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_VIEW, GnonogramsView);
	switch (property_id) {
		case GNONOGRAMS_VIEW_MODEL_PROPERTY:
		g_value_set_object (value, gnonograms_view_get_model (self));
		break;
		case GNONOGRAMS_VIEW_CONTROLLER_PROPERTY:
		g_value_set_object (value, gnonograms_view_get_controller (self));
		break;
		case GNONOGRAMS_VIEW_DIMENSIONS_PROPERTY:
		{
			GnonogramsDimensions boxed;
			gnonograms_view_get_dimensions (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY:
		g_value_set_enum (value, gnonograms_view_get_generator_grade (self));
		break;
		case GNONOGRAMS_VIEW_GAME_STATE_PROPERTY:
		g_value_set_enum (value, gnonograms_view_get_game_state (self));
		break;
		case GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_strikeout_complete (self));
		break;
		case GNONOGRAMS_VIEW_GAME_NAME_PROPERTY:
		g_value_set_string (value, gnonograms_view_get_game_name (self));
		break;
		case GNONOGRAMS_VIEW_READONLY_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_readonly (self));
		break;
		case GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY:
		g_value_set_enum (value, gnonograms_view_get_game_grade (self));
		break;
		case GNONOGRAMS_VIEW_FONTHEIGHT_PROPERTY:
		g_value_set_double (value, gnonograms_view_get_fontheight (self));
		break;
		case GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_can_go_back (self));
		break;
		case GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_can_go_forward (self));
		break;
		case GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY:
		g_value_set_boolean (value, gnonograms_view_get_restart_destructive (self));
		break;
		case GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY:
		{
			GnonogramsCell boxed;
			gnonograms_view_get_current_cell (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY:
		{
			GnonogramsCell boxed;
			gnonograms_view_get_previous_cell (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	GnonogramsView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_VIEW, GnonogramsView);
	switch (property_id) {
		case GNONOGRAMS_VIEW_MODEL_PROPERTY:
		gnonograms_view_set_model (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_VIEW_CONTROLLER_PROPERTY:
		gnonograms_view_set_controller (self, g_value_get_object (value));
		break;
		case GNONOGRAMS_VIEW_DIMENSIONS_PROPERTY:
		gnonograms_view_set_dimensions (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_VIEW_GENERATOR_GRADE_PROPERTY:
		gnonograms_view_set_generator_grade (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_VIEW_GAME_STATE_PROPERTY:
		gnonograms_view_set_game_state (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_VIEW_STRIKEOUT_COMPLETE_PROPERTY:
		gnonograms_view_set_strikeout_complete (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_READONLY_PROPERTY:
		gnonograms_view_set_readonly (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_GAME_GRADE_PROPERTY:
		gnonograms_view_set_game_grade (self, g_value_get_enum (value));
		break;
		case GNONOGRAMS_VIEW_FONTHEIGHT_PROPERTY:
		gnonograms_view_set_fontheight (self, g_value_get_double (value));
		break;
		case GNONOGRAMS_VIEW_CAN_GO_BACK_PROPERTY:
		gnonograms_view_set_can_go_back (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_CAN_GO_FORWARD_PROPERTY:
		gnonograms_view_set_can_go_forward (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_RESTART_DESTRUCTIVE_PROPERTY:
		gnonograms_view_set_restart_destructive (self, g_value_get_boolean (value));
		break;
		case GNONOGRAMS_VIEW_CURRENT_CELL_PROPERTY:
		gnonograms_view_set_current_cell (self, g_value_get_boxed (value));
		break;
		case GNONOGRAMS_VIEW_PREVIOUS_CELL_PROPERTY:
		gnonograms_view_set_previous_cell (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
gnonograms_restart_button_get_instance_private (GnonogramsRestartButton* self)
{
	return G_STRUCT_MEMBER_P (self, GnonogramsRestartButton_private_offset);
}

GnonogramsRestartButton*
gnonograms_restart_button_construct (GType object_type,
                                     const gchar* icon_name,
                                     const gchar* tooltip,
                                     gboolean sensitive)
{
	GnonogramsRestartButton * self = NULL;
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (tooltip != NULL, NULL);
	self = (GnonogramsRestartButton*) gnonograms_header_button_construct (object_type, icon_name, tooltip, sensitive);
	return self;
}

GnonogramsRestartButton*
gnonograms_restart_button_new (const gchar* icon_name,
                               const gchar* tooltip,
                               gboolean sensitive)
{
	return gnonograms_restart_button_construct (GNONOGRAMS_TYPE_RESTART_BUTTON, icon_name, tooltip, sensitive);
}

gboolean
gnonograms_restart_button_get_restart_destructive (GnonogramsRestartButton* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_restart_destructive;
	return result;
}

void
gnonograms_restart_button_set_restart_destructive (GnonogramsRestartButton* self,
                                                   gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = gnonograms_restart_button_get_restart_destructive (self);
	if (old_value != value) {
		self->priv->_restart_destructive = value;
		g_object_notify_by_pspec ((GObject *) self, gnonograms_restart_button_properties[GNONOGRAMS_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY]);
	}
}

static void
_gnonograms_restart_button___lambda27_ (GnonogramsRestartButton* self)
{
	gboolean _tmp0_;
	_tmp0_ = self->priv->_restart_destructive;
	if (_tmp0_) {
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		GtkStyleContext* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		GtkStyleContext* _tmp6_;
		_tmp1_ = gtk_button_get_image ((GtkButton*) self);
		_tmp2_ = _tmp1_;
		_tmp3_ = gtk_widget_get_style_context (_tmp2_);
		gtk_style_context_add_class (_tmp3_, "warn");
		_tmp4_ = gtk_button_get_image ((GtkButton*) self);
		_tmp5_ = _tmp4_;
		_tmp6_ = gtk_widget_get_style_context (_tmp5_);
		gtk_style_context_remove_class (_tmp6_, "dim");
	} else {
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		GtkStyleContext* _tmp9_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
		GtkStyleContext* _tmp12_;
		_tmp7_ = gtk_button_get_image ((GtkButton*) self);
		_tmp8_ = _tmp7_;
		_tmp9_ = gtk_widget_get_style_context (_tmp8_);
		gtk_style_context_remove_class (_tmp9_, "warn");
		_tmp10_ = gtk_button_get_image ((GtkButton*) self);
		_tmp11_ = _tmp10_;
		_tmp12_ = gtk_widget_get_style_context (_tmp11_);
		gtk_style_context_add_class (_tmp12_, "dim");
	}
}

static void
__gnonograms_restart_button___lambda27__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	_gnonograms_restart_button___lambda27_ ((GnonogramsRestartButton*) self);
}

static GObject *
gnonograms_restart_button_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsRestartButton * self;
	parent_class = G_OBJECT_CLASS (gnonograms_restart_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_RESTART_BUTTON, GnonogramsRestartButton);
	gnonograms_restart_button_set_restart_destructive (self, FALSE);
	g_signal_connect_object ((GObject*) self, "notify::restart-destructive", (GCallback) __gnonograms_restart_button___lambda27__g_object_notify, self, 0);
	g_object_bind_property_with_closures ((GObject*) self, "sensitive", (GObject*) self, "restart-destructive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	return obj;
}

static void
gnonograms_restart_button_class_init (GnonogramsRestartButtonClass * klass,
                                      gpointer klass_data)
{
	gnonograms_restart_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnonogramsRestartButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gnonograms_restart_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnonograms_restart_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = gnonograms_restart_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnonograms_restart_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNONOGRAMS_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY, gnonograms_restart_button_properties[GNONOGRAMS_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY] = g_param_spec_boolean ("restart-destructive", "restart-destructive", "restart-destructive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
gnonograms_restart_button_instance_init (GnonogramsRestartButton * self,
                                         gpointer klass)
{
	self->priv = gnonograms_restart_button_get_instance_private (self);
}

static void
gnonograms_restart_button_finalize (GObject * obj)
{
	GnonogramsRestartButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_RESTART_BUTTON, GnonogramsRestartButton);
	G_OBJECT_CLASS (gnonograms_restart_button_parent_class)->finalize (obj);
}

static GType
gnonograms_restart_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsRestartButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_restart_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsRestartButton), 0, (GInstanceInitFunc) gnonograms_restart_button_instance_init, NULL };
	GType gnonograms_restart_button_type_id;
	gnonograms_restart_button_type_id = g_type_register_static (GNONOGRAMS_TYPE_HEADER_BUTTON, "GnonogramsRestartButton", &g_define_type_info, 0);
	GnonogramsRestartButton_private_offset = g_type_add_instance_private (gnonograms_restart_button_type_id, sizeof (GnonogramsRestartButtonPrivate));
	return gnonograms_restart_button_type_id;
}

GType
gnonograms_restart_button_get_type (void)
{
	static volatile gsize gnonograms_restart_button_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_restart_button_type_id__volatile)) {
		GType gnonograms_restart_button_type_id;
		gnonograms_restart_button_type_id = gnonograms_restart_button_get_type_once ();
		g_once_init_leave (&gnonograms_restart_button_type_id__volatile, gnonograms_restart_button_type_id);
	}
	return gnonograms_restart_button_type_id__volatile;
}

static void
_vala_gnonograms_restart_button_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	GnonogramsRestartButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_RESTART_BUTTON, GnonogramsRestartButton);
	switch (property_id) {
		case GNONOGRAMS_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY:
		g_value_set_boolean (value, gnonograms_restart_button_get_restart_destructive (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gnonograms_restart_button_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	GnonogramsRestartButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNONOGRAMS_TYPE_RESTART_BUTTON, GnonogramsRestartButton);
	switch (property_id) {
		case GNONOGRAMS_RESTART_BUTTON_RESTART_DESTRUCTIVE_PROPERTY:
		gnonograms_restart_button_set_restart_destructive (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

GnonogramsHeaderButton*
gnonograms_header_button_construct (GType object_type,
                                    const gchar* icon_name,
                                    const gchar* tooltip,
                                    gboolean sensitive)
{
	GnonogramsHeaderButton * self = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (tooltip != NULL, NULL);
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp0_);
	_tmp1_ = _tmp0_;
	self = (GnonogramsHeaderButton*) g_object_new (object_type, "image", _tmp1_, "tooltip-text", tooltip, "sensitive", sensitive, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

GnonogramsHeaderButton*
gnonograms_header_button_new (const gchar* icon_name,
                              const gchar* tooltip,
                              gboolean sensitive)
{
	return gnonograms_header_button_construct (GNONOGRAMS_TYPE_HEADER_BUTTON, icon_name, tooltip, sensitive);
}

static GObject *
gnonograms_header_button_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GnonogramsHeaderButton * self;
	GtkStyleContext* _tmp0_;
	parent_class = G_OBJECT_CLASS (gnonograms_header_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNONOGRAMS_TYPE_HEADER_BUTTON, GnonogramsHeaderButton);
	gtk_widget_set_margin_top ((GtkWidget*) self, 3);
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 3);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "headerbutton");
	return obj;
}

static void
gnonograms_header_button_class_init (GnonogramsHeaderButtonClass * klass,
                                     gpointer klass_data)
{
	gnonograms_header_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = gnonograms_header_button_constructor;
}

static void
gnonograms_header_button_instance_init (GnonogramsHeaderButton * self,
                                        gpointer klass)
{
}

static GType
gnonograms_header_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnonogramsHeaderButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnonograms_header_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnonogramsHeaderButton), 0, (GInstanceInitFunc) gnonograms_header_button_instance_init, NULL };
	GType gnonograms_header_button_type_id;
	gnonograms_header_button_type_id = g_type_register_static (gtk_button_get_type (), "GnonogramsHeaderButton", &g_define_type_info, 0);
	return gnonograms_header_button_type_id;
}

GType
gnonograms_header_button_get_type (void)
{
	static volatile gsize gnonograms_header_button_type_id__volatile = 0;
	if (g_once_init_enter (&gnonograms_header_button_type_id__volatile)) {
		GType gnonograms_header_button_type_id;
		gnonograms_header_button_type_id = gnonograms_header_button_get_type_once ();
		g_once_init_leave (&gnonograms_header_button_type_id__volatile, gnonograms_header_button_type_id);
	}
	return gnonograms_header_button_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

